// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.4.2
//
// <auto-generated>
//
// Generated from file `IdentitySetPrx.java'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Glacier2;

/**
 * An object for managing the set of object identity constraints on a
 * {@link Session}. 
 * 
 * @see Session
 * @see SessionControl
 * 
 **/
public interface IdentitySetPrx extends Ice.ObjectPrx
{
    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     **/
    public void add(Ice.Identity[] additions);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void add(Ice.Identity[] additions, java.util.Map<String, String> __ctx);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> __ctx);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, Ice.Callback __cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, Callback_IdentitySet_add __cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param additions The sequence of Ice identities to be added.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> __ctx, Callback_IdentitySet_add __cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_add(Ice.AsyncResult __result);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     **/
    public void remove(Ice.Identity[] deletions);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void remove(Ice.Identity[] deletions, java.util.Map<String, String> __ctx);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> __ctx);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, Ice.Callback __cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, Callback_IdentitySet_remove __cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param deletions The sequence of Ice identities to be removed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> __ctx, Callback_IdentitySet_remove __cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_remove(Ice.AsyncResult __result);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @return The sequence of Ice identities for this set. 
     * 
     **/
    public Ice.Identity[] get();

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The sequence of Ice identities for this set. 
     * 
     **/
    public Ice.Identity[] get(java.util.Map<String, String> __ctx);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get();

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> __ctx);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(Ice.Callback __cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(Callback_IdentitySet_get __cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> __ctx, Callback_IdentitySet_get __cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     * 
     * @param __result The asynchronous result object.
     * @return The sequence of Ice identities for this set. 
     * 
     **/
    public Ice.Identity[] end_get(Ice.AsyncResult __result);
}
