// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.4.2
//
// <auto-generated>
//
// Generated from file `RequestFailedException.java'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Ice;

/**
 * This exception is raised if a request failed. This exception, and
 * all exceptions derived from {@link RequestFailedException}, are
 * transmitted by the Ice protocol, even though they are declared
 * <tt>local</tt>.
 * 
 **/
public class RequestFailedException extends Ice.LocalException
{
    public RequestFailedException()
    {
    }

    public RequestFailedException(Throwable cause)
    {
        super(cause);
    }

    public RequestFailedException(Identity id, String facet, String operation)
    {
        this.id = id;
        this.facet = facet;
        this.operation = operation;
    }

    public RequestFailedException(Identity id, String facet, String operation, Throwable cause)
    {
        super(cause);
        this.id = id;
        this.facet = facet;
        this.operation = operation;
    }

    public String
    ice_name()
    {
        return "Ice::RequestFailedException";
    }

    /**
     * The identity of the Ice Object to which the request was sent.
     **/
    public Identity id;

    /**
     * The facet to which the request was sent.
     **/
    public String facet;

    /**
     * The operation name of the request.
     **/
    public String operation;
}
