

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

@javax.persistence.Entity
@javax.persistence.PrimaryKeyJoinColumn(name="lightsource_id")
@javax.persistence.Table(name = "laser")
@org.hibernate.annotations.ForeignKey(name="FKlaser_lightsource_id_lightsource")
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
@org.hibernate.annotations.Check(constraints="frequencyMultiplication > 0 and wavelength > 0")
public  class Laser
extends ome.model.acquisition.LightSource implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "laser_owner_filter";
    public final static String GROUP_FILTER = "laser_group_filter";
    public final static String EVENT_FILTER = "laser_event_filter";
    public final static String PERMS_FILTER = "laser_perms_filter";

    public Laser () {
        this(null, true);
    }

    protected Laser (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Laser (Long id, boolean loaded) {
        super(id, loaded);
    }


    public Laser(
ome.model.enums.LaserType _type,ome.model.enums.LaserMedium _laserMedium    ) {
        this(null, true);
        setType(_type);
        setLaserMedium(_laserMedium);
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.enums.LaserType type = null;

   /**
    * Many-to-one field ome.model.acquisition.Laser.type (ome.model.enums.LaserType)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.LaserType.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="type", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlaser_type_lasertype")
    public ome.model.enums.LaserType getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(ome.model.enums.LaserType type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = type;
    }
    protected ome.model.enums.LaserMedium laserMedium = null;

   /**
    * Many-to-one field ome.model.acquisition.Laser.laserMedium (ome.model.enums.LaserMedium)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.LaserMedium.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="laserMedium", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlaser_laserMedium_lasermedium")
    public ome.model.enums.LaserMedium getLaserMedium() {
        if (! _loaded ) errorIfUnloaded();
        return this.laserMedium;
    }

    public void setLaserMedium(ome.model.enums.LaserMedium laserMedium) {
        if (! _loaded ) errorIfUnloaded();
        this.laserMedium = laserMedium;
    }
    protected java.lang.Integer frequencyMultiplication = null;

   /**
    * Simple field ome.model.acquisition.Laser.frequencyMultiplication (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="frequencyMultiplication", updatable=true)
    public java.lang.Integer getFrequencyMultiplication() {
        if (! _loaded ) errorIfUnloaded();
        return this.frequencyMultiplication;
    }

    public void setFrequencyMultiplication(java.lang.Integer frequencyMultiplication) {
        if (! _loaded ) errorIfUnloaded();
        this.frequencyMultiplication = (java.lang.Integer) frequencyMultiplication;
    }
    protected java.lang.Boolean tuneable = null;

   /**
    * Simple field ome.model.acquisition.Laser.tuneable (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="tuneable", updatable=true)
    public java.lang.Boolean getTuneable() {
        if (! _loaded ) errorIfUnloaded();
        return this.tuneable;
    }

    public void setTuneable(java.lang.Boolean tuneable) {
        if (! _loaded ) errorIfUnloaded();
        this.tuneable = (java.lang.Boolean) tuneable;
    }
    protected ome.model.enums.Pulse pulse = null;

   /**
    * Many-to-one field ome.model.acquisition.Laser.pulse (ome.model.enums.Pulse)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Pulse.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="pulse", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlaser_pulse_pulse")
    public ome.model.enums.Pulse getPulse() {
        if (! _loaded ) errorIfUnloaded();
        return this.pulse;
    }

    public void setPulse(ome.model.enums.Pulse pulse) {
        if (! _loaded ) errorIfUnloaded();
        this.pulse = pulse;
    }
    protected java.lang.Integer wavelength = null;

   /**
    * Simple field ome.model.acquisition.Laser.wavelength (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="wavelength", updatable=true)
    public java.lang.Integer getWavelength() {
        if (! _loaded ) errorIfUnloaded();
        return this.wavelength;
    }

    public void setWavelength(java.lang.Integer wavelength) {
        if (! _loaded ) errorIfUnloaded();
        this.wavelength = (java.lang.Integer) wavelength;
    }
    protected java.lang.Boolean pockelCell = null;

   /**
    * Simple field ome.model.acquisition.Laser.pockelCell (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="pockelCell", updatable=true)
    public java.lang.Boolean getPockelCell() {
        if (! _loaded ) errorIfUnloaded();
        return this.pockelCell;
    }

    public void setPockelCell(java.lang.Boolean pockelCell) {
        if (! _loaded ) errorIfUnloaded();
        this.pockelCell = (java.lang.Boolean) pockelCell;
    }
    protected ome.model.acquisition.LightSource pump = null;

   /**
    * Many-to-one field ome.model.acquisition.Laser.pump (ome.model.acquisition.LightSource)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.LightSource.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="pump", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlaser_pump_lightsource")
    public ome.model.acquisition.LightSource getPump() {
        if (! _loaded ) errorIfUnloaded();
        return this.pump;
    }

    public void setPump(ome.model.acquisition.LightSource pump) {
        if (! _loaded ) errorIfUnloaded();
        this.pump = pump;
    }
    protected java.lang.Double repetitionRate = null;

   /**
    * Simple field ome.model.acquisition.Laser.repetitionRate (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="repetitionRate", updatable=true)
    public java.lang.Double getRepetitionRate() {
        if (! _loaded ) errorIfUnloaded();
        return this.repetitionRate;
    }

    public void setRepetitionRate(java.lang.Double repetitionRate) {
        if (! _loaded ) errorIfUnloaded();
        this.repetitionRate = (java.lang.Double) repetitionRate;
    }

    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.Laser newInstance() 
    {
        return new ome.model.acquisition.Laser();
    }

    public ome.model.acquisition.Laser proxy() {
        return new ome.model.acquisition.Laser(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.type = (ome.model.enums.LaserType) __filter.filter(TYPE, this.type );
            this.laserMedium = (ome.model.enums.LaserMedium) __filter.filter(LASERMEDIUM, this.laserMedium );
            this.frequencyMultiplication = (java.lang.Integer) __filter.filter(FREQUENCYMULTIPLICATION, this.frequencyMultiplication );
            this.tuneable = (java.lang.Boolean) __filter.filter(TUNEABLE, this.tuneable );
            this.pulse = (ome.model.enums.Pulse) __filter.filter(PULSE, this.pulse );
            this.wavelength = (java.lang.Integer) __filter.filter(WAVELENGTH, this.wavelength );
            this.pockelCell = (java.lang.Boolean) __filter.filter(POCKELCELL, this.pockelCell );
            this.pump = (ome.model.acquisition.LightSource) __filter.filter(PUMP, this.pump );
            this.repetitionRate = (java.lang.Double) __filter.filter(REPETITIONRATE, this.repetitionRate );
            return super.acceptFilter(__filter);
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.acquisition.Laser.FIELDS;
    }
  
    public final static String TYPE = "ome.model.acquisition.Laser_type";
    public final static String LASERMEDIUM = "ome.model.acquisition.Laser_laserMedium";
    public final static String FREQUENCYMULTIPLICATION = "ome.model.acquisition.Laser_frequencyMultiplication";
    public final static String TUNEABLE = "ome.model.acquisition.Laser_tuneable";
    public final static String PULSE = "ome.model.acquisition.Laser_pulse";
    public final static String WAVELENGTH = "ome.model.acquisition.Laser_wavelength";
    public final static String POCKELCELL = "ome.model.acquisition.Laser_pockelCell";
    public final static String PUMP = "ome.model.acquisition.Laser_pump";
    public final static String REPETITIONRATE = "ome.model.acquisition.Laser_repetitionRate";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(TYPE);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(LASERMEDIUM);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(FREQUENCYMULTIPLICATION);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(TUNEABLE);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(PULSE);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(WAVELENGTH);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(POCKELCELL);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(PUMP);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       raw.add(REPETITIONRATE);
       raw.addAll(ome.model.acquisition.LightSource.FIELDS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(TYPE)) { // TODO use == here first??
            return getType();
        } else if (field.equals(LASERMEDIUM)) { // TODO use == here first??
            return getLaserMedium();
        } else if (field.equals(FREQUENCYMULTIPLICATION)) { // TODO use == here first??
            return getFrequencyMultiplication();
        } else if (field.equals(TUNEABLE)) { // TODO use == here first??
            return getTuneable();
        } else if (field.equals(PULSE)) { // TODO use == here first??
            return getPulse();
        } else if (field.equals(WAVELENGTH)) { // TODO use == here first??
            return getWavelength();
        } else if (field.equals(POCKELCELL)) { // TODO use == here first??
            return getPockelCell();
        } else if (field.equals(PUMP)) { // TODO use == here first??
            return getPump();
        } else if (field.equals(REPETITIONRATE)) { // TODO use == here first??
            return getRepetitionRate();
        } else {
            return super.retrieve(field);
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(TYPE)) {
            setType((ome.model.enums.LaserType)value);
        } else if (field.equals(LASERMEDIUM)) {
            setLaserMedium((ome.model.enums.LaserMedium)value);
        } else if (field.equals(FREQUENCYMULTIPLICATION)) {
            setFrequencyMultiplication((java.lang.Integer)value);
        } else if (field.equals(TUNEABLE)) {
            setTuneable((java.lang.Boolean)value);
        } else if (field.equals(PULSE)) {
            setPulse((ome.model.enums.Pulse)value);
        } else if (field.equals(WAVELENGTH)) {
            setWavelength((java.lang.Integer)value);
        } else if (field.equals(POCKELCELL)) {
            setPockelCell((java.lang.Boolean)value);
        } else if (field.equals(PUMP)) {
            setPump((ome.model.acquisition.LightSource)value);
        } else if (field.equals(REPETITIONRATE)) {
            setRepetitionRate((java.lang.Double)value);
        } else {
            super.putAt(field,value);
        }
    }


    public void unload() {
        _loaded = false;
        this.type = null;
        this.laserMedium = null;
        this.frequencyMultiplication = null;
        this.tuneable = null;
        this.pulse = null;
        this.wavelength = null;
        this.pockelCell = null;
        this.pump = null;
        this.repetitionRate = null;
        super.unload();
    }




    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


}
