

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="lightpath_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_owner_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_group_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_event_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_perms_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="lightpath_owner_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_group_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_event_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="lightpath_perms_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="lightpath_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="lightpath_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="lightpath_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="lightpath_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "lightpath", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_lightpath",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_lightpath"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class LightPath
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "lightpath_owner_filter";
    public final static String GROUP_FILTER = "lightpath_group_filter";
    public final static String EVENT_FILTER = "lightpath_event_filter";
    public final static String PERMS_FILTER = "lightpath_perms_filter";

    public LightPath () {
        this(null, true);
    }

    protected LightPath (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public LightPath (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }



    public final static String ID = "ome.model.acquisition.LightPath_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_lightpath") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.acquisition.LightPath_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.util.List<ome.model.acquisition.LightPathExcitationFilterLink> excitationFilterLink = new java.util.ArrayList<ome.model.acquisition.LightPathExcitationFilterLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_EXCITATIONFILTERLINK = "lightpath_owner_filter_EXCITATIONFILTERLINK";
    public final static String GROUP_FILTER_EXCITATIONFILTERLINK = "lightpath_group_filter_EXCITATIONFILTERLINK";
    public final static String EVENT_FILTER_EXCITATIONFILTERLINK = "lightpath_event_filter_EXCITATIONFILTERLINK";
    public final static String PERMS_FILTER_EXCITATIONFILTERLINK = "lightpath_perms_filter_EXCITATIONFILTERLINK";

   /**
    * returns excitationFilterLink . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.acquisition.LightPath.excitationFilterLink (ome.model.acquisition.LightPathExcitationFilterLink)
    * Values are indexed by the column "index" on ome.model.acquisition.LightPathExcitationFilterLink
    */
    @javax.persistence.JoinColumn(name="parent", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="parent_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_EXCITATIONFILTERLINK, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_EXCITATIONFILTERLINK, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_EXCITATIONFILTERLINK, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_EXCITATIONFILTERLINK, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.acquisition.LightPathExcitationFilterLink> getExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.excitationFilterLink;
    }

    /**
     * setter for excitationFilterLink should be avoided. Does not fulfill normal semantics.
     */
    protected void setExcitationFilterLink(java.util.List<ome.model.acquisition.LightPathExcitationFilterLink> excitationFilterLink) {
        if (! _loaded ) errorIfUnloaded();
        this.excitationFilterLink = excitationFilterLink;
    }
    /**
     * returns the size of excitationFilterLink. If less than zero, the Set was null.
     */
    public int sizeOfExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.excitationFilterLink == null ? -1 : this.excitationFilterLink.size();
    }

    /**
     * should be used rather than accessing the excitationFilterLink set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfExcitationFilterLink()} is less than zero.
     */
    public java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> iterateExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.LightPathExcitationFilterLink>();
        }
        return getExcitationFilterLink().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.acquisition.LightPathExcitationFilterLink> unmodifiableExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getExcitationFilterLink() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.LightPathExcitationFilterLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateExcitationFilterLink} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectExcitationFilterLink(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = iterateExcitationFilterLink();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setExcitationFilterLink . Makes the necessary
     * call on ome.model.acquisition.LightPathExcitationFilterLink as well.
     */
    public void addLightPathExcitationFilterLink(ome.model.acquisition.LightPathExcitationFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setParent ( this );
             }
         }
    }

    /**
     * use like addLightPathExcitationFilterLink.
     */
    public void addLightPathExcitationFilterLinkSet(java.util.Collection<ome.model.acquisition.LightPathExcitationFilterLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
           throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().addAll( targets );
        java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathExcitationFilterLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setParent ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.acquisition.LightPathExcitationFilterLink
     */
    public void removeLightPathExcitationFilterLink(ome.model.acquisition.LightPathExcitationFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().remove( target );
        if (target.isLoaded()) {
            target.setParent ( null );
        }
    }

    /**
     * use like removeLightPathExcitationFilterLink
     */
    public void removeLightPathExcitationFilterLinkSet(java.util.Collection<ome.model.acquisition.LightPathExcitationFilterLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().removeAll( targets );
        java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathExcitationFilterLink target = it.next();
            if (target.isLoaded()) {
                target.setParent ( null );
            }
        }
    }



    /**
     * Gets the ome.model.acquisition.LightPathExcitationFilterLink at the given index.
     */
    public ome.model.acquisition.LightPathExcitationFilterLink getLightPathExcitationFilterLink(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        return getExcitationFilterLink().get(index);
    }

    /**
     * Sets the ome.model.acquisition.LightPathExcitationFilterLink at the given index. Adheres to the {@link List#set(int ,E))}
     * contract. To extend the list, use {@link #addLightPathExcitationFilterLink()}.
     * @see java.util.List#set(int, E)
     */
    public ome.model.acquisition.LightPathExcitationFilterLink setLightPathExcitationFilterLink(int index, ome.model.acquisition.LightPathExcitationFilterLink element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }

        ome.model.acquisition.LightPathExcitationFilterLink old = getExcitationFilterLink().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setParent ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of excitationFilterLink which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfExcitationFilterLink()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.acquisition.LightPathExcitationFilterLink getPrimaryLightPathExcitationFilterLink()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        return getExcitationFilterLink().get(0);
    }

    /**
     * Swaps the first element of excitationFilterLink with the first instance of the 
     * given element. If the given element is not in the list, an 
     * {@link IndexOutBoundException} will be thrown. Returns the swapped 
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfExcitationFilterLink()} for more information.
     */
    public ome.model.acquisition.LightPathExcitationFilterLink setPrimaryLightPathExcitationFilterLink(ome.model.acquisition.LightPathExcitationFilterLink element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        java.util.List<ome.model.acquisition.LightPathExcitationFilterLink> list = getExcitationFilterLink();
        int index = list.indexOf(element);
        ome.model.acquisition.LightPathExcitationFilterLink old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    

    /**
     * Adds a ome.model.acquisition.LightPathExcitationFilterLink to excitationFilterLink . This entails changing our excitationFilterLink Set,
     * creating a new ome.model.acquisition.LightPathExcitationFilterLink and calling linkExcitationFilter on the ome.model.acquisition.Filter.
     */
    public ome.model.acquisition.LightPathExcitationFilterLink linkExcitationFilter (ome.model.acquisition.Filter addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.acquisition.LightPathExcitationFilterLink link = new ome.model.acquisition.LightPathExcitationFilterLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addLightPathExcitationFilterLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.acquisition.LightPathExcitationFilterLink to excitationFilterLink, allowing for recursion -- whether
     * or not addLightPathExcitationFilterLink will be called on the addition <b>if it is loaded</b>
     */
    public void addLightPathExcitationFilterLink (ome.model.acquisition.LightPathExcitationFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().add( link );

    }

    /**
     * provides an iterator over the parent values of the excitationFilterLink. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedExcitationFilterList()} instead.
     */
     public java.util.Iterator<ome.model.acquisition.Filter> linkedExcitationFilterIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.Filter>();
        }

        final java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = getExcitationFilterLink().iterator();
        return new java.util.Iterator<ome.model.acquisition.Filter>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.acquisition.Filter next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "excitationFilterLink is null; no elements." );
                }
                ome.model.acquisition.LightPathExcitationFilterLink link = (ome.model.acquisition.LightPathExcitationFilterLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.acquisition.LightPathExcitationFilterLink which have the argument as their child.
     */
    public java.util.Set<ome.model.acquisition.LightPathExcitationFilterLink> findLightPathExcitationFilterLink( ome.model.acquisition.Filter target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = iterateExcitationFilterLink();
        final java.util.Set<ome.model.acquisition.LightPathExcitationFilterLink> result = new java.util.HashSet<ome.model.acquisition.LightPathExcitationFilterLink>();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathExcitationFilterLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedExcitationFilterIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.acquisition.Filter> linkedExcitationFilterList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.acquisition.Filter> it = linkedExcitationFilterIterator();
        java.util.List<ome.model.acquisition.Filter> list = new java.util.ArrayList<ome.model.acquisition.Filter>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.Filter while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedExcitationFilter(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.Filter> it = linkedExcitationFilterIterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.Filter obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.acquisition.Filter instances from this instance.
     */
    public void unlinkExcitationFilter (ome.model.acquisition.Filter removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.acquisition.LightPathExcitationFilterLink> toRemove = findLightPathExcitationFilterLink( removal );
        java.util.Iterator<ome.model.acquisition.LightPathExcitationFilterLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeLightPathExcitationFilterLink( it.next(), true );
        }
    }

    /**
     * removes the given LightPathExcitationFilterLink from excitationFilterLink, allowing for recursion -- whether
     * or not the removal will call unlinkLightPath again <b>if loaded</b>.
     */
    public void removeLightPathExcitationFilterLink (ome.model.acquisition.LightPathExcitationFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getExcitationFilterLink() == null ) {
            throwNullCollectionException("ExcitationFilterLink");
        }

        getExcitationFilterLink().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearExcitationFilterLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.acquisition.LightPathExcitationFilterLink> list = new java.util.ArrayList<ome.model.acquisition.LightPathExcitationFilterLink>( getExcitationFilterLink() );
        for (ome.model.acquisition.LightPathExcitationFilterLink link : list) {
            removeLightPathExcitationFilterLink( link, true );
        }
    }

    private java.util.Map<Long, Long> excitationFilterLinkCountPerOwner = null;

    protected void setExcitationFilterLinkCountPerOwner(java.util.Map<Long, Long> map) {
        this.excitationFilterLinkCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_LightPath_excitationFilterLink_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.acquisition.LightPathExcitationFilterLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_LightPath_excitationFilterLink") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_LightPath_excitationFilterLink_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="LightPath_id"))
    public java.util.Map<Long, Long> getExcitationFilterLinkCountPerOwner() {
        return this.excitationFilterLinkCountPerOwner;
    }

    protected ome.model.acquisition.Dichroic dichroic = null;

   /**
    * Many-to-one field ome.model.acquisition.LightPath.dichroic (ome.model.acquisition.Dichroic)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Dichroic.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="dichroic", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlightpath_dichroic_dichroic")
    public ome.model.acquisition.Dichroic getDichroic() {
        if (! _loaded ) errorIfUnloaded();
        return this.dichroic;
    }

    public void setDichroic(ome.model.acquisition.Dichroic dichroic) {
        if (! _loaded ) errorIfUnloaded();
        this.dichroic = dichroic;
    }
    protected java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> emissionFilterLink = new java.util.HashSet<ome.model.acquisition.LightPathEmissionFilterLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_EMISSIONFILTERLINK = "lightpath_owner_filter_EMISSIONFILTERLINK";
    public final static String GROUP_FILTER_EMISSIONFILTERLINK = "lightpath_group_filter_EMISSIONFILTERLINK";
    public final static String EVENT_FILTER_EMISSIONFILTERLINK = "lightpath_event_filter_EMISSIONFILTERLINK";
    public final static String PERMS_FILTER_EMISSIONFILTERLINK = "lightpath_perms_filter_EMISSIONFILTERLINK";

   /**
    * returns emissionFilterLink . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.acquisition.LightPath.emissionFilterLink (ome.model.acquisition.LightPathEmissionFilterLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_EMISSIONFILTERLINK, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_EMISSIONFILTERLINK, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_EMISSIONFILTERLINK, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_EMISSIONFILTERLINK, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> getEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.emissionFilterLink;
    }

    /**
     * setter for emissionFilterLink should be avoided. Does not fulfill normal semantics.
     */
    protected void setEmissionFilterLink(java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> emissionFilterLink) {
        if (! _loaded ) errorIfUnloaded();
        this.emissionFilterLink = emissionFilterLink;
    }
    /**
     * returns the size of emissionFilterLink. If less than zero, the Set was null.
     */
    public int sizeOfEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.emissionFilterLink == null ? -1 : this.emissionFilterLink.size();
    }

    /**
     * should be used rather than accessing the emissionFilterLink set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfEmissionFilterLink()} is less than zero.
     */
    public java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> iterateEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.LightPathEmissionFilterLink>();
        }
        return getEmissionFilterLink().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.acquisition.LightPathEmissionFilterLink> unmodifiableEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getEmissionFilterLink() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.LightPathEmissionFilterLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateEmissionFilterLink} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectEmissionFilterLink(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = iterateEmissionFilterLink();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setEmissionFilterLink . Makes the necessary
     * call on ome.model.acquisition.LightPathEmissionFilterLink as well.
     */
    public void addLightPathEmissionFilterLink(ome.model.acquisition.LightPathEmissionFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addLightPathEmissionFilterLink.
     */
    public void addLightPathEmissionFilterLinkSet(java.util.Collection<ome.model.acquisition.LightPathEmissionFilterLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
           throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().addAll( targets );
        java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathEmissionFilterLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.acquisition.LightPathEmissionFilterLink
     */
    public void removeLightPathEmissionFilterLink(ome.model.acquisition.LightPathEmissionFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeLightPathEmissionFilterLink
     */
    public void removeLightPathEmissionFilterLinkSet(java.util.Collection<ome.model.acquisition.LightPathEmissionFilterLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().removeAll( targets );
        java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathEmissionFilterLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.acquisition.LightPathEmissionFilterLink to emissionFilterLink . This entails changing our emissionFilterLink Set,
     * creating a new ome.model.acquisition.LightPathEmissionFilterLink and calling linkEmissionFilter on the ome.model.acquisition.Filter.
     */
    public ome.model.acquisition.LightPathEmissionFilterLink linkEmissionFilter (ome.model.acquisition.Filter addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.acquisition.LightPathEmissionFilterLink link = new ome.model.acquisition.LightPathEmissionFilterLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addLightPathEmissionFilterLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.acquisition.LightPathEmissionFilterLink to emissionFilterLink, allowing for recursion -- whether
     * or not addLightPathEmissionFilterLink will be called on the addition <b>if it is loaded</b>
     */
    public void addLightPathEmissionFilterLink (ome.model.acquisition.LightPathEmissionFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().add( link );

    }

    /**
     * provides an iterator over the parent values of the emissionFilterLink. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedEmissionFilterList()} instead.
     */
     public java.util.Iterator<ome.model.acquisition.Filter> linkedEmissionFilterIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.Filter>();
        }

        final java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = getEmissionFilterLink().iterator();
        return new java.util.Iterator<ome.model.acquisition.Filter>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.acquisition.Filter next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "emissionFilterLink is null; no elements." );
                }
                ome.model.acquisition.LightPathEmissionFilterLink link = (ome.model.acquisition.LightPathEmissionFilterLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.acquisition.LightPathEmissionFilterLink which have the argument as their child.
     */
    public java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> findLightPathEmissionFilterLink( ome.model.acquisition.Filter target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = iterateEmissionFilterLink();
        final java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> result = new java.util.HashSet<ome.model.acquisition.LightPathEmissionFilterLink>();
        while ( it.hasNext() ) {
            ome.model.acquisition.LightPathEmissionFilterLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedEmissionFilterIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.acquisition.Filter> linkedEmissionFilterList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.acquisition.Filter> it = linkedEmissionFilterIterator();
        java.util.List<ome.model.acquisition.Filter> list = new java.util.ArrayList<ome.model.acquisition.Filter>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.Filter while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedEmissionFilter(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.Filter> it = linkedEmissionFilterIterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.Filter obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.acquisition.Filter instances from this instance.
     */
    public void unlinkEmissionFilter (ome.model.acquisition.Filter removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink> toRemove = findLightPathEmissionFilterLink( removal );
        java.util.Iterator<ome.model.acquisition.LightPathEmissionFilterLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeLightPathEmissionFilterLink( it.next(), true );
        }
    }

    /**
     * removes the given LightPathEmissionFilterLink from emissionFilterLink, allowing for recursion -- whether
     * or not the removal will call unlinkLightPath again <b>if loaded</b>.
     */
    public void removeLightPathEmissionFilterLink (ome.model.acquisition.LightPathEmissionFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getEmissionFilterLink() == null ) {
            throwNullCollectionException("EmissionFilterLink");
        }

        getEmissionFilterLink().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearEmissionFilterLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.acquisition.LightPathEmissionFilterLink> list = new java.util.ArrayList<ome.model.acquisition.LightPathEmissionFilterLink>( getEmissionFilterLink() );
        for (ome.model.acquisition.LightPathEmissionFilterLink link : list) {
            removeLightPathEmissionFilterLink( link, true );
        }
    }

    private java.util.Map<Long, Long> emissionFilterLinkCountPerOwner = null;

    protected void setEmissionFilterLinkCountPerOwner(java.util.Map<Long, Long> map) {
        this.emissionFilterLinkCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_LightPath_emissionFilterLink_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.acquisition.LightPathEmissionFilterLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_LightPath_emissionFilterLink") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_LightPath_emissionFilterLink_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="LightPath_id"))
    public java.util.Map<Long, Long> getEmissionFilterLinkCountPerOwner() {
        return this.emissionFilterLinkCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.LightPath newInstance() 
    {
        return new ome.model.acquisition.LightPath();
    }

    public ome.model.acquisition.LightPath proxy() {
        return new ome.model.acquisition.LightPath(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.excitationFilterLinkCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(EXCITATIONFILTERLINKCOUNTPEROWNER, this.excitationFilterLinkCountPerOwner );
            this.excitationFilterLink = (java.util.List<ome.model.acquisition.LightPathExcitationFilterLink>) __filter.filter(EXCITATIONFILTERLINK, this.excitationFilterLink );
            this.dichroic = (ome.model.acquisition.Dichroic) __filter.filter(DICHROIC, this.dichroic );
            this.emissionFilterLinkCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(EMISSIONFILTERLINKCOUNTPEROWNER, this.emissionFilterLinkCountPerOwner );
            this.emissionFilterLink = (java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink>) __filter.filter(EMISSIONFILTERLINK, this.emissionFilterLink );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.acquisition.LightPath.FIELDS;
    }
  
    public final static String EXCITATIONFILTERLINKCOUNTPEROWNER = "ome.model.acquisition.LightPath_excitationFilterLinkCountPerOwner";
    public final static String EXCITATIONFILTERLINK = "ome.model.acquisition.LightPath_excitationFilterLink";
    public final static String DICHROIC = "ome.model.acquisition.LightPath_dichroic";
    public final static String EMISSIONFILTERLINKCOUNTPEROWNER = "ome.model.acquisition.LightPath_emissionFilterLinkCountPerOwner";
    public final static String EMISSIONFILTERLINK = "ome.model.acquisition.LightPath_emissionFilterLink";
    public final static String DETAILS = "ome.model.acquisition.LightPath_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(EXCITATIONFILTERLINKCOUNTPEROWNER);
       raw.add(EXCITATIONFILTERLINK);
       raw.add(DICHROIC);
       raw.add(EMISSIONFILTERLINKCOUNTPEROWNER);
       raw.add(EMISSIONFILTERLINK);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(EXCITATIONFILTERLINKCOUNTPEROWNER)) {
            return getExcitationFilterLinkCountPerOwner();
        } else if (field.equals(EXCITATIONFILTERLINK)) { // TODO use == here first??
            return getExcitationFilterLink();
        } else if (field.equals(DICHROIC)) { // TODO use == here first??
            return getDichroic();
        } else if (field.equals(EMISSIONFILTERLINKCOUNTPEROWNER)) {
            return getEmissionFilterLinkCountPerOwner();
        } else if (field.equals(EMISSIONFILTERLINK)) { // TODO use == here first??
            return getEmissionFilterLink();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(EXCITATIONFILTERLINKCOUNTPEROWNER)) {
            setExcitationFilterLinkCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(EXCITATIONFILTERLINK)) {
            setExcitationFilterLink((java.util.List<ome.model.acquisition.LightPathExcitationFilterLink>)value);
        } else if (field.equals(DICHROIC)) {
            setDichroic((ome.model.acquisition.Dichroic)value);
        } else if (field.equals(EMISSIONFILTERLINKCOUNTPEROWNER)) {
            setEmissionFilterLinkCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(EMISSIONFILTERLINK)) {
            setEmissionFilterLink((java.util.Set<ome.model.acquisition.LightPathEmissionFilterLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.excitationFilterLinkCountPerOwner = null;
        this.excitationFilterLink = null;
        this.dichroic = null;
        this.emissionFilterLinkCountPerOwner = null;
        this.emissionFilterLink = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKlightpath_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlightpath_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKlightpath_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlightpath_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlightpath_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
