

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="objective_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="objective_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="objective_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="objective_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="objective_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="objective_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="objective_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="objective_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "objective", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_objective",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_objective"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Objective
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "objective_owner_filter";
    public final static String GROUP_FILTER = "objective_group_filter";
    public final static String EVENT_FILTER = "objective_event_filter";
    public final static String PERMS_FILTER = "objective_perms_filter";

    public Objective () {
        this(null, true);
    }

    protected Objective (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Objective (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Objective(
ome.model.enums.Immersion _immersion,ome.model.enums.Correction _correction,ome.model.acquisition.Instrument _instrument    ) {
        this(null, true);
        setImmersion(_immersion);
        setCorrection(_correction);
        setInstrument(_instrument);
    }

    public final static String ID = "ome.model.acquisition.Objective_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_objective") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.acquisition.Objective_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String manufacturer = null;

   /**
    * Simple field ome.model.acquisition.Objective.manufacturer (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="manufacturer", updatable=true)
    public java.lang.String getManufacturer() {
        if (! _loaded ) errorIfUnloaded();
        return this.manufacturer;
    }

    public void setManufacturer(java.lang.String manufacturer) {
        if (! _loaded ) errorIfUnloaded();
        this.manufacturer = (java.lang.String) manufacturer;
    }
    protected java.lang.String model = null;

   /**
    * Simple field ome.model.acquisition.Objective.model (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="model", updatable=true)
    public java.lang.String getModel() {
        if (! _loaded ) errorIfUnloaded();
        return this.model;
    }

    public void setModel(java.lang.String model) {
        if (! _loaded ) errorIfUnloaded();
        this.model = (java.lang.String) model;
    }
    protected java.lang.String lotNumber = null;

   /**
    * Simple field ome.model.acquisition.Objective.lotNumber (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="lotNumber", updatable=true)
    public java.lang.String getLotNumber() {
        if (! _loaded ) errorIfUnloaded();
        return this.lotNumber;
    }

    public void setLotNumber(java.lang.String lotNumber) {
        if (! _loaded ) errorIfUnloaded();
        this.lotNumber = (java.lang.String) lotNumber;
    }
    protected java.lang.String serialNumber = null;

   /**
    * Simple field ome.model.acquisition.Objective.serialNumber (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="serialNumber", updatable=true)
    public java.lang.String getSerialNumber() {
        if (! _loaded ) errorIfUnloaded();
        return this.serialNumber;
    }

    public void setSerialNumber(java.lang.String serialNumber) {
        if (! _loaded ) errorIfUnloaded();
        this.serialNumber = (java.lang.String) serialNumber;
    }
    protected java.lang.Double nominalMagnification = null;

   /**
    * Simple field ome.model.acquisition.Objective.nominalMagnification (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="nominalMagnification", updatable=true)
    public java.lang.Double getNominalMagnification() {
        if (! _loaded ) errorIfUnloaded();
        return this.nominalMagnification;
    }

    public void setNominalMagnification(java.lang.Double nominalMagnification) {
        if (! _loaded ) errorIfUnloaded();
        this.nominalMagnification = (java.lang.Double) nominalMagnification;
    }
    protected java.lang.Double calibratedMagnification = null;

   /**
    * Simple field ome.model.acquisition.Objective.calibratedMagnification (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="calibratedMagnification", updatable=true)
    public java.lang.Double getCalibratedMagnification() {
        if (! _loaded ) errorIfUnloaded();
        return this.calibratedMagnification;
    }

    public void setCalibratedMagnification(java.lang.Double calibratedMagnification) {
        if (! _loaded ) errorIfUnloaded();
        this.calibratedMagnification = (java.lang.Double) calibratedMagnification;
    }
    protected java.lang.Double lensNA = null;

   /**
    * Simple field ome.model.acquisition.Objective.lensNA (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="lensNA", updatable=true)
    public java.lang.Double getLensNA() {
        if (! _loaded ) errorIfUnloaded();
        return this.lensNA;
    }

    public void setLensNA(java.lang.Double lensNA) {
        if (! _loaded ) errorIfUnloaded();
        this.lensNA = (java.lang.Double) lensNA;
    }
    protected ome.model.enums.Immersion immersion = null;

   /**
    * Many-to-one field ome.model.acquisition.Objective.immersion (ome.model.enums.Immersion)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Immersion.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="immersion", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKobjective_immersion_immersion")
    public ome.model.enums.Immersion getImmersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.immersion;
    }

    public void setImmersion(ome.model.enums.Immersion immersion) {
        if (! _loaded ) errorIfUnloaded();
        this.immersion = immersion;
    }
    protected ome.model.enums.Correction correction = null;

   /**
    * Many-to-one field ome.model.acquisition.Objective.correction (ome.model.enums.Correction)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Correction.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="correction", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKobjective_correction_correction")
    public ome.model.enums.Correction getCorrection() {
        if (! _loaded ) errorIfUnloaded();
        return this.correction;
    }

    public void setCorrection(ome.model.enums.Correction correction) {
        if (! _loaded ) errorIfUnloaded();
        this.correction = correction;
    }
    protected java.lang.Double workingDistance = null;

   /**
    * Simple field ome.model.acquisition.Objective.workingDistance (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="workingDistance", updatable=true)
    public java.lang.Double getWorkingDistance() {
        if (! _loaded ) errorIfUnloaded();
        return this.workingDistance;
    }

    public void setWorkingDistance(java.lang.Double workingDistance) {
        if (! _loaded ) errorIfUnloaded();
        this.workingDistance = (java.lang.Double) workingDistance;
    }
    protected java.lang.Boolean iris = null;

   /**
    * Simple field ome.model.acquisition.Objective.iris (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="iris", updatable=true)
    public java.lang.Boolean getIris() {
        if (! _loaded ) errorIfUnloaded();
        return this.iris;
    }

    public void setIris(java.lang.Boolean iris) {
        if (! _loaded ) errorIfUnloaded();
        this.iris = (java.lang.Boolean) iris;
    }
    protected ome.model.acquisition.Instrument instrument = null;

   /**
    * Many-to-one field ome.model.acquisition.Objective.instrument (ome.model.acquisition.Instrument)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Instrument.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="instrument", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKobjective_instrument_instrument")
    public ome.model.acquisition.Instrument getInstrument() {
        if (! _loaded ) errorIfUnloaded();
        return this.instrument;
    }

    public void setInstrument(ome.model.acquisition.Instrument instrument) {
        if (! _loaded ) errorIfUnloaded();
        this.instrument = instrument;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.Objective newInstance() 
    {
        return new ome.model.acquisition.Objective();
    }

    public ome.model.acquisition.Objective proxy() {
        return new ome.model.acquisition.Objective(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.manufacturer = (java.lang.String) __filter.filter(MANUFACTURER, this.manufacturer );
            this.model = (java.lang.String) __filter.filter(MODEL, this.model );
            this.lotNumber = (java.lang.String) __filter.filter(LOTNUMBER, this.lotNumber );
            this.serialNumber = (java.lang.String) __filter.filter(SERIALNUMBER, this.serialNumber );
            this.nominalMagnification = (java.lang.Double) __filter.filter(NOMINALMAGNIFICATION, this.nominalMagnification );
            this.calibratedMagnification = (java.lang.Double) __filter.filter(CALIBRATEDMAGNIFICATION, this.calibratedMagnification );
            this.lensNA = (java.lang.Double) __filter.filter(LENSNA, this.lensNA );
            this.immersion = (ome.model.enums.Immersion) __filter.filter(IMMERSION, this.immersion );
            this.correction = (ome.model.enums.Correction) __filter.filter(CORRECTION, this.correction );
            this.workingDistance = (java.lang.Double) __filter.filter(WORKINGDISTANCE, this.workingDistance );
            this.iris = (java.lang.Boolean) __filter.filter(IRIS, this.iris );
            this.instrument = (ome.model.acquisition.Instrument) __filter.filter(INSTRUMENT, this.instrument );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.acquisition.Objective.FIELDS;
    }
  
    public final static String MANUFACTURER = "ome.model.acquisition.Objective_manufacturer";
    public final static String MODEL = "ome.model.acquisition.Objective_model";
    public final static String LOTNUMBER = "ome.model.acquisition.Objective_lotNumber";
    public final static String SERIALNUMBER = "ome.model.acquisition.Objective_serialNumber";
    public final static String NOMINALMAGNIFICATION = "ome.model.acquisition.Objective_nominalMagnification";
    public final static String CALIBRATEDMAGNIFICATION = "ome.model.acquisition.Objective_calibratedMagnification";
    public final static String LENSNA = "ome.model.acquisition.Objective_lensNA";
    public final static String IMMERSION = "ome.model.acquisition.Objective_immersion";
    public final static String CORRECTION = "ome.model.acquisition.Objective_correction";
    public final static String WORKINGDISTANCE = "ome.model.acquisition.Objective_workingDistance";
    public final static String IRIS = "ome.model.acquisition.Objective_iris";
    public final static String INSTRUMENT = "ome.model.acquisition.Objective_instrument";
    public final static String DETAILS = "ome.model.acquisition.Objective_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(MANUFACTURER);
       raw.add(MODEL);
       raw.add(LOTNUMBER);
       raw.add(SERIALNUMBER);
       raw.add(NOMINALMAGNIFICATION);
       raw.add(CALIBRATEDMAGNIFICATION);
       raw.add(LENSNA);
       raw.add(IMMERSION);
       raw.add(CORRECTION);
       raw.add(WORKINGDISTANCE);
       raw.add(IRIS);
       raw.add(INSTRUMENT);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(MANUFACTURER)) { // TODO use == here first??
            return getManufacturer();
        } else if (field.equals(MODEL)) { // TODO use == here first??
            return getModel();
        } else if (field.equals(LOTNUMBER)) { // TODO use == here first??
            return getLotNumber();
        } else if (field.equals(SERIALNUMBER)) { // TODO use == here first??
            return getSerialNumber();
        } else if (field.equals(NOMINALMAGNIFICATION)) { // TODO use == here first??
            return getNominalMagnification();
        } else if (field.equals(CALIBRATEDMAGNIFICATION)) { // TODO use == here first??
            return getCalibratedMagnification();
        } else if (field.equals(LENSNA)) { // TODO use == here first??
            return getLensNA();
        } else if (field.equals(IMMERSION)) { // TODO use == here first??
            return getImmersion();
        } else if (field.equals(CORRECTION)) { // TODO use == here first??
            return getCorrection();
        } else if (field.equals(WORKINGDISTANCE)) { // TODO use == here first??
            return getWorkingDistance();
        } else if (field.equals(IRIS)) { // TODO use == here first??
            return getIris();
        } else if (field.equals(INSTRUMENT)) { // TODO use == here first??
            return getInstrument();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(MANUFACTURER)) {
            setManufacturer((java.lang.String)value);
        } else if (field.equals(MODEL)) {
            setModel((java.lang.String)value);
        } else if (field.equals(LOTNUMBER)) {
            setLotNumber((java.lang.String)value);
        } else if (field.equals(SERIALNUMBER)) {
            setSerialNumber((java.lang.String)value);
        } else if (field.equals(NOMINALMAGNIFICATION)) {
            setNominalMagnification((java.lang.Double)value);
        } else if (field.equals(CALIBRATEDMAGNIFICATION)) {
            setCalibratedMagnification((java.lang.Double)value);
        } else if (field.equals(LENSNA)) {
            setLensNA((java.lang.Double)value);
        } else if (field.equals(IMMERSION)) {
            setImmersion((ome.model.enums.Immersion)value);
        } else if (field.equals(CORRECTION)) {
            setCorrection((ome.model.enums.Correction)value);
        } else if (field.equals(WORKINGDISTANCE)) {
            setWorkingDistance((java.lang.Double)value);
        } else if (field.equals(IRIS)) {
            setIris((java.lang.Boolean)value);
        } else if (field.equals(INSTRUMENT)) {
            setInstrument((ome.model.acquisition.Instrument)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.manufacturer = null;
        this.model = null;
        this.lotNumber = null;
        this.serialNumber = null;
        this.nominalMagnification = null;
        this.calibratedMagnification = null;
        this.lensNA = null;
        this.immersion = null;
        this.correction = null;
        this.workingDistance = null;
        this.iris = null;
        this.instrument = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKobjective_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKobjective_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKobjective_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKobjective_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKobjective_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
