

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.annotations;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="namespaceannotationlink_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespaceannotationlink_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespaceannotationlink_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespaceannotationlink_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="namespaceannotationlink_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="namespaceannotationlink_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="namespaceannotationlink_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="namespaceannotationlink_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "namespaceannotationlink", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"parent","child","owner_id"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_namespaceannotationlink",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_namespaceannotationlink"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class NamespaceAnnotationLink
implements java.io.Serializable, IObject
, IMutable, IAnnotationLink{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "namespaceannotationlink_owner_filter";
    public final static String GROUP_FILTER = "namespaceannotationlink_group_filter";
    public final static String EVENT_FILTER = "namespaceannotationlink_event_filter";
    public final static String PERMS_FILTER = "namespaceannotationlink_perms_filter";

    public NamespaceAnnotationLink () {
        this(null, true);
    }

    protected NamespaceAnnotationLink (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public NamespaceAnnotationLink (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public NamespaceAnnotationLink(
IObject _parent,IObject _child    ) {
        this(null, true);
        setParent(_parent);
        setChild(_child);
    }

    public final static String ID = "ome.model.annotations.NamespaceAnnotationLink_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_namespaceannotationlink") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.annotations.NamespaceAnnotationLink_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected IObject parent = null;

   /**
    * Many-to-one field ome.model.annotations.NamespaceAnnotationLink.parent (ome.model.meta.Namespace)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Namespace.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="parent", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKnamespaceannotationlink_parent_namespace")
    @org.hibernate.annotations.Target(ome.model.meta.Namespace.class)
    public IObject getParent() {
        if (! _loaded ) errorIfUnloaded();
        return this.parent;
    }

    public void setParent(IObject parent) {
        if (! _loaded ) errorIfUnloaded();
        this.parent = parent;
    }
    protected IObject child = null;

   /**
    * Many-to-one field ome.model.annotations.NamespaceAnnotationLink.child (ome.model.annotations.Annotation)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.annotations.Annotation.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="child", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKnamespaceannotationlink_child_annotation")
    @org.hibernate.annotations.Target(ome.model.annotations.Annotation.class)
    public IObject getChild() {
        if (! _loaded ) errorIfUnloaded();
        return this.child;
    }

    public void setChild(IObject child) {
        if (! _loaded ) errorIfUnloaded();
        this.child = child;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.annotations.NamespaceAnnotationLink newInstance() 
    {
        return new ome.model.annotations.NamespaceAnnotationLink();
    }

    public ome.model.annotations.NamespaceAnnotationLink proxy() {
        return new ome.model.annotations.NamespaceAnnotationLink(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.parent = (IObject) __filter.filter(PARENT, this.parent );
            this.child = (IObject) __filter.filter(CHILD, this.child );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.annotations.NamespaceAnnotationLink.FIELDS;
    }
  
    public final static String PARENT = "ome.model.annotations.NamespaceAnnotationLink_parent";
    public final static String CHILD = "ome.model.annotations.NamespaceAnnotationLink_child";
    public final static String DETAILS = "ome.model.annotations.NamespaceAnnotationLink_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(PARENT);
       raw.add(CHILD);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(PARENT)) { // TODO use == here first??
            return getParent();
        } else if (field.equals(CHILD)) { // TODO use == here first??
            return getChild();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(PARENT)) {
            setParent((IObject)value);
        } else if (field.equals(CHILD)) {
            setChild((IObject)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.parent = null;
        this.child = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }

    public void link(ome.model.meta.Namespace parent, ome.model.annotations.Annotation child) {
        setParent( parent );
        setChild( child );
    }

    public ome.model.meta.Namespace parent() {
        return (ome.model.meta.Namespace) getParent();
    }

    public ome.model.annotations.Annotation child() {
        return (ome.model.annotations.Annotation) getChild();
    }
    

    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespaceannotationlink_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespaceannotationlink_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespaceannotationlink_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespaceannotationlink_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespaceannotationlink_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
