

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.containers;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="dataset_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="dataset_owner_filter_PROJECTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_group_filter_PROJECTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_event_filter_PROJECTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_perms_filter_PROJECTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="dataset_owner_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_group_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_event_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_perms_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="dataset_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="dataset_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="dataset_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="dataset_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="dataset_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="dataset_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "dataset", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_dataset",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_dataset"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Dataset
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "dataset_owner_filter";
    public final static String GROUP_FILTER = "dataset_group_filter";
    public final static String EVENT_FILTER = "dataset_event_filter";
    public final static String PERMS_FILTER = "dataset_perms_filter";

    public Dataset () {
        this(null, true);
    }

    protected Dataset (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Dataset (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Dataset(
java.lang.String _name    ) {
        this(null, true);
        setName(_name);
    }

    public final static String ID = "ome.model.containers.Dataset_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_dataset") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.containers.Dataset_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.util.Set<ome.model.containers.ProjectDatasetLink> projectLinks = new java.util.HashSet<ome.model.containers.ProjectDatasetLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_PROJECTLINKS = "dataset_owner_filter_PROJECTLINKS";
    public final static String GROUP_FILTER_PROJECTLINKS = "dataset_group_filter_PROJECTLINKS";
    public final static String EVENT_FILTER_PROJECTLINKS = "dataset_event_filter_PROJECTLINKS";
    public final static String PERMS_FILTER_PROJECTLINKS = "dataset_perms_filter_PROJECTLINKS";

   /**
    * returns projectLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Dataset.projectLinks (ome.model.containers.ProjectDatasetLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_PROJECTLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_PROJECTLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_PROJECTLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_PROJECTLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.ProjectDatasetLink> getProjectLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.projectLinks;
    }

    /**
     * setter for projectLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setProjectLinks(java.util.Set<ome.model.containers.ProjectDatasetLink> projectLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.projectLinks = projectLinks;
    }
    /**
     * returns the size of projectLinks. If less than zero, the Set was null.
     */
    public int sizeOfProjectLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.projectLinks == null ? -1 : this.projectLinks.size();
    }

    /**
     * should be used rather than accessing the projectLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfProjectLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.ProjectDatasetLink> iterateProjectLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getProjectLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.ProjectDatasetLink>();
        }
        return getProjectLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.containers.ProjectDatasetLink> unmodifiableProjectLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getProjectLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getProjectLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.containers.ProjectDatasetLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateProjectLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectProjectLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = iterateProjectLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setProjectLinks . Makes the necessary
     * call on ome.model.containers.ProjectDatasetLink as well.
     */
    public void addProjectDatasetLink(ome.model.containers.ProjectDatasetLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getProjectLinks() == null) {
            throwNullCollectionException("ProjectLinks");
        }
        getProjectLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addProjectDatasetLink.
     */
    public void addProjectDatasetLinkSet(java.util.Collection<ome.model.containers.ProjectDatasetLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getProjectLinks() == null) {
           throwNullCollectionException("ProjectLinks");
        }
        getProjectLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.ProjectDatasetLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.ProjectDatasetLink
     */
    public void removeProjectDatasetLink(ome.model.containers.ProjectDatasetLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getProjectLinks() == null) {
            throwNullCollectionException("ProjectLinks");
        }
        getProjectLinks().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeProjectDatasetLink
     */
    public void removeProjectDatasetLinkSet(java.util.Collection<ome.model.containers.ProjectDatasetLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getProjectLinks() == null) {
            throwNullCollectionException("ProjectLinks");
        }
        getProjectLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.ProjectDatasetLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.containers.ProjectDatasetLink to projectLinks . This entails changing our projectLinks Set,
     * creating a new ome.model.containers.ProjectDatasetLink and calling linkProject on the ome.model.containers.Project.
     */
    public ome.model.containers.ProjectDatasetLink linkProject (ome.model.containers.Project addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.ProjectDatasetLink link = new ome.model.containers.ProjectDatasetLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addProjectDatasetLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.ProjectDatasetLink to projectLinks, allowing for recursion -- whether
     * or not addProjectDatasetLink will be called on the addition <b>if it is loaded</b>
     */
    public void addProjectDatasetLink (ome.model.containers.ProjectDatasetLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getProjectLinks() == null ) {
            throwNullCollectionException("ProjectLinks");
        }
        getProjectLinks().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addProjectDatasetLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the projectLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedProjectList()} instead.
     */
     public java.util.Iterator<ome.model.containers.Project> linkedProjectIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getProjectLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.Project>();
        }

        final java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = getProjectLinks().iterator();
        return new java.util.Iterator<ome.model.containers.Project>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.containers.Project next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "projectLinks is null; no elements." );
                }
                ome.model.containers.ProjectDatasetLink link = (ome.model.containers.ProjectDatasetLink) it.next();
                return link.parent();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.ProjectDatasetLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.containers.ProjectDatasetLink> findProjectDatasetLink( ome.model.containers.Project target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = iterateProjectLinks();
        final java.util.Set<ome.model.containers.ProjectDatasetLink> result = new java.util.HashSet<ome.model.containers.ProjectDatasetLink>();
        while ( it.hasNext() ) {
            ome.model.containers.ProjectDatasetLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedProjectIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.containers.Project> linkedProjectList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.containers.Project> it = linkedProjectIterator();
        java.util.List<ome.model.containers.Project> list = new java.util.ArrayList<ome.model.containers.Project>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.Project while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedProject(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.Project> it = linkedProjectIterator();
        while ( it.hasNext() ) {
            ome.model.containers.Project obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.containers.Project instances from this instance.
     */
    public void unlinkProject (ome.model.containers.Project removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.ProjectDatasetLink> toRemove = findProjectDatasetLink( removal );
        java.util.Iterator<ome.model.containers.ProjectDatasetLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeProjectDatasetLink( it.next(), true );
        }
    }

    /**
     * removes the given ProjectDatasetLink from projectLinks, allowing for recursion -- whether
     * or not the removal will call unlinkDataset again <b>if loaded</b>.
     */
    public void removeProjectDatasetLink (ome.model.containers.ProjectDatasetLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getProjectLinks() == null ) {
            throwNullCollectionException("ProjectLinks");
        }

        getProjectLinks().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeProjectDatasetLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearProjectLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.ProjectDatasetLink> list = new java.util.ArrayList<ome.model.containers.ProjectDatasetLink>( getProjectLinks() );
        for (ome.model.containers.ProjectDatasetLink link : list) {
            removeProjectDatasetLink( link, true );
        }
    }

    private java.util.Map<Long, Long> projectLinksCountPerOwner = null;

    protected void setProjectLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.projectLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Dataset_projectLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.ProjectDatasetLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Dataset_projectLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Dataset_projectLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Dataset_id"))
    public java.util.Map<Long, Long> getProjectLinksCountPerOwner() {
        return this.projectLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.containers.DatasetImageLink> imageLinks = new java.util.HashSet<ome.model.containers.DatasetImageLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_IMAGELINKS = "dataset_owner_filter_IMAGELINKS";
    public final static String GROUP_FILTER_IMAGELINKS = "dataset_group_filter_IMAGELINKS";
    public final static String EVENT_FILTER_IMAGELINKS = "dataset_event_filter_IMAGELINKS";
    public final static String PERMS_FILTER_IMAGELINKS = "dataset_perms_filter_IMAGELINKS";

   /**
    * returns imageLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Dataset.imageLinks (ome.model.containers.DatasetImageLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_IMAGELINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_IMAGELINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_IMAGELINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_IMAGELINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.DatasetImageLink> getImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.imageLinks;
    }

    /**
     * setter for imageLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setImageLinks(java.util.Set<ome.model.containers.DatasetImageLink> imageLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.imageLinks = imageLinks;
    }
    /**
     * returns the size of imageLinks. If less than zero, the Set was null.
     */
    public int sizeOfImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.imageLinks == null ? -1 : this.imageLinks.size();
    }

    /**
     * should be used rather than accessing the imageLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfImageLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.DatasetImageLink> iterateImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.DatasetImageLink>();
        }
        return getImageLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.containers.DatasetImageLink> unmodifiableImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getImageLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.containers.DatasetImageLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateImageLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectImageLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = iterateImageLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setImageLinks . Makes the necessary
     * call on ome.model.containers.DatasetImageLink as well.
     */
    public void addDatasetImageLink(ome.model.containers.DatasetImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addDatasetImageLink.
     */
    public void addDatasetImageLinkSet(java.util.Collection<ome.model.containers.DatasetImageLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
           throwNullCollectionException("ImageLinks");
        }
        getImageLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.DatasetImageLink
     */
    public void removeDatasetImageLink(ome.model.containers.DatasetImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeDatasetImageLink
     */
    public void removeDatasetImageLinkSet(java.util.Collection<ome.model.containers.DatasetImageLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.containers.DatasetImageLink to imageLinks . This entails changing our imageLinks Set,
     * creating a new ome.model.containers.DatasetImageLink and calling linkImage on the ome.model.core.Image.
     */
    public ome.model.containers.DatasetImageLink linkImage (ome.model.core.Image addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.DatasetImageLink link = new ome.model.containers.DatasetImageLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addDatasetImageLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.DatasetImageLink to imageLinks, allowing for recursion -- whether
     * or not addDatasetImageLink will be called on the addition <b>if it is loaded</b>
     */
    public void addDatasetImageLink (ome.model.containers.DatasetImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addDatasetImageLink( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the imageLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedImageList()} instead.
     */
     public java.util.Iterator<ome.model.core.Image> linkedImageIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.Image>();
        }

        final java.util.Iterator<ome.model.containers.DatasetImageLink> it = getImageLinks().iterator();
        return new java.util.Iterator<ome.model.core.Image>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.core.Image next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "imageLinks is null; no elements." );
                }
                ome.model.containers.DatasetImageLink link = (ome.model.containers.DatasetImageLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.DatasetImageLink which have the argument as their child.
     */
    public java.util.Set<ome.model.containers.DatasetImageLink> findDatasetImageLink( ome.model.core.Image target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.DatasetImageLink> it = iterateImageLinks();
        final java.util.Set<ome.model.containers.DatasetImageLink> result = new java.util.HashSet<ome.model.containers.DatasetImageLink>();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedImageIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.core.Image> linkedImageList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.core.Image> it = linkedImageIterator();
        java.util.List<ome.model.core.Image> list = new java.util.ArrayList<ome.model.core.Image>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.Image while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedImage(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.Image> it = linkedImageIterator();
        while ( it.hasNext() ) {
            ome.model.core.Image obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.core.Image instances from this instance.
     */
    public void unlinkImage (ome.model.core.Image removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.DatasetImageLink> toRemove = findDatasetImageLink( removal );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeDatasetImageLink( it.next(), true );
        }
    }

    /**
     * removes the given DatasetImageLink from imageLinks, allowing for recursion -- whether
     * or not the removal will call unlinkDataset again <b>if loaded</b>.
     */
    public void removeDatasetImageLink (ome.model.containers.DatasetImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getImageLinks() == null ) {
            throwNullCollectionException("ImageLinks");
        }

        getImageLinks().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removeDatasetImageLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearImageLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.DatasetImageLink> list = new java.util.ArrayList<ome.model.containers.DatasetImageLink>( getImageLinks() );
        for (ome.model.containers.DatasetImageLink link : list) {
            removeDatasetImageLink( link, true );
        }
    }

    private java.util.Map<Long, Long> imageLinksCountPerOwner = null;

    protected void setImageLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.imageLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Dataset_imageLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.DatasetImageLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Dataset_imageLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Dataset_imageLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Dataset_id"))
    public java.util.Map<Long, Long> getImageLinksCountPerOwner() {
        return this.imageLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.annotations.DatasetAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.DatasetAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "dataset_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "dataset_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "dataset_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "dataset_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Dataset.annotationLinks (ome.model.annotations.DatasetAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.DatasetAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.DatasetAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.DatasetAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.DatasetAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.DatasetAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.DatasetAnnotationLink as well.
     */
    public void addDatasetAnnotationLink(ome.model.annotations.DatasetAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addDatasetAnnotationLink.
     */
    public void addDatasetAnnotationLinkSet(java.util.Collection<ome.model.annotations.DatasetAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.DatasetAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.DatasetAnnotationLink
     */
    public void removeDatasetAnnotationLink(ome.model.annotations.DatasetAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeDatasetAnnotationLink
     */
    public void removeDatasetAnnotationLinkSet(java.util.Collection<ome.model.annotations.DatasetAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.DatasetAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.DatasetAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.DatasetAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.DatasetAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.DatasetAnnotationLink link = new ome.model.annotations.DatasetAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addDatasetAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.DatasetAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addDatasetAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addDatasetAnnotationLink (ome.model.annotations.DatasetAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.DatasetAnnotationLink link = (ome.model.annotations.DatasetAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.DatasetAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.DatasetAnnotationLink> findDatasetAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.DatasetAnnotationLink> result = new java.util.HashSet<ome.model.annotations.DatasetAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.DatasetAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.DatasetAnnotationLink> toRemove = findDatasetAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.DatasetAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeDatasetAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given DatasetAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkDataset again <b>if loaded</b>.
     */
    public void removeDatasetAnnotationLink (ome.model.annotations.DatasetAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.DatasetAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.DatasetAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.DatasetAnnotationLink link : list) {
            removeDatasetAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Dataset_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.DatasetAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Dataset_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Dataset_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Dataset_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.containers.Dataset.name (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.containers.Dataset.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.containers.Dataset newInstance() 
    {
        return new ome.model.containers.Dataset();
    }

    public ome.model.containers.Dataset proxy() {
        return new ome.model.containers.Dataset(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.projectLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(PROJECTLINKSCOUNTPEROWNER, this.projectLinksCountPerOwner );
            this.projectLinks = (java.util.Set<ome.model.containers.ProjectDatasetLink>) __filter.filter(PROJECTLINKS, this.projectLinks );
            this.imageLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(IMAGELINKSCOUNTPEROWNER, this.imageLinksCountPerOwner );
            this.imageLinks = (java.util.Set<ome.model.containers.DatasetImageLink>) __filter.filter(IMAGELINKS, this.imageLinks );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.DatasetAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.containers.Dataset.FIELDS;
    }
  
    public final static String PROJECTLINKSCOUNTPEROWNER = "ome.model.containers.Dataset_projectLinksCountPerOwner";
    public final static String PROJECTLINKS = "ome.model.containers.Dataset_projectLinks";
    public final static String IMAGELINKSCOUNTPEROWNER = "ome.model.containers.Dataset_imageLinksCountPerOwner";
    public final static String IMAGELINKS = "ome.model.containers.Dataset_imageLinks";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.containers.Dataset_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.containers.Dataset_annotationLinks";
    public final static String NAME = "ome.model.containers.Dataset_name";
    public final static String DESCRIPTION = "ome.model.containers.Dataset_description";
    public final static String DETAILS = "ome.model.containers.Dataset_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(PROJECTLINKSCOUNTPEROWNER);
       raw.add(PROJECTLINKS);
       raw.add(IMAGELINKSCOUNTPEROWNER);
       raw.add(IMAGELINKS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(PROJECTLINKSCOUNTPEROWNER)) {
            return getProjectLinksCountPerOwner();
        } else if (field.equals(PROJECTLINKS)) { // TODO use == here first??
            return getProjectLinks();
        } else if (field.equals(IMAGELINKSCOUNTPEROWNER)) {
            return getImageLinksCountPerOwner();
        } else if (field.equals(IMAGELINKS)) { // TODO use == here first??
            return getImageLinks();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(NAME)) { // TODO use == here first??
            return getName();
        } else if (field.equals(DESCRIPTION)) { // TODO use == here first??
            return getDescription();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(PROJECTLINKSCOUNTPEROWNER)) {
            setProjectLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(PROJECTLINKS)) {
            setProjectLinks((java.util.Set<ome.model.containers.ProjectDatasetLink>)value);
        } else if (field.equals(IMAGELINKSCOUNTPEROWNER)) {
            setImageLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(IMAGELINKS)) {
            setImageLinks((java.util.Set<ome.model.containers.DatasetImageLink>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.DatasetAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.projectLinksCountPerOwner = null;
        this.projectLinks = null;
        this.imageLinksCountPerOwner = null;
        this.imageLinks = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKdataset_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdataset_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKdataset_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdataset_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdataset_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
