

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.core;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="image_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="image_owner_filter_PIXELS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter_PIXELS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter_PIXELS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter_PIXELS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="image_owner_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="image_owner_filter_ROIS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter_ROIS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter_ROIS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter_ROIS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="image_owner_filter_DATASETLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter_DATASETLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter_DATASETLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter_DATASETLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="image_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="image_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="image_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="image_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="image_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="image_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "image", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_image",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_image"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Image
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "image_owner_filter";
    public final static String GROUP_FILTER = "image_group_filter";
    public final static String EVENT_FILTER = "image_event_filter";
    public final static String PERMS_FILTER = "image_perms_filter";

    public Image () {
        this(null, true);
    }

    protected Image (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Image (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Image(
java.sql.Timestamp _acquisitionDate,java.lang.String _name    ) {
        this(null, true);
        setAcquisitionDate(_acquisitionDate);
        setName(_name);
    }

    public final static String ID = "ome.model.core.Image_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_image") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.core.Image_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.sql.Timestamp acquisitionDate = null;

   /**
    * Simple field ome.model.core.Image.acquisitionDate (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="acquisitionDate", updatable=true)
    public java.sql.Timestamp getAcquisitionDate() {
        if (! _loaded ) errorIfUnloaded();
        return this.acquisitionDate;
    }

    public void setAcquisitionDate(java.sql.Timestamp acquisitionDate) {
        if (! _loaded ) errorIfUnloaded();
        this.acquisitionDate = (java.sql.Timestamp) acquisitionDate;
    }
    protected java.lang.Boolean archived = null;

   /**
    * Simple field ome.model.core.Image.archived (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="archived", updatable=true)
    public java.lang.Boolean getArchived() {
        if (! _loaded ) errorIfUnloaded();
        return this.archived;
    }

    public void setArchived(java.lang.Boolean archived) {
        if (! _loaded ) errorIfUnloaded();
        this.archived = (java.lang.Boolean) archived;
    }
    protected java.lang.Boolean partial = null;

   /**
    * Simple field ome.model.core.Image.partial (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="partial", updatable=true)
    public java.lang.Boolean getPartial() {
        if (! _loaded ) errorIfUnloaded();
        return this.partial;
    }

    public void setPartial(java.lang.Boolean partial) {
        if (! _loaded ) errorIfUnloaded();
        this.partial = (java.lang.Boolean) partial;
    }
    protected ome.model.enums.Format format = null;

   /**
    * Many-to-one field ome.model.core.Image.format (ome.model.enums.Format)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Format.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="format", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_format_format")
    public ome.model.enums.Format getFormat() {
        if (! _loaded ) errorIfUnloaded();
        return this.format;
    }

    public void setFormat(ome.model.enums.Format format) {
        if (! _loaded ) errorIfUnloaded();
        this.format = format;
    }
    protected ome.model.acquisition.ImagingEnvironment imagingEnvironment = null;

   /**
    * Many-to-one field ome.model.core.Image.imagingEnvironment (ome.model.acquisition.ImagingEnvironment)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.ImagingEnvironment.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="imagingEnvironment", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_imagingEnvironment_imagingenvironment")
    public ome.model.acquisition.ImagingEnvironment getImagingEnvironment() {
        if (! _loaded ) errorIfUnloaded();
        return this.imagingEnvironment;
    }

    public void setImagingEnvironment(ome.model.acquisition.ImagingEnvironment imagingEnvironment) {
        if (! _loaded ) errorIfUnloaded();
        this.imagingEnvironment = imagingEnvironment;
    }
    protected ome.model.acquisition.ObjectiveSettings objectiveSettings = null;

   /**
    * Many-to-one field ome.model.core.Image.objectiveSettings (ome.model.acquisition.ObjectiveSettings)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.ObjectiveSettings.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="objectiveSettings", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_objectiveSettings_objectivesettings")
    public ome.model.acquisition.ObjectiveSettings getObjectiveSettings() {
        if (! _loaded ) errorIfUnloaded();
        return this.objectiveSettings;
    }

    public void setObjectiveSettings(ome.model.acquisition.ObjectiveSettings objectiveSettings) {
        if (! _loaded ) errorIfUnloaded();
        this.objectiveSettings = objectiveSettings;
    }
    protected ome.model.acquisition.Instrument instrument = null;

   /**
    * Many-to-one field ome.model.core.Image.instrument (ome.model.acquisition.Instrument)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Instrument.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="instrument", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_instrument_instrument")
    public ome.model.acquisition.Instrument getInstrument() {
        if (! _loaded ) errorIfUnloaded();
        return this.instrument;
    }

    public void setInstrument(ome.model.acquisition.Instrument instrument) {
        if (! _loaded ) errorIfUnloaded();
        this.instrument = instrument;
    }
    protected ome.model.acquisition.StageLabel stageLabel = null;

   /**
    * Many-to-one field ome.model.core.Image.stageLabel (ome.model.acquisition.StageLabel)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.StageLabel.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="stageLabel", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_stageLabel_stagelabel")
    public ome.model.acquisition.StageLabel getStageLabel() {
        if (! _loaded ) errorIfUnloaded();
        return this.stageLabel;
    }

    public void setStageLabel(ome.model.acquisition.StageLabel stageLabel) {
        if (! _loaded ) errorIfUnloaded();
        this.stageLabel = stageLabel;
    }
    protected ome.model.experiment.Experiment experiment = null;

   /**
    * Many-to-one field ome.model.core.Image.experiment (ome.model.experiment.Experiment)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.experiment.Experiment.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="experiment", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_experiment_experiment")
    public ome.model.experiment.Experiment getExperiment() {
        if (! _loaded ) errorIfUnloaded();
        return this.experiment;
    }

    public void setExperiment(ome.model.experiment.Experiment experiment) {
        if (! _loaded ) errorIfUnloaded();
        this.experiment = experiment;
    }
    protected java.util.List<ome.model.core.Pixels> pixels = new java.util.ArrayList<ome.model.core.Pixels>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_PIXELS = "image_owner_filter_PIXELS";
    public final static String GROUP_FILTER_PIXELS = "image_group_filter_PIXELS";
    public final static String EVENT_FILTER_PIXELS = "image_event_filter_PIXELS";
    public final static String PERMS_FILTER_PIXELS = "image_perms_filter_PIXELS";

   /**
    * returns pixels . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.core.Image.pixels (ome.model.core.Pixels)
    * Values are indexed by the column "index" on ome.model.core.Pixels
    */
    @javax.persistence.JoinColumn(name="image", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="image_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_PIXELS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_PIXELS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_PIXELS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_PIXELS, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.core.Pixels> getPixels() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixels;
    }

    /**
     * setter for pixels should be avoided. Does not fulfill normal semantics.
     */
    protected void setPixels(java.util.List<ome.model.core.Pixels> pixels) {
        if (! _loaded ) errorIfUnloaded();
        this.pixels = pixels;
    }
    /**
     * returns the size of pixels. If less than zero, the Set was null.
     */
    public int sizeOfPixels() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixels == null ? -1 : this.pixels.size();
    }

    /**
     * should be used rather than accessing the pixels set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfPixels()} is less than zero.
     */
    public java.util.Iterator<ome.model.core.Pixels> iteratePixels() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixels() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.Pixels>();
        }
        return getPixels().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.core.Pixels> unmodifiablePixels() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixels() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getPixels() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.core.Pixels while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iteratePixels} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectPixels(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.Pixels> it = iteratePixels();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setPixels . Makes the necessary
     * call on ome.model.core.Pixels as well.
     */
    public void addPixels(ome.model.core.Pixels target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        getPixels().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setImage ( this );
             }
         }
    }

    /**
     * use like addPixels.
     */
    public void addPixelsSet(java.util.Collection<ome.model.core.Pixels> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
           throwNullCollectionException("Pixels");
        }
        getPixels().addAll( targets );
        java.util.Iterator<ome.model.core.Pixels> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.Pixels target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setImage ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.core.Pixels
     */
    public void removePixels(ome.model.core.Pixels target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        getPixels().remove( target );
        if (target.isLoaded()) {
            target.setImage ( null );
        }
    }

    /**
     * use like removePixels
     */
    public void removePixelsSet(java.util.Collection<ome.model.core.Pixels> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        getPixels().removeAll( targets );
        java.util.Iterator<ome.model.core.Pixels> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.Pixels target = it.next();
            if (target.isLoaded()) {
                target.setImage ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearPixels() {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        getPixels().clear();
        java.util.Iterator<ome.model.core.Pixels> it = iteratePixels();
        while (it.hasNext()) {
            ome.model.core.Pixels target = it.next();
            target.setImage ( null );
        }
    }


    /**
     * Gets the ome.model.core.Pixels at the given index.
     */
    public ome.model.core.Pixels getPixels(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        return getPixels().get(index);
    }

    /**
     * Sets the ome.model.core.Pixels at the given index. Adheres to the {@link List#set(int ,E))}
     * contract. To extend the list, use {@link #addPixels()}.
     * @see java.util.List#set(int, E)
     */
    public ome.model.core.Pixels setPixels(int index, ome.model.core.Pixels element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }

        ome.model.core.Pixels old = getPixels().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setImage ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of pixels which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfPixels()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.core.Pixels getPrimaryPixels()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        return getPixels().get(0);
    }

    /**
     * Swaps the first element of pixels with the first instance of the 
     * given element. If the given element is not in the list, an 
     * {@link IndexOutBoundException} will be thrown. Returns the swapped 
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfPixels()} for more information.
     */
    public ome.model.core.Pixels setPrimaryPixels(ome.model.core.Pixels element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getPixels() == null) {
            throwNullCollectionException("Pixels");
        }
        java.util.List<ome.model.core.Pixels> list = getPixels();
        int index = list.indexOf(element);
        ome.model.core.Pixels old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected java.util.Set<ome.model.screen.WellSample> wellSamples = new java.util.HashSet<ome.model.screen.WellSample>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_WELLSAMPLES = "image_owner_filter_WELLSAMPLES";
    public final static String GROUP_FILTER_WELLSAMPLES = "image_group_filter_WELLSAMPLES";
    public final static String EVENT_FILTER_WELLSAMPLES = "image_event_filter_WELLSAMPLES";
    public final static String PERMS_FILTER_WELLSAMPLES = "image_perms_filter_WELLSAMPLES";

   /**
    * returns wellSamples . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.Image.wellSamples (ome.model.screen.WellSample)
    */
    @javax.persistence.OneToMany(mappedBy="image", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_WELLSAMPLES, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_WELLSAMPLES, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_WELLSAMPLES, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_WELLSAMPLES, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.WellSample> getWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellSamples;
    }

    /**
     * setter for wellSamples should be avoided. Does not fulfill normal semantics.
     */
    protected void setWellSamples(java.util.Set<ome.model.screen.WellSample> wellSamples) {
        if (! _loaded ) errorIfUnloaded();
        this.wellSamples = wellSamples;
    }
    /**
     * returns the size of wellSamples. If less than zero, the Set was null.
     */
    public int sizeOfWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellSamples == null ? -1 : this.wellSamples.size();
    }

    /**
     * should be used rather than accessing the wellSamples set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfWellSamples()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.WellSample> iterateWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellSamples() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.WellSample>();
        }
        return getWellSamples().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.WellSample> unmodifiableWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellSamples() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getWellSamples() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.WellSample while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateWellSamples} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectWellSamples(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.WellSample> it = iterateWellSamples();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setWellSamples . Makes the necessary
     * call on ome.model.screen.WellSample as well.
     */
    public void addWellSample(ome.model.screen.WellSample target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setImage ( this );
         }
    }

    /**
     * use like addWellSample.
     */
    public void addWellSampleSet(java.util.Collection<ome.model.screen.WellSample> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
           throwNullCollectionException("WellSamples");
        }
        getWellSamples().addAll( targets );
        java.util.Iterator<ome.model.screen.WellSample> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellSample target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setImage ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.WellSample
     */
    public void removeWellSample(ome.model.screen.WellSample target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().remove( target );
            target.setImage ( null );
    }

    /**
     * use like removeWellSample
     */
    public void removeWellSampleSet(java.util.Collection<ome.model.screen.WellSample> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().removeAll( targets );
        java.util.Iterator<ome.model.screen.WellSample> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellSample target = it.next();
                target.setImage ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().clear();
        java.util.Iterator<ome.model.screen.WellSample> it = iterateWellSamples();
        while (it.hasNext()) {
            ome.model.screen.WellSample target = it.next();
            target.setImage ( null );
        }
    }


    protected java.util.Set<ome.model.roi.Roi> rois = new java.util.HashSet<ome.model.roi.Roi>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ROIS = "image_owner_filter_ROIS";
    public final static String GROUP_FILTER_ROIS = "image_group_filter_ROIS";
    public final static String EVENT_FILTER_ROIS = "image_event_filter_ROIS";
    public final static String PERMS_FILTER_ROIS = "image_perms_filter_ROIS";

   /**
    * returns rois . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.Image.rois (ome.model.roi.Roi)
    */
    @javax.persistence.OneToMany(mappedBy="image", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ROIS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ROIS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ROIS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ROIS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.roi.Roi> getRois() {
        if (! _loaded ) errorIfUnloaded();
        return this.rois;
    }

    /**
     * setter for rois should be avoided. Does not fulfill normal semantics.
     */
    protected void setRois(java.util.Set<ome.model.roi.Roi> rois) {
        if (! _loaded ) errorIfUnloaded();
        this.rois = rois;
    }
    /**
     * returns the size of rois. If less than zero, the Set was null.
     */
    public int sizeOfRois() {
        if (! _loaded ) errorIfUnloaded();
        return this.rois == null ? -1 : this.rois.size();
    }

    /**
     * should be used rather than accessing the rois set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfRois()} is less than zero.
     */
    public java.util.Iterator<ome.model.roi.Roi> iterateRois() {
        if (! _loaded ) errorIfUnloaded();
        if ( getRois() == null ) {
            return new ome.util.EmptyIterator<ome.model.roi.Roi>();
        }
        return getRois().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.roi.Roi> unmodifiableRois() {
        if (! _loaded ) errorIfUnloaded();
        if ( getRois() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getRois() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.roi.Roi while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateRois} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectRois(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.roi.Roi> it = iterateRois();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setRois . Makes the necessary
     * call on ome.model.roi.Roi as well.
     */
    public void addRoi(ome.model.roi.Roi target) {
        if (! _loaded ) errorIfUnloaded();
        if (getRois() == null) {
            throwNullCollectionException("Rois");
        }
        getRois().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setImage ( this );
         }
    }

    /**
     * use like addRoi.
     */
    public void addRoiSet(java.util.Collection<ome.model.roi.Roi> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getRois() == null) {
           throwNullCollectionException("Rois");
        }
        getRois().addAll( targets );
        java.util.Iterator<ome.model.roi.Roi> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.roi.Roi target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setImage ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.roi.Roi
     */
    public void removeRoi(ome.model.roi.Roi target) {
        if (! _loaded ) errorIfUnloaded();
        if (getRois() == null) {
            throwNullCollectionException("Rois");
        }
        getRois().remove( target );
            target.setImage ( null );
    }

    /**
     * use like removeRoi
     */
    public void removeRoiSet(java.util.Collection<ome.model.roi.Roi> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getRois() == null) {
            throwNullCollectionException("Rois");
        }
        getRois().removeAll( targets );
        java.util.Iterator<ome.model.roi.Roi> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.roi.Roi target = it.next();
                target.setImage ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearRois() {
        if (! _loaded ) errorIfUnloaded();
        if (getRois() == null) {
            throwNullCollectionException("Rois");
        }
        getRois().clear();
        java.util.Iterator<ome.model.roi.Roi> it = iterateRois();
        while (it.hasNext()) {
            ome.model.roi.Roi target = it.next();
            target.setImage ( null );
        }
    }


    protected java.util.Set<ome.model.containers.DatasetImageLink> datasetLinks = new java.util.HashSet<ome.model.containers.DatasetImageLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_DATASETLINKS = "image_owner_filter_DATASETLINKS";
    public final static String GROUP_FILTER_DATASETLINKS = "image_group_filter_DATASETLINKS";
    public final static String EVENT_FILTER_DATASETLINKS = "image_event_filter_DATASETLINKS";
    public final static String PERMS_FILTER_DATASETLINKS = "image_perms_filter_DATASETLINKS";

   /**
    * returns datasetLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.Image.datasetLinks (ome.model.containers.DatasetImageLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_DATASETLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_DATASETLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_DATASETLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_DATASETLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.DatasetImageLink> getDatasetLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.datasetLinks;
    }

    /**
     * setter for datasetLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setDatasetLinks(java.util.Set<ome.model.containers.DatasetImageLink> datasetLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.datasetLinks = datasetLinks;
    }
    /**
     * returns the size of datasetLinks. If less than zero, the Set was null.
     */
    public int sizeOfDatasetLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.datasetLinks == null ? -1 : this.datasetLinks.size();
    }

    /**
     * should be used rather than accessing the datasetLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfDatasetLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.DatasetImageLink> iterateDatasetLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getDatasetLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.DatasetImageLink>();
        }
        return getDatasetLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.containers.DatasetImageLink> unmodifiableDatasetLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getDatasetLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getDatasetLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.containers.DatasetImageLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateDatasetLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectDatasetLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = iterateDatasetLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setDatasetLinks . Makes the necessary
     * call on ome.model.containers.DatasetImageLink as well.
     */
    public void addDatasetImageLink(ome.model.containers.DatasetImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getDatasetLinks() == null) {
            throwNullCollectionException("DatasetLinks");
        }
        getDatasetLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addDatasetImageLink.
     */
    public void addDatasetImageLinkSet(java.util.Collection<ome.model.containers.DatasetImageLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getDatasetLinks() == null) {
           throwNullCollectionException("DatasetLinks");
        }
        getDatasetLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.DatasetImageLink
     */
    public void removeDatasetImageLink(ome.model.containers.DatasetImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getDatasetLinks() == null) {
            throwNullCollectionException("DatasetLinks");
        }
        getDatasetLinks().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeDatasetImageLink
     */
    public void removeDatasetImageLinkSet(java.util.Collection<ome.model.containers.DatasetImageLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getDatasetLinks() == null) {
            throwNullCollectionException("DatasetLinks");
        }
        getDatasetLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.containers.DatasetImageLink to datasetLinks . This entails changing our datasetLinks Set,
     * creating a new ome.model.containers.DatasetImageLink and calling linkDataset on the ome.model.containers.Dataset.
     */
    public ome.model.containers.DatasetImageLink linkDataset (ome.model.containers.Dataset addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.DatasetImageLink link = new ome.model.containers.DatasetImageLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addDatasetImageLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.DatasetImageLink to datasetLinks, allowing for recursion -- whether
     * or not addDatasetImageLink will be called on the addition <b>if it is loaded</b>
     */
    public void addDatasetImageLink (ome.model.containers.DatasetImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getDatasetLinks() == null ) {
            throwNullCollectionException("DatasetLinks");
        }
        getDatasetLinks().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addDatasetImageLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the datasetLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedDatasetList()} instead.
     */
     public java.util.Iterator<ome.model.containers.Dataset> linkedDatasetIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getDatasetLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.Dataset>();
        }

        final java.util.Iterator<ome.model.containers.DatasetImageLink> it = getDatasetLinks().iterator();
        return new java.util.Iterator<ome.model.containers.Dataset>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.containers.Dataset next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "datasetLinks is null; no elements." );
                }
                ome.model.containers.DatasetImageLink link = (ome.model.containers.DatasetImageLink) it.next();
                return link.parent();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.DatasetImageLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.containers.DatasetImageLink> findDatasetImageLink( ome.model.containers.Dataset target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.DatasetImageLink> it = iterateDatasetLinks();
        final java.util.Set<ome.model.containers.DatasetImageLink> result = new java.util.HashSet<ome.model.containers.DatasetImageLink>();
        while ( it.hasNext() ) {
            ome.model.containers.DatasetImageLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedDatasetIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.containers.Dataset> linkedDatasetList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.containers.Dataset> it = linkedDatasetIterator();
        java.util.List<ome.model.containers.Dataset> list = new java.util.ArrayList<ome.model.containers.Dataset>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.Dataset while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedDataset(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.Dataset> it = linkedDatasetIterator();
        while ( it.hasNext() ) {
            ome.model.containers.Dataset obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.containers.Dataset instances from this instance.
     */
    public void unlinkDataset (ome.model.containers.Dataset removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.DatasetImageLink> toRemove = findDatasetImageLink( removal );
        java.util.Iterator<ome.model.containers.DatasetImageLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeDatasetImageLink( it.next(), true );
        }
    }

    /**
     * removes the given DatasetImageLink from datasetLinks, allowing for recursion -- whether
     * or not the removal will call unlinkImage again <b>if loaded</b>.
     */
    public void removeDatasetImageLink (ome.model.containers.DatasetImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getDatasetLinks() == null ) {
            throwNullCollectionException("DatasetLinks");
        }

        getDatasetLinks().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeDatasetImageLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearDatasetLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.DatasetImageLink> list = new java.util.ArrayList<ome.model.containers.DatasetImageLink>( getDatasetLinks() );
        for (ome.model.containers.DatasetImageLink link : list) {
            removeDatasetImageLink( link, true );
        }
    }

    private java.util.Map<Long, Long> datasetLinksCountPerOwner = null;

    protected void setDatasetLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.datasetLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Image_datasetLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.DatasetImageLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Image_datasetLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Image_datasetLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Image_id"))
    public java.util.Map<Long, Long> getDatasetLinksCountPerOwner() {
        return this.datasetLinksCountPerOwner;
    }

    protected ome.model.fs.Fileset fileset = null;

   /**
    * Many-to-one field ome.model.core.Image.fileset (ome.model.fs.Fileset)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.fs.Fileset.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="fileset", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKimage_fileset_fileset")
    public ome.model.fs.Fileset getFileset() {
        if (! _loaded ) errorIfUnloaded();
        return this.fileset;
    }

    public void setFileset(ome.model.fs.Fileset fileset) {
        if (! _loaded ) errorIfUnloaded();
        this.fileset = fileset;
    }
    protected java.util.Set<ome.model.annotations.ImageAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.ImageAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "image_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "image_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "image_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "image_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.Image.annotationLinks (ome.model.annotations.ImageAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.ImageAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.ImageAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.ImageAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.ImageAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.ImageAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.ImageAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.ImageAnnotationLink as well.
     */
    public void addImageAnnotationLink(ome.model.annotations.ImageAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addImageAnnotationLink.
     */
    public void addImageAnnotationLinkSet(java.util.Collection<ome.model.annotations.ImageAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ImageAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.ImageAnnotationLink
     */
    public void removeImageAnnotationLink(ome.model.annotations.ImageAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeImageAnnotationLink
     */
    public void removeImageAnnotationLinkSet(java.util.Collection<ome.model.annotations.ImageAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ImageAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.ImageAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.ImageAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.ImageAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.ImageAnnotationLink link = new ome.model.annotations.ImageAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addImageAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.ImageAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addImageAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addImageAnnotationLink (ome.model.annotations.ImageAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.ImageAnnotationLink link = (ome.model.annotations.ImageAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.ImageAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.ImageAnnotationLink> findImageAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.ImageAnnotationLink> result = new java.util.HashSet<ome.model.annotations.ImageAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.ImageAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.ImageAnnotationLink> toRemove = findImageAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.ImageAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeImageAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given ImageAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkImage again <b>if loaded</b>.
     */
    public void removeImageAnnotationLink (ome.model.annotations.ImageAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.ImageAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.ImageAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.ImageAnnotationLink link : list) {
            removeImageAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Image_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.ImageAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Image_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Image_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Image_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.core.Image.name (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.core.Image.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.core.Image newInstance() 
    {
        return new ome.model.core.Image();
    }

    public ome.model.core.Image proxy() {
        return new ome.model.core.Image(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.acquisitionDate = (java.sql.Timestamp) __filter.filter(ACQUISITIONDATE, this.acquisitionDate );
            this.archived = (java.lang.Boolean) __filter.filter(ARCHIVED, this.archived );
            this.partial = (java.lang.Boolean) __filter.filter(PARTIAL, this.partial );
            this.format = (ome.model.enums.Format) __filter.filter(FORMAT, this.format );
            this.imagingEnvironment = (ome.model.acquisition.ImagingEnvironment) __filter.filter(IMAGINGENVIRONMENT, this.imagingEnvironment );
            this.objectiveSettings = (ome.model.acquisition.ObjectiveSettings) __filter.filter(OBJECTIVESETTINGS, this.objectiveSettings );
            this.instrument = (ome.model.acquisition.Instrument) __filter.filter(INSTRUMENT, this.instrument );
            this.stageLabel = (ome.model.acquisition.StageLabel) __filter.filter(STAGELABEL, this.stageLabel );
            this.experiment = (ome.model.experiment.Experiment) __filter.filter(EXPERIMENT, this.experiment );
            this.pixels = (java.util.List<ome.model.core.Pixels>) __filter.filter(PIXELS, this.pixels );
            this.wellSamples = (java.util.Set<ome.model.screen.WellSample>) __filter.filter(WELLSAMPLES, this.wellSamples );
            this.rois = (java.util.Set<ome.model.roi.Roi>) __filter.filter(ROIS, this.rois );
            this.datasetLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(DATASETLINKSCOUNTPEROWNER, this.datasetLinksCountPerOwner );
            this.datasetLinks = (java.util.Set<ome.model.containers.DatasetImageLink>) __filter.filter(DATASETLINKS, this.datasetLinks );
            this.fileset = (ome.model.fs.Fileset) __filter.filter(FILESET, this.fileset );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.ImageAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.core.Image.FIELDS;
    }
  
    public final static String ACQUISITIONDATE = "ome.model.core.Image_acquisitionDate";
    public final static String ARCHIVED = "ome.model.core.Image_archived";
    public final static String PARTIAL = "ome.model.core.Image_partial";
    public final static String FORMAT = "ome.model.core.Image_format";
    public final static String IMAGINGENVIRONMENT = "ome.model.core.Image_imagingEnvironment";
    public final static String OBJECTIVESETTINGS = "ome.model.core.Image_objectiveSettings";
    public final static String INSTRUMENT = "ome.model.core.Image_instrument";
    public final static String STAGELABEL = "ome.model.core.Image_stageLabel";
    public final static String EXPERIMENT = "ome.model.core.Image_experiment";
    public final static String PIXELS = "ome.model.core.Image_pixels";
    public final static String WELLSAMPLES = "ome.model.core.Image_wellSamples";
    public final static String ROIS = "ome.model.core.Image_rois";
    public final static String DATASETLINKSCOUNTPEROWNER = "ome.model.core.Image_datasetLinksCountPerOwner";
    public final static String DATASETLINKS = "ome.model.core.Image_datasetLinks";
    public final static String FILESET = "ome.model.core.Image_fileset";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.core.Image_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.core.Image_annotationLinks";
    public final static String NAME = "ome.model.core.Image_name";
    public final static String DESCRIPTION = "ome.model.core.Image_description";
    public final static String DETAILS = "ome.model.core.Image_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(ACQUISITIONDATE);
       raw.add(ARCHIVED);
       raw.add(PARTIAL);
       raw.add(FORMAT);
       raw.add(IMAGINGENVIRONMENT);
       raw.add(OBJECTIVESETTINGS);
       raw.add(INSTRUMENT);
       raw.add(STAGELABEL);
       raw.add(EXPERIMENT);
       raw.add(PIXELS);
       raw.add(WELLSAMPLES);
       raw.add(ROIS);
       raw.add(DATASETLINKSCOUNTPEROWNER);
       raw.add(DATASETLINKS);
       raw.add(FILESET);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(ACQUISITIONDATE)) { // TODO use == here first??
            return getAcquisitionDate();
        } else if (field.equals(ARCHIVED)) { // TODO use == here first??
            return getArchived();
        } else if (field.equals(PARTIAL)) { // TODO use == here first??
            return getPartial();
        } else if (field.equals(FORMAT)) { // TODO use == here first??
            return getFormat();
        } else if (field.equals(IMAGINGENVIRONMENT)) { // TODO use == here first??
            return getImagingEnvironment();
        } else if (field.equals(OBJECTIVESETTINGS)) { // TODO use == here first??
            return getObjectiveSettings();
        } else if (field.equals(INSTRUMENT)) { // TODO use == here first??
            return getInstrument();
        } else if (field.equals(STAGELABEL)) { // TODO use == here first??
            return getStageLabel();
        } else if (field.equals(EXPERIMENT)) { // TODO use == here first??
            return getExperiment();
        } else if (field.equals(PIXELS)) { // TODO use == here first??
            return getPixels();
        } else if (field.equals(WELLSAMPLES)) { // TODO use == here first??
            return getWellSamples();
        } else if (field.equals(ROIS)) { // TODO use == here first??
            return getRois();
        } else if (field.equals(DATASETLINKSCOUNTPEROWNER)) {
            return getDatasetLinksCountPerOwner();
        } else if (field.equals(DATASETLINKS)) { // TODO use == here first??
            return getDatasetLinks();
        } else if (field.equals(FILESET)) { // TODO use == here first??
            return getFileset();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(NAME)) { // TODO use == here first??
            return getName();
        } else if (field.equals(DESCRIPTION)) { // TODO use == here first??
            return getDescription();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(ACQUISITIONDATE)) {
            setAcquisitionDate((java.sql.Timestamp)value);
        } else if (field.equals(ARCHIVED)) {
            setArchived((java.lang.Boolean)value);
        } else if (field.equals(PARTIAL)) {
            setPartial((java.lang.Boolean)value);
        } else if (field.equals(FORMAT)) {
            setFormat((ome.model.enums.Format)value);
        } else if (field.equals(IMAGINGENVIRONMENT)) {
            setImagingEnvironment((ome.model.acquisition.ImagingEnvironment)value);
        } else if (field.equals(OBJECTIVESETTINGS)) {
            setObjectiveSettings((ome.model.acquisition.ObjectiveSettings)value);
        } else if (field.equals(INSTRUMENT)) {
            setInstrument((ome.model.acquisition.Instrument)value);
        } else if (field.equals(STAGELABEL)) {
            setStageLabel((ome.model.acquisition.StageLabel)value);
        } else if (field.equals(EXPERIMENT)) {
            setExperiment((ome.model.experiment.Experiment)value);
        } else if (field.equals(PIXELS)) {
            setPixels((java.util.List<ome.model.core.Pixels>)value);
        } else if (field.equals(WELLSAMPLES)) {
            setWellSamples((java.util.Set<ome.model.screen.WellSample>)value);
        } else if (field.equals(ROIS)) {
            setRois((java.util.Set<ome.model.roi.Roi>)value);
        } else if (field.equals(DATASETLINKSCOUNTPEROWNER)) {
            setDatasetLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(DATASETLINKS)) {
            setDatasetLinks((java.util.Set<ome.model.containers.DatasetImageLink>)value);
        } else if (field.equals(FILESET)) {
            setFileset((ome.model.fs.Fileset)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.ImageAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.acquisitionDate = null;
        this.archived = null;
        this.partial = null;
        this.format = null;
        this.imagingEnvironment = null;
        this.objectiveSettings = null;
        this.instrument = null;
        this.stageLabel = null;
        this.experiment = null;
        this.pixels = null;
        this.wellSamples = null;
        this.rois = null;
        this.datasetLinksCountPerOwner = null;
        this.datasetLinks = null;
        this.fileset = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKimage_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKimage_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKimage_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKimage_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKimage_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
