

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.display;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="renderingdef_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_owner_filter_WAVERENDERING",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_group_filter_WAVERENDERING",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_event_filter_WAVERENDERING",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_perms_filter_WAVERENDERING",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="renderingdef_owner_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_group_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_event_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="renderingdef_perms_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="renderingdef_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="renderingdef_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="renderingdef_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="renderingdef_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "renderingdef", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_renderingdef",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_renderingdef"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class RenderingDef
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "renderingdef_owner_filter";
    public final static String GROUP_FILTER = "renderingdef_group_filter";
    public final static String EVENT_FILTER = "renderingdef_event_filter";
    public final static String PERMS_FILTER = "renderingdef_perms_filter";

    public RenderingDef () {
        this(null, true);
    }

    protected RenderingDef (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public RenderingDef (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public RenderingDef(
ome.model.core.Pixels _pixels,java.lang.Integer _defaultZ,java.lang.Integer _defaultT,ome.model.enums.RenderingModel _model,ome.model.display.QuantumDef _quantization    ) {
        this(null, true);
        setPixels(_pixels);
        setDefaultZ(_defaultZ);
        setDefaultT(_defaultT);
        setModel(_model);
        setQuantization(_quantization);
    }

    public final static String ID = "ome.model.display.RenderingDef_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_renderingdef") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.display.RenderingDef_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.core.Pixels pixels = null;

   /**
    * Many-to-one field ome.model.display.RenderingDef.pixels (ome.model.core.Pixels)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.core.Pixels.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="pixels", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKrenderingdef_pixels_pixels")
    public ome.model.core.Pixels getPixels() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixels;
    }

    public void setPixels(ome.model.core.Pixels pixels) {
        if (! _loaded ) errorIfUnloaded();
        this.pixels = pixels;
    }
    protected java.lang.Integer defaultZ = null;

   /**
    * Simple field ome.model.display.RenderingDef.defaultZ (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="defaultZ", updatable=true)
    public java.lang.Integer getDefaultZ() {
        if (! _loaded ) errorIfUnloaded();
        return this.defaultZ;
    }

    public void setDefaultZ(java.lang.Integer defaultZ) {
        if (! _loaded ) errorIfUnloaded();
        this.defaultZ = (java.lang.Integer) defaultZ;
    }
    protected java.lang.Integer defaultT = null;

   /**
    * Simple field ome.model.display.RenderingDef.defaultT (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="defaultT", updatable=true)
    public java.lang.Integer getDefaultT() {
        if (! _loaded ) errorIfUnloaded();
        return this.defaultT;
    }

    public void setDefaultT(java.lang.Integer defaultT) {
        if (! _loaded ) errorIfUnloaded();
        this.defaultT = (java.lang.Integer) defaultT;
    }
    protected ome.model.enums.RenderingModel model = null;

   /**
    * Many-to-one field ome.model.display.RenderingDef.model (ome.model.enums.RenderingModel)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.RenderingModel.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="model", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKrenderingdef_model_renderingmodel")
    public ome.model.enums.RenderingModel getModel() {
        if (! _loaded ) errorIfUnloaded();
        return this.model;
    }

    public void setModel(ome.model.enums.RenderingModel model) {
        if (! _loaded ) errorIfUnloaded();
        this.model = model;
    }
    protected java.util.List<ome.model.display.ChannelBinding> waveRendering = new java.util.ArrayList<ome.model.display.ChannelBinding>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_WAVERENDERING = "renderingdef_owner_filter_WAVERENDERING";
    public final static String GROUP_FILTER_WAVERENDERING = "renderingdef_group_filter_WAVERENDERING";
    public final static String EVENT_FILTER_WAVERENDERING = "renderingdef_event_filter_WAVERENDERING";
    public final static String PERMS_FILTER_WAVERENDERING = "renderingdef_perms_filter_WAVERENDERING";

   /**
    * returns waveRendering . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.display.RenderingDef.waveRendering (ome.model.display.ChannelBinding)
    * Values are indexed by the column "index" on ome.model.display.ChannelBinding
    */
    @javax.persistence.JoinColumn(name="renderingDef", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="renderingDef_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_WAVERENDERING, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_WAVERENDERING, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_WAVERENDERING, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_WAVERENDERING, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.display.ChannelBinding> getWaveRendering() {
        if (! _loaded ) errorIfUnloaded();
        return this.waveRendering;
    }

    /**
     * setter for waveRendering should be avoided. Does not fulfill normal semantics.
     */
    protected void setWaveRendering(java.util.List<ome.model.display.ChannelBinding> waveRendering) {
        if (! _loaded ) errorIfUnloaded();
        this.waveRendering = waveRendering;
    }
    /**
     * returns the size of waveRendering. If less than zero, the Set was null.
     */
    public int sizeOfWaveRendering() {
        if (! _loaded ) errorIfUnloaded();
        return this.waveRendering == null ? -1 : this.waveRendering.size();
    }

    /**
     * should be used rather than accessing the waveRendering set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfWaveRendering()} is less than zero.
     */
    public java.util.Iterator<ome.model.display.ChannelBinding> iterateWaveRendering() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWaveRendering() == null ) {
            return new ome.util.EmptyIterator<ome.model.display.ChannelBinding>();
        }
        return getWaveRendering().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.display.ChannelBinding> unmodifiableWaveRendering() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWaveRendering() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getWaveRendering() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.display.ChannelBinding while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateWaveRendering} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectWaveRendering(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.display.ChannelBinding> it = iterateWaveRendering();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setWaveRendering . Makes the necessary
     * call on ome.model.display.ChannelBinding as well.
     */
    public void addChannelBinding(ome.model.display.ChannelBinding target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        getWaveRendering().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setRenderingDef ( this );
             }
         }
    }

    /**
     * use like addChannelBinding.
     */
    public void addChannelBindingSet(java.util.Collection<ome.model.display.ChannelBinding> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
           throwNullCollectionException("WaveRendering");
        }
        getWaveRendering().addAll( targets );
        java.util.Iterator<ome.model.display.ChannelBinding> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.ChannelBinding target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setRenderingDef ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.display.ChannelBinding
     */
    public void removeChannelBinding(ome.model.display.ChannelBinding target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        getWaveRendering().remove( target );
        if (target.isLoaded()) {
            target.setRenderingDef ( null );
        }
    }

    /**
     * use like removeChannelBinding
     */
    public void removeChannelBindingSet(java.util.Collection<ome.model.display.ChannelBinding> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        getWaveRendering().removeAll( targets );
        java.util.Iterator<ome.model.display.ChannelBinding> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.ChannelBinding target = it.next();
            if (target.isLoaded()) {
                target.setRenderingDef ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearWaveRendering() {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        getWaveRendering().clear();
        java.util.Iterator<ome.model.display.ChannelBinding> it = iterateWaveRendering();
        while (it.hasNext()) {
            ome.model.display.ChannelBinding target = it.next();
            target.setRenderingDef ( null );
        }
    }


    /**
     * Gets the ome.model.display.ChannelBinding at the given index.
     */
    public ome.model.display.ChannelBinding getChannelBinding(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        return getWaveRendering().get(index);
    }

    /**
     * Sets the ome.model.display.ChannelBinding at the given index. Adheres to the {@link List#set(int ,E))}
     * contract. To extend the list, use {@link #addChannelBinding()}.
     * @see java.util.List#set(int, E)
     */
    public ome.model.display.ChannelBinding setChannelBinding(int index, ome.model.display.ChannelBinding element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }

        ome.model.display.ChannelBinding old = getWaveRendering().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setRenderingDef ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of waveRendering which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfWaveRendering()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.display.ChannelBinding getPrimaryChannelBinding()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        return getWaveRendering().get(0);
    }

    /**
     * Swaps the first element of waveRendering with the first instance of the 
     * given element. If the given element is not in the list, an 
     * {@link IndexOutBoundException} will be thrown. Returns the swapped 
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfWaveRendering()} for more information.
     */
    public ome.model.display.ChannelBinding setPrimaryChannelBinding(ome.model.display.ChannelBinding element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWaveRendering() == null) {
            throwNullCollectionException("WaveRendering");
        }
        java.util.List<ome.model.display.ChannelBinding> list = getWaveRendering();
        int index = list.indexOf(element);
        ome.model.display.ChannelBinding old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected java.lang.String name = null;

   /**
    * Simple field ome.model.display.RenderingDef.name (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.Double compression = null;

   /**
    * Simple field ome.model.display.RenderingDef.compression (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="compression", updatable=true)
    public java.lang.Double getCompression() {
        if (! _loaded ) errorIfUnloaded();
        return this.compression;
    }

    public void setCompression(java.lang.Double compression) {
        if (! _loaded ) errorIfUnloaded();
        this.compression = (java.lang.Double) compression;
    }
    protected ome.model.display.QuantumDef quantization = null;

   /**
    * Many-to-one field ome.model.display.RenderingDef.quantization (ome.model.display.QuantumDef)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.display.QuantumDef.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="quantization", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKrenderingdef_quantization_quantumdef")
    public ome.model.display.QuantumDef getQuantization() {
        if (! _loaded ) errorIfUnloaded();
        return this.quantization;
    }

    public void setQuantization(ome.model.display.QuantumDef quantization) {
        if (! _loaded ) errorIfUnloaded();
        this.quantization = quantization;
    }
    protected java.util.List<ome.model.display.CodomainMapContext> spatialDomainEnhancement = new java.util.ArrayList<ome.model.display.CodomainMapContext>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_SPATIALDOMAINENHANCEMENT = "renderingdef_owner_filter_SPATIALDOMAINENHANCEMENT";
    public final static String GROUP_FILTER_SPATIALDOMAINENHANCEMENT = "renderingdef_group_filter_SPATIALDOMAINENHANCEMENT";
    public final static String EVENT_FILTER_SPATIALDOMAINENHANCEMENT = "renderingdef_event_filter_SPATIALDOMAINENHANCEMENT";
    public final static String PERMS_FILTER_SPATIALDOMAINENHANCEMENT = "renderingdef_perms_filter_SPATIALDOMAINENHANCEMENT";

   /**
    * returns spatialDomainEnhancement . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.display.RenderingDef.spatialDomainEnhancement (ome.model.display.CodomainMapContext)
    * Values are indexed by the column "index" on ome.model.display.CodomainMapContext
    */
    @javax.persistence.JoinColumn(name="renderingDef", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="renderingDef_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_SPATIALDOMAINENHANCEMENT, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_SPATIALDOMAINENHANCEMENT, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_SPATIALDOMAINENHANCEMENT, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_SPATIALDOMAINENHANCEMENT, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.display.CodomainMapContext> getSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        return this.spatialDomainEnhancement;
    }

    /**
     * setter for spatialDomainEnhancement should be avoided. Does not fulfill normal semantics.
     */
    protected void setSpatialDomainEnhancement(java.util.List<ome.model.display.CodomainMapContext> spatialDomainEnhancement) {
        if (! _loaded ) errorIfUnloaded();
        this.spatialDomainEnhancement = spatialDomainEnhancement;
    }
    /**
     * returns the size of spatialDomainEnhancement. If less than zero, the Set was null.
     */
    public int sizeOfSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        return this.spatialDomainEnhancement == null ? -1 : this.spatialDomainEnhancement.size();
    }

    /**
     * should be used rather than accessing the spatialDomainEnhancement set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfSpatialDomainEnhancement()} is less than zero.
     */
    public java.util.Iterator<ome.model.display.CodomainMapContext> iterateSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if ( getSpatialDomainEnhancement() == null ) {
            return new ome.util.EmptyIterator<ome.model.display.CodomainMapContext>();
        }
        return getSpatialDomainEnhancement().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.display.CodomainMapContext> unmodifiableSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if ( getSpatialDomainEnhancement() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getSpatialDomainEnhancement() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.display.CodomainMapContext while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateSpatialDomainEnhancement} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectSpatialDomainEnhancement(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.display.CodomainMapContext> it = iterateSpatialDomainEnhancement();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setSpatialDomainEnhancement . Makes the necessary
     * call on ome.model.display.CodomainMapContext as well.
     */
    public void addCodomainMapContext(ome.model.display.CodomainMapContext target) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setRenderingDef ( this );
             }
         }
    }

    /**
     * use like addCodomainMapContext.
     */
    public void addCodomainMapContextSet(java.util.Collection<ome.model.display.CodomainMapContext> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
           throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().addAll( targets );
        java.util.Iterator<ome.model.display.CodomainMapContext> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.CodomainMapContext target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setRenderingDef ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.display.CodomainMapContext
     */
    public void removeCodomainMapContext(ome.model.display.CodomainMapContext target) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().remove( target );
        if (target.isLoaded()) {
            target.setRenderingDef ( null );
        }
    }

    /**
     * use like removeCodomainMapContext
     */
    public void removeCodomainMapContextSet(java.util.Collection<ome.model.display.CodomainMapContext> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().removeAll( targets );
        java.util.Iterator<ome.model.display.CodomainMapContext> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.CodomainMapContext target = it.next();
            if (target.isLoaded()) {
                target.setRenderingDef ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().clear();
        java.util.Iterator<ome.model.display.CodomainMapContext> it = iterateSpatialDomainEnhancement();
        while (it.hasNext()) {
            ome.model.display.CodomainMapContext target = it.next();
            target.setRenderingDef ( null );
        }
    }


    /**
     * Gets the ome.model.display.CodomainMapContext at the given index.
     */
    public ome.model.display.CodomainMapContext getCodomainMapContext(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        return getSpatialDomainEnhancement().get(index);
    }

    /**
     * Sets the ome.model.display.CodomainMapContext at the given index. Adheres to the {@link List#set(int ,E))}
     * contract. To extend the list, use {@link #addCodomainMapContext()}.
     * @see java.util.List#set(int, E)
     */
    public ome.model.display.CodomainMapContext setCodomainMapContext(int index, ome.model.display.CodomainMapContext element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }

        ome.model.display.CodomainMapContext old = getSpatialDomainEnhancement().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setRenderingDef ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of spatialDomainEnhancement which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfSpatialDomainEnhancement()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.display.CodomainMapContext getPrimaryCodomainMapContext()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        return getSpatialDomainEnhancement().get(0);
    }

    /**
     * Swaps the first element of spatialDomainEnhancement with the first instance of the 
     * given element. If the given element is not in the list, an 
     * {@link IndexOutBoundException} will be thrown. Returns the swapped 
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfSpatialDomainEnhancement()} for more information.
     */
    public ome.model.display.CodomainMapContext setPrimaryCodomainMapContext(ome.model.display.CodomainMapContext element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        java.util.List<ome.model.display.CodomainMapContext> list = getSpatialDomainEnhancement();
        int index = list.indexOf(element);
        ome.model.display.CodomainMapContext old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.display.RenderingDef newInstance() 
    {
        return new ome.model.display.RenderingDef();
    }

    public ome.model.display.RenderingDef proxy() {
        return new ome.model.display.RenderingDef(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.pixels = (ome.model.core.Pixels) __filter.filter(PIXELS, this.pixels );
            this.defaultZ = (java.lang.Integer) __filter.filter(DEFAULTZ, this.defaultZ );
            this.defaultT = (java.lang.Integer) __filter.filter(DEFAULTT, this.defaultT );
            this.model = (ome.model.enums.RenderingModel) __filter.filter(MODEL, this.model );
            this.waveRendering = (java.util.List<ome.model.display.ChannelBinding>) __filter.filter(WAVERENDERING, this.waveRendering );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.compression = (java.lang.Double) __filter.filter(COMPRESSION, this.compression );
            this.quantization = (ome.model.display.QuantumDef) __filter.filter(QUANTIZATION, this.quantization );
            this.spatialDomainEnhancement = (java.util.List<ome.model.display.CodomainMapContext>) __filter.filter(SPATIALDOMAINENHANCEMENT, this.spatialDomainEnhancement );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.display.RenderingDef.FIELDS;
    }
  
    public final static String PIXELS = "ome.model.display.RenderingDef_pixels";
    public final static String DEFAULTZ = "ome.model.display.RenderingDef_defaultZ";
    public final static String DEFAULTT = "ome.model.display.RenderingDef_defaultT";
    public final static String MODEL = "ome.model.display.RenderingDef_model";
    public final static String WAVERENDERING = "ome.model.display.RenderingDef_waveRendering";
    public final static String NAME = "ome.model.display.RenderingDef_name";
    public final static String COMPRESSION = "ome.model.display.RenderingDef_compression";
    public final static String QUANTIZATION = "ome.model.display.RenderingDef_quantization";
    public final static String SPATIALDOMAINENHANCEMENT = "ome.model.display.RenderingDef_spatialDomainEnhancement";
    public final static String DETAILS = "ome.model.display.RenderingDef_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(PIXELS);
       raw.add(DEFAULTZ);
       raw.add(DEFAULTT);
       raw.add(MODEL);
       raw.add(WAVERENDERING);
       raw.add(NAME);
       raw.add(COMPRESSION);
       raw.add(QUANTIZATION);
       raw.add(SPATIALDOMAINENHANCEMENT);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(PIXELS)) { // TODO use == here first??
            return getPixels();
        } else if (field.equals(DEFAULTZ)) { // TODO use == here first??
            return getDefaultZ();
        } else if (field.equals(DEFAULTT)) { // TODO use == here first??
            return getDefaultT();
        } else if (field.equals(MODEL)) { // TODO use == here first??
            return getModel();
        } else if (field.equals(WAVERENDERING)) { // TODO use == here first??
            return getWaveRendering();
        } else if (field.equals(NAME)) { // TODO use == here first??
            return getName();
        } else if (field.equals(COMPRESSION)) { // TODO use == here first??
            return getCompression();
        } else if (field.equals(QUANTIZATION)) { // TODO use == here first??
            return getQuantization();
        } else if (field.equals(SPATIALDOMAINENHANCEMENT)) { // TODO use == here first??
            return getSpatialDomainEnhancement();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(PIXELS)) {
            setPixels((ome.model.core.Pixels)value);
        } else if (field.equals(DEFAULTZ)) {
            setDefaultZ((java.lang.Integer)value);
        } else if (field.equals(DEFAULTT)) {
            setDefaultT((java.lang.Integer)value);
        } else if (field.equals(MODEL)) {
            setModel((ome.model.enums.RenderingModel)value);
        } else if (field.equals(WAVERENDERING)) {
            setWaveRendering((java.util.List<ome.model.display.ChannelBinding>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(COMPRESSION)) {
            setCompression((java.lang.Double)value);
        } else if (field.equals(QUANTIZATION)) {
            setQuantization((ome.model.display.QuantumDef)value);
        } else if (field.equals(SPATIALDOMAINENHANCEMENT)) {
            setSpatialDomainEnhancement((java.util.List<ome.model.display.CodomainMapContext>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.pixels = null;
        this.defaultZ = null;
        this.defaultT = null;
        this.model = null;
        this.waveRendering = null;
        this.name = null;
        this.compression = null;
        this.quantization = null;
        this.spatialDomainEnhancement = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKrenderingdef_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKrenderingdef_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKrenderingdef_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKrenderingdef_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKrenderingdef_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
