

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.fs;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="filesetversioninfo_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filesetversioninfo_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filesetversioninfo_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filesetversioninfo_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="filesetversioninfo_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="filesetversioninfo_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="filesetversioninfo_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="filesetversioninfo_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "filesetversioninfo", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_filesetversioninfo",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_filesetversioninfo"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class FilesetVersionInfo
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "filesetversioninfo_owner_filter";
    public final static String GROUP_FILTER = "filesetversioninfo_group_filter";
    public final static String EVENT_FILTER = "filesetversioninfo_event_filter";
    public final static String PERMS_FILTER = "filesetversioninfo_perms_filter";

    public FilesetVersionInfo () {
        this(null, true);
    }

    protected FilesetVersionInfo (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public FilesetVersionInfo (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public FilesetVersionInfo(
java.lang.String _bioformatsReader,java.lang.String _bioformatsVersion,java.lang.String _omeroVersion,java.lang.String _osArchitecture,java.lang.String _osName,java.lang.String _osVersion,java.lang.String _locale    ) {
        this(null, true);
        setBioformatsReader(_bioformatsReader);
        setBioformatsVersion(_bioformatsVersion);
        setOmeroVersion(_omeroVersion);
        setOsArchitecture(_osArchitecture);
        setOsName(_osName);
        setOsVersion(_osVersion);
        setLocale(_locale);
    }

    public final static String ID = "ome.model.fs.FilesetVersionInfo_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_filesetversioninfo") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.fs.FilesetVersionInfo_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String bioformatsReader = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.bioformatsReader (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="bioformatsReader", updatable=true)
    public java.lang.String getBioformatsReader() {
        if (! _loaded ) errorIfUnloaded();
        return this.bioformatsReader;
    }

    public void setBioformatsReader(java.lang.String bioformatsReader) {
        if (! _loaded ) errorIfUnloaded();
        this.bioformatsReader = (java.lang.String) bioformatsReader;
    }
    protected java.lang.String bioformatsVersion = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.bioformatsVersion (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="bioformatsVersion", updatable=true)
    public java.lang.String getBioformatsVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.bioformatsVersion;
    }

    public void setBioformatsVersion(java.lang.String bioformatsVersion) {
        if (! _loaded ) errorIfUnloaded();
        this.bioformatsVersion = (java.lang.String) bioformatsVersion;
    }
    protected java.lang.String omeroVersion = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.omeroVersion (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="omeroVersion", updatable=true)
    public java.lang.String getOmeroVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.omeroVersion;
    }

    public void setOmeroVersion(java.lang.String omeroVersion) {
        if (! _loaded ) errorIfUnloaded();
        this.omeroVersion = (java.lang.String) omeroVersion;
    }
    protected java.lang.String osArchitecture = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.osArchitecture (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="osArchitecture", updatable=true)
    public java.lang.String getOsArchitecture() {
        if (! _loaded ) errorIfUnloaded();
        return this.osArchitecture;
    }

    public void setOsArchitecture(java.lang.String osArchitecture) {
        if (! _loaded ) errorIfUnloaded();
        this.osArchitecture = (java.lang.String) osArchitecture;
    }
    protected java.lang.String osName = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.osName (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="osName", updatable=true)
    public java.lang.String getOsName() {
        if (! _loaded ) errorIfUnloaded();
        return this.osName;
    }

    public void setOsName(java.lang.String osName) {
        if (! _loaded ) errorIfUnloaded();
        this.osName = (java.lang.String) osName;
    }
    protected java.lang.String osVersion = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.osVersion (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="osVersion", updatable=true)
    public java.lang.String getOsVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.osVersion;
    }

    public void setOsVersion(java.lang.String osVersion) {
        if (! _loaded ) errorIfUnloaded();
        this.osVersion = (java.lang.String) osVersion;
    }
    protected java.lang.String locale = null;

   /**
    * Simple field ome.model.fs.FilesetVersionInfo.locale (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="locale", updatable=true)
    public java.lang.String getLocale() {
        if (! _loaded ) errorIfUnloaded();
        return this.locale;
    }

    public void setLocale(java.lang.String locale) {
        if (! _loaded ) errorIfUnloaded();
        this.locale = (java.lang.String) locale;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.fs.FilesetVersionInfo newInstance() 
    {
        return new ome.model.fs.FilesetVersionInfo();
    }

    public ome.model.fs.FilesetVersionInfo proxy() {
        return new ome.model.fs.FilesetVersionInfo(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.bioformatsReader = (java.lang.String) __filter.filter(BIOFORMATSREADER, this.bioformatsReader );
            this.bioformatsVersion = (java.lang.String) __filter.filter(BIOFORMATSVERSION, this.bioformatsVersion );
            this.omeroVersion = (java.lang.String) __filter.filter(OMEROVERSION, this.omeroVersion );
            this.osArchitecture = (java.lang.String) __filter.filter(OSARCHITECTURE, this.osArchitecture );
            this.osName = (java.lang.String) __filter.filter(OSNAME, this.osName );
            this.osVersion = (java.lang.String) __filter.filter(OSVERSION, this.osVersion );
            this.locale = (java.lang.String) __filter.filter(LOCALE, this.locale );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.fs.FilesetVersionInfo.FIELDS;
    }
  
    public final static String BIOFORMATSREADER = "ome.model.fs.FilesetVersionInfo_bioformatsReader";
    public final static String BIOFORMATSVERSION = "ome.model.fs.FilesetVersionInfo_bioformatsVersion";
    public final static String OMEROVERSION = "ome.model.fs.FilesetVersionInfo_omeroVersion";
    public final static String OSARCHITECTURE = "ome.model.fs.FilesetVersionInfo_osArchitecture";
    public final static String OSNAME = "ome.model.fs.FilesetVersionInfo_osName";
    public final static String OSVERSION = "ome.model.fs.FilesetVersionInfo_osVersion";
    public final static String LOCALE = "ome.model.fs.FilesetVersionInfo_locale";
    public final static String DETAILS = "ome.model.fs.FilesetVersionInfo_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(BIOFORMATSREADER);
       raw.add(BIOFORMATSVERSION);
       raw.add(OMEROVERSION);
       raw.add(OSARCHITECTURE);
       raw.add(OSNAME);
       raw.add(OSVERSION);
       raw.add(LOCALE);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(BIOFORMATSREADER)) { // TODO use == here first??
            return getBioformatsReader();
        } else if (field.equals(BIOFORMATSVERSION)) { // TODO use == here first??
            return getBioformatsVersion();
        } else if (field.equals(OMEROVERSION)) { // TODO use == here first??
            return getOmeroVersion();
        } else if (field.equals(OSARCHITECTURE)) { // TODO use == here first??
            return getOsArchitecture();
        } else if (field.equals(OSNAME)) { // TODO use == here first??
            return getOsName();
        } else if (field.equals(OSVERSION)) { // TODO use == here first??
            return getOsVersion();
        } else if (field.equals(LOCALE)) { // TODO use == here first??
            return getLocale();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(BIOFORMATSREADER)) {
            setBioformatsReader((java.lang.String)value);
        } else if (field.equals(BIOFORMATSVERSION)) {
            setBioformatsVersion((java.lang.String)value);
        } else if (field.equals(OMEROVERSION)) {
            setOmeroVersion((java.lang.String)value);
        } else if (field.equals(OSARCHITECTURE)) {
            setOsArchitecture((java.lang.String)value);
        } else if (field.equals(OSNAME)) {
            setOsName((java.lang.String)value);
        } else if (field.equals(OSVERSION)) {
            setOsVersion((java.lang.String)value);
        } else if (field.equals(LOCALE)) {
            setLocale((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.bioformatsReader = null;
        this.bioformatsVersion = null;
        this.omeroVersion = null;
        this.osArchitecture = null;
        this.osName = null;
        this.osVersion = null;
        this.locale = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKfilesetversioninfo_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilesetversioninfo_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKfilesetversioninfo_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilesetversioninfo_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilesetversioninfo_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
