

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.jobs;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="job_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="job_owner_filter_ORIGINALFILELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_group_filter_ORIGINALFILELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_event_filter_ORIGINALFILELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="job_perms_filter_ORIGINALFILELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="job_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="job_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="job_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="job_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "job", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_job",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_job"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public abstract class Job
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "job_owner_filter";
    public final static String GROUP_FILTER = "job_group_filter";
    public final static String EVENT_FILTER = "job_event_filter";
    public final static String PERMS_FILTER = "job_perms_filter";

    public Job () {
        this(null, true);
    }

    protected Job (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Job (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Job(
java.lang.String _username,java.lang.String _groupname,java.lang.String _type,java.lang.String _message,ome.model.jobs.JobStatus _status,java.sql.Timestamp _submitted,java.sql.Timestamp _scheduledFor    ) {
        this(null, true);
        setUsername(_username);
        setGroupname(_groupname);
        setType(_type);
        setMessage(_message);
        setStatus(_status);
        setSubmitted(_submitted);
        setScheduledFor(_scheduledFor);
    }

    public final static String ID = "ome.model.jobs.Job_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_job") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.jobs.Job_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String username = null;

   /**
    * Simple field ome.model.jobs.Job.username (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="username", updatable=true)
    public java.lang.String getUsername() {
        if (! _loaded ) errorIfUnloaded();
        return this.username;
    }

    public void setUsername(java.lang.String username) {
        if (! _loaded ) errorIfUnloaded();
        this.username = (java.lang.String) username;
    }
    protected java.lang.String groupname = null;

   /**
    * Simple field ome.model.jobs.Job.groupname (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="groupname", updatable=true)
    public java.lang.String getGroupname() {
        if (! _loaded ) errorIfUnloaded();
        return this.groupname;
    }

    public void setGroupname(java.lang.String groupname) {
        if (! _loaded ) errorIfUnloaded();
        this.groupname = (java.lang.String) groupname;
    }
    protected java.lang.String type = null;

   /**
    * Simple field ome.model.jobs.Job.type (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="type", updatable=true)
    public java.lang.String getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(java.lang.String type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = (java.lang.String) type;
    }
    protected java.lang.String message = null;

   /**
    * Simple field ome.model.jobs.Job.message (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="message", updatable=true)
    public java.lang.String getMessage() {
        if (! _loaded ) errorIfUnloaded();
        return this.message;
    }

    public void setMessage(java.lang.String message) {
        if (! _loaded ) errorIfUnloaded();
        this.message = (java.lang.String) message;
    }
    protected ome.model.jobs.JobStatus status = null;

   /**
    * Many-to-one field ome.model.jobs.Job.status (ome.model.jobs.JobStatus)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.EAGER, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.jobs.JobStatus.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="status", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKjob_status_jobstatus")
    public ome.model.jobs.JobStatus getStatus() {
        if (! _loaded ) errorIfUnloaded();
        return this.status;
    }

    public void setStatus(ome.model.jobs.JobStatus status) {
        if (! _loaded ) errorIfUnloaded();
        this.status = status;
    }
    protected java.sql.Timestamp submitted = null;

   /**
    * Simple field ome.model.jobs.Job.submitted (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="submitted", updatable=true)
    public java.sql.Timestamp getSubmitted() {
        if (! _loaded ) errorIfUnloaded();
        return this.submitted;
    }

    public void setSubmitted(java.sql.Timestamp submitted) {
        if (! _loaded ) errorIfUnloaded();
        this.submitted = (java.sql.Timestamp) submitted;
    }
    protected java.sql.Timestamp scheduledFor = null;

   /**
    * Simple field ome.model.jobs.Job.scheduledFor (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="scheduledFor", updatable=true)
    public java.sql.Timestamp getScheduledFor() {
        if (! _loaded ) errorIfUnloaded();
        return this.scheduledFor;
    }

    public void setScheduledFor(java.sql.Timestamp scheduledFor) {
        if (! _loaded ) errorIfUnloaded();
        this.scheduledFor = (java.sql.Timestamp) scheduledFor;
    }
    protected java.sql.Timestamp started = null;

   /**
    * Simple field ome.model.jobs.Job.started (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="started", updatable=true)
    public java.sql.Timestamp getStarted() {
        if (! _loaded ) errorIfUnloaded();
        return this.started;
    }

    public void setStarted(java.sql.Timestamp started) {
        if (! _loaded ) errorIfUnloaded();
        this.started = (java.sql.Timestamp) started;
    }
    protected java.sql.Timestamp finished = null;

   /**
    * Simple field ome.model.jobs.Job.finished (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="finished", updatable=true)
    public java.sql.Timestamp getFinished() {
        if (! _loaded ) errorIfUnloaded();
        return this.finished;
    }

    public void setFinished(java.sql.Timestamp finished) {
        if (! _loaded ) errorIfUnloaded();
        this.finished = (java.sql.Timestamp) finished;
    }
    protected java.util.Set<ome.model.jobs.JobOriginalFileLink> originalFileLinks = new java.util.HashSet<ome.model.jobs.JobOriginalFileLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ORIGINALFILELINKS = "job_owner_filter_ORIGINALFILELINKS";
    public final static String GROUP_FILTER_ORIGINALFILELINKS = "job_group_filter_ORIGINALFILELINKS";
    public final static String EVENT_FILTER_ORIGINALFILELINKS = "job_event_filter_ORIGINALFILELINKS";
    public final static String PERMS_FILTER_ORIGINALFILELINKS = "job_perms_filter_ORIGINALFILELINKS";

   /**
    * returns originalFileLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.jobs.Job.originalFileLinks (ome.model.jobs.JobOriginalFileLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ORIGINALFILELINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ORIGINALFILELINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ORIGINALFILELINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ORIGINALFILELINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.jobs.JobOriginalFileLink> getOriginalFileLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.originalFileLinks;
    }

    /**
     * setter for originalFileLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setOriginalFileLinks(java.util.Set<ome.model.jobs.JobOriginalFileLink> originalFileLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.originalFileLinks = originalFileLinks;
    }
    /**
     * returns the size of originalFileLinks. If less than zero, the Set was null.
     */
    public int sizeOfOriginalFileLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.originalFileLinks == null ? -1 : this.originalFileLinks.size();
    }

    /**
     * should be used rather than accessing the originalFileLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfOriginalFileLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.jobs.JobOriginalFileLink> iterateOriginalFileLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getOriginalFileLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.jobs.JobOriginalFileLink>();
        }
        return getOriginalFileLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.jobs.JobOriginalFileLink> unmodifiableOriginalFileLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getOriginalFileLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getOriginalFileLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.jobs.JobOriginalFileLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateOriginalFileLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectOriginalFileLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = iterateOriginalFileLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setOriginalFileLinks . Makes the necessary
     * call on ome.model.jobs.JobOriginalFileLink as well.
     */
    public void addJobOriginalFileLink(ome.model.jobs.JobOriginalFileLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getOriginalFileLinks() == null) {
            throwNullCollectionException("OriginalFileLinks");
        }
        getOriginalFileLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addJobOriginalFileLink.
     */
    public void addJobOriginalFileLinkSet(java.util.Collection<ome.model.jobs.JobOriginalFileLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getOriginalFileLinks() == null) {
           throwNullCollectionException("OriginalFileLinks");
        }
        getOriginalFileLinks().addAll( targets );
        java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.jobs.JobOriginalFileLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.jobs.JobOriginalFileLink
     */
    public void removeJobOriginalFileLink(ome.model.jobs.JobOriginalFileLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getOriginalFileLinks() == null) {
            throwNullCollectionException("OriginalFileLinks");
        }
        getOriginalFileLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeJobOriginalFileLink
     */
    public void removeJobOriginalFileLinkSet(java.util.Collection<ome.model.jobs.JobOriginalFileLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getOriginalFileLinks() == null) {
            throwNullCollectionException("OriginalFileLinks");
        }
        getOriginalFileLinks().removeAll( targets );
        java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.jobs.JobOriginalFileLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.jobs.JobOriginalFileLink to originalFileLinks . This entails changing our originalFileLinks Set,
     * creating a new ome.model.jobs.JobOriginalFileLink and calling linkOriginalFile on the ome.model.core.OriginalFile.
     */
    public ome.model.jobs.JobOriginalFileLink linkOriginalFile (ome.model.core.OriginalFile addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.jobs.JobOriginalFileLink link = new ome.model.jobs.JobOriginalFileLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addJobOriginalFileLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.jobs.JobOriginalFileLink to originalFileLinks, allowing for recursion -- whether
     * or not addJobOriginalFileLink will be called on the addition <b>if it is loaded</b>
     */
    public void addJobOriginalFileLink (ome.model.jobs.JobOriginalFileLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getOriginalFileLinks() == null ) {
            throwNullCollectionException("OriginalFileLinks");
        }
        getOriginalFileLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the originalFileLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedOriginalFileList()} instead.
     */
     public java.util.Iterator<ome.model.core.OriginalFile> linkedOriginalFileIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getOriginalFileLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.OriginalFile>();
        }

        final java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = getOriginalFileLinks().iterator();
        return new java.util.Iterator<ome.model.core.OriginalFile>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.core.OriginalFile next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "originalFileLinks is null; no elements." );
                }
                ome.model.jobs.JobOriginalFileLink link = (ome.model.jobs.JobOriginalFileLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.jobs.JobOriginalFileLink which have the argument as their child.
     */
    public java.util.Set<ome.model.jobs.JobOriginalFileLink> findJobOriginalFileLink( ome.model.core.OriginalFile target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = iterateOriginalFileLinks();
        final java.util.Set<ome.model.jobs.JobOriginalFileLink> result = new java.util.HashSet<ome.model.jobs.JobOriginalFileLink>();
        while ( it.hasNext() ) {
            ome.model.jobs.JobOriginalFileLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedOriginalFileIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.core.OriginalFile> linkedOriginalFileList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.core.OriginalFile> it = linkedOriginalFileIterator();
        java.util.List<ome.model.core.OriginalFile> list = new java.util.ArrayList<ome.model.core.OriginalFile>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.OriginalFile while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedOriginalFile(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.OriginalFile> it = linkedOriginalFileIterator();
        while ( it.hasNext() ) {
            ome.model.core.OriginalFile obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.core.OriginalFile instances from this instance.
     */
    public void unlinkOriginalFile (ome.model.core.OriginalFile removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.jobs.JobOriginalFileLink> toRemove = findJobOriginalFileLink( removal );
        java.util.Iterator<ome.model.jobs.JobOriginalFileLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeJobOriginalFileLink( it.next(), true );
        }
    }

    /**
     * removes the given JobOriginalFileLink from originalFileLinks, allowing for recursion -- whether
     * or not the removal will call unlinkJob again <b>if loaded</b>.
     */
    public void removeJobOriginalFileLink (ome.model.jobs.JobOriginalFileLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getOriginalFileLinks() == null ) {
            throwNullCollectionException("OriginalFileLinks");
        }

        getOriginalFileLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearOriginalFileLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.jobs.JobOriginalFileLink> list = new java.util.ArrayList<ome.model.jobs.JobOriginalFileLink>( getOriginalFileLinks() );
        for (ome.model.jobs.JobOriginalFileLink link : list) {
            removeJobOriginalFileLink( link, true );
        }
    }

    private java.util.Map<Long, Long> originalFileLinksCountPerOwner = null;

    protected void setOriginalFileLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.originalFileLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Job_originalFileLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.jobs.JobOriginalFileLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Job_originalFileLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Job_originalFileLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Job_id"))
    public java.util.Map<Long, Long> getOriginalFileLinksCountPerOwner() {
        return this.originalFileLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }


    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.username = (java.lang.String) __filter.filter(USERNAME, this.username );
            this.groupname = (java.lang.String) __filter.filter(GROUPNAME, this.groupname );
            this.type = (java.lang.String) __filter.filter(TYPE, this.type );
            this.message = (java.lang.String) __filter.filter(MESSAGE, this.message );
            this.status = (ome.model.jobs.JobStatus) __filter.filter(STATUS, this.status );
            this.submitted = (java.sql.Timestamp) __filter.filter(SUBMITTED, this.submitted );
            this.scheduledFor = (java.sql.Timestamp) __filter.filter(SCHEDULEDFOR, this.scheduledFor );
            this.started = (java.sql.Timestamp) __filter.filter(STARTED, this.started );
            this.finished = (java.sql.Timestamp) __filter.filter(FINISHED, this.finished );
            this.originalFileLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ORIGINALFILELINKSCOUNTPEROWNER, this.originalFileLinksCountPerOwner );
            this.originalFileLinks = (java.util.Set<ome.model.jobs.JobOriginalFileLink>) __filter.filter(ORIGINALFILELINKS, this.originalFileLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.jobs.Job.FIELDS;
    }
  
    public final static String USERNAME = "ome.model.jobs.Job_username";
    public final static String GROUPNAME = "ome.model.jobs.Job_groupname";
    public final static String TYPE = "ome.model.jobs.Job_type";
    public final static String MESSAGE = "ome.model.jobs.Job_message";
    public final static String STATUS = "ome.model.jobs.Job_status";
    public final static String SUBMITTED = "ome.model.jobs.Job_submitted";
    public final static String SCHEDULEDFOR = "ome.model.jobs.Job_scheduledFor";
    public final static String STARTED = "ome.model.jobs.Job_started";
    public final static String FINISHED = "ome.model.jobs.Job_finished";
    public final static String ORIGINALFILELINKSCOUNTPEROWNER = "ome.model.jobs.Job_originalFileLinksCountPerOwner";
    public final static String ORIGINALFILELINKS = "ome.model.jobs.Job_originalFileLinks";
    public final static String DETAILS = "ome.model.jobs.Job_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(USERNAME);
       raw.add(GROUPNAME);
       raw.add(TYPE);
       raw.add(MESSAGE);
       raw.add(STATUS);
       raw.add(SUBMITTED);
       raw.add(SCHEDULEDFOR);
       raw.add(STARTED);
       raw.add(FINISHED);
       raw.add(ORIGINALFILELINKSCOUNTPEROWNER);
       raw.add(ORIGINALFILELINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(USERNAME)) { // TODO use == here first??
            return getUsername();
        } else if (field.equals(GROUPNAME)) { // TODO use == here first??
            return getGroupname();
        } else if (field.equals(TYPE)) { // TODO use == here first??
            return getType();
        } else if (field.equals(MESSAGE)) { // TODO use == here first??
            return getMessage();
        } else if (field.equals(STATUS)) { // TODO use == here first??
            return getStatus();
        } else if (field.equals(SUBMITTED)) { // TODO use == here first??
            return getSubmitted();
        } else if (field.equals(SCHEDULEDFOR)) { // TODO use == here first??
            return getScheduledFor();
        } else if (field.equals(STARTED)) { // TODO use == here first??
            return getStarted();
        } else if (field.equals(FINISHED)) { // TODO use == here first??
            return getFinished();
        } else if (field.equals(ORIGINALFILELINKSCOUNTPEROWNER)) {
            return getOriginalFileLinksCountPerOwner();
        } else if (field.equals(ORIGINALFILELINKS)) { // TODO use == here first??
            return getOriginalFileLinks();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(USERNAME)) {
            setUsername((java.lang.String)value);
        } else if (field.equals(GROUPNAME)) {
            setGroupname((java.lang.String)value);
        } else if (field.equals(TYPE)) {
            setType((java.lang.String)value);
        } else if (field.equals(MESSAGE)) {
            setMessage((java.lang.String)value);
        } else if (field.equals(STATUS)) {
            setStatus((ome.model.jobs.JobStatus)value);
        } else if (field.equals(SUBMITTED)) {
            setSubmitted((java.sql.Timestamp)value);
        } else if (field.equals(SCHEDULEDFOR)) {
            setScheduledFor((java.sql.Timestamp)value);
        } else if (field.equals(STARTED)) {
            setStarted((java.sql.Timestamp)value);
        } else if (field.equals(FINISHED)) {
            setFinished((java.sql.Timestamp)value);
        } else if (field.equals(ORIGINALFILELINKSCOUNTPEROWNER)) {
            setOriginalFileLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ORIGINALFILELINKS)) {
            setOriginalFileLinks((java.util.Set<ome.model.jobs.JobOriginalFileLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.username = null;
        this.groupname = null;
        this.type = null;
        this.message = null;
        this.status = null;
        this.submitted = null;
        this.scheduledFor = null;
        this.started = null;
        this.finished = null;
        this.originalFileLinksCountPerOwner = null;
        this.originalFileLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKjob_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKjob_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKjob_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKjob_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKjob_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
