

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.jobs;

import ome.conditions.*;
import ome.model.*;

@javax.persistence.Entity
@javax.persistence.PrimaryKeyJoinColumn(name="job_id")
@javax.persistence.Table(name = "scriptjob")
@org.hibernate.annotations.ForeignKey(name="FKscriptjob_job_id_job")
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class ScriptJob
extends ome.model.jobs.Job implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "scriptjob_owner_filter";
    public final static String GROUP_FILTER = "scriptjob_group_filter";
    public final static String EVENT_FILTER = "scriptjob_event_filter";
    public final static String PERMS_FILTER = "scriptjob_perms_filter";

    public ScriptJob () {
        this(null, true);
    }

    protected ScriptJob (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public ScriptJob (Long id, boolean loaded) {
        super(id, loaded);
    }




   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String description = null;

   /**
    * Simple field ome.model.jobs.ScriptJob.description (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }

    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.jobs.ScriptJob newInstance() 
    {
        return new ome.model.jobs.ScriptJob();
    }

    public ome.model.jobs.ScriptJob proxy() {
        return new ome.model.jobs.ScriptJob(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            return super.acceptFilter(__filter);
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.jobs.ScriptJob.FIELDS;
    }
  
    public final static String DESCRIPTION = "ome.model.jobs.ScriptJob_description";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(DESCRIPTION);
       raw.addAll(ome.model.jobs.Job.FIELDS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(DESCRIPTION)) { // TODO use == here first??
            return getDescription();
        } else {
            return super.retrieve(field);
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else {
            super.putAt(field,value);
        }
    }


    public void unload() {
        _loaded = false;
        this.description = null;
        super.unload();
    }




    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


}
