

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.meta;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="namespace_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="namespace_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="namespace_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="namespace_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="namespace_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="namespace_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="namespace_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "namespace", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_namespace",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_namespace"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Namespace
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "namespace_owner_filter";
    public final static String GROUP_FILTER = "namespace_group_filter";
    public final static String EVENT_FILTER = "namespace_event_filter";
    public final static String PERMS_FILTER = "namespace_perms_filter";

    public Namespace () {
        this(null, true);
    }

    protected Namespace (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Namespace (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Namespace(
java.lang.String _name    ) {
        this(null, true);
        setName(_name);
    }

    public final static String ID = "ome.model.meta.Namespace_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_namespace") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.meta.Namespace_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.util.List<String> keywords = null;

   /**
    * Simple field ome.model.meta.Namespace.keywords (java.util.List<String>) 
    */
    @org.hibernate.annotations.Type(type="ome.tools.hibernate.ListAsSQLArrayUserType$STRING", parameters=@org.hibernate.annotations.Parameter(name="profile", value="psql"))
    // Not indexed

    @javax.persistence.Column(columnDefinition="text[]", nullable=true, unique=false, name="keywords", updatable=true)
    public java.util.List<String> getKeywords() {
        if (! _loaded ) errorIfUnloaded();
        return this.keywords;
    }

    public void setKeywords(java.util.List<String> keywords) {
        if (! _loaded ) errorIfUnloaded();
        this.keywords = (java.util.List<String>) keywords;
    }
    protected java.lang.Boolean multivalued = null;

   /**
    * Simple field ome.model.meta.Namespace.multivalued (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="multivalued", updatable=true)
    public java.lang.Boolean getMultivalued() {
        if (! _loaded ) errorIfUnloaded();
        return this.multivalued;
    }

    public void setMultivalued(java.lang.Boolean multivalued) {
        if (! _loaded ) errorIfUnloaded();
        this.multivalued = (java.lang.Boolean) multivalued;
    }
    protected java.lang.Boolean display = null;

   /**
    * Simple field ome.model.meta.Namespace.display (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="display", updatable=true)
    public java.lang.Boolean getDisplay() {
        if (! _loaded ) errorIfUnloaded();
        return this.display;
    }

    public void setDisplay(java.lang.Boolean display) {
        if (! _loaded ) errorIfUnloaded();
        this.display = (java.lang.Boolean) display;
    }
    protected java.util.Set<ome.model.annotations.NamespaceAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.NamespaceAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "namespace_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "namespace_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "namespace_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "namespace_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.meta.Namespace.annotationLinks (ome.model.annotations.NamespaceAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.NamespaceAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.NamespaceAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.NamespaceAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.NamespaceAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.NamespaceAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.NamespaceAnnotationLink as well.
     */
    public void addNamespaceAnnotationLink(ome.model.annotations.NamespaceAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addNamespaceAnnotationLink.
     */
    public void addNamespaceAnnotationLinkSet(java.util.Collection<ome.model.annotations.NamespaceAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.NamespaceAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.NamespaceAnnotationLink
     */
    public void removeNamespaceAnnotationLink(ome.model.annotations.NamespaceAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeNamespaceAnnotationLink
     */
    public void removeNamespaceAnnotationLinkSet(java.util.Collection<ome.model.annotations.NamespaceAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.NamespaceAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.NamespaceAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.NamespaceAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.NamespaceAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.NamespaceAnnotationLink link = new ome.model.annotations.NamespaceAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addNamespaceAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.NamespaceAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addNamespaceAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addNamespaceAnnotationLink (ome.model.annotations.NamespaceAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.NamespaceAnnotationLink link = (ome.model.annotations.NamespaceAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.NamespaceAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.NamespaceAnnotationLink> findNamespaceAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.NamespaceAnnotationLink> result = new java.util.HashSet<ome.model.annotations.NamespaceAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.NamespaceAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.NamespaceAnnotationLink> toRemove = findNamespaceAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.NamespaceAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeNamespaceAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given NamespaceAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkNamespace again <b>if loaded</b>.
     */
    public void removeNamespaceAnnotationLink (ome.model.annotations.NamespaceAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.NamespaceAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.NamespaceAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.NamespaceAnnotationLink link : list) {
            removeNamespaceAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Namespace_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.NamespaceAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Namespace_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Namespace_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Namespace_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.meta.Namespace.name (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.meta.Namespace.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.meta.Namespace newInstance() 
    {
        return new ome.model.meta.Namespace();
    }

    public ome.model.meta.Namespace proxy() {
        return new ome.model.meta.Namespace(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.keywords = (java.util.List<String>) __filter.filter(KEYWORDS, this.keywords );
            this.multivalued = (java.lang.Boolean) __filter.filter(MULTIVALUED, this.multivalued );
            this.display = (java.lang.Boolean) __filter.filter(DISPLAY, this.display );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.NamespaceAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.meta.Namespace.FIELDS;
    }
  
    public final static String KEYWORDS = "ome.model.meta.Namespace_keywords";
    public final static String MULTIVALUED = "ome.model.meta.Namespace_multivalued";
    public final static String DISPLAY = "ome.model.meta.Namespace_display";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.meta.Namespace_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.meta.Namespace_annotationLinks";
    public final static String NAME = "ome.model.meta.Namespace_name";
    public final static String DESCRIPTION = "ome.model.meta.Namespace_description";
    public final static String DETAILS = "ome.model.meta.Namespace_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(KEYWORDS);
       raw.add(MULTIVALUED);
       raw.add(DISPLAY);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(KEYWORDS)) { // TODO use == here first??
            return getKeywords();
        } else if (field.equals(MULTIVALUED)) { // TODO use == here first??
            return getMultivalued();
        } else if (field.equals(DISPLAY)) { // TODO use == here first??
            return getDisplay();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(NAME)) { // TODO use == here first??
            return getName();
        } else if (field.equals(DESCRIPTION)) { // TODO use == here first??
            return getDescription();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(KEYWORDS)) {
            setKeywords((java.util.List<String>)value);
        } else if (field.equals(MULTIVALUED)) {
            setMultivalued((java.lang.Boolean)value);
        } else if (field.equals(DISPLAY)) {
            setDisplay((java.lang.Boolean)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.NamespaceAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.keywords = null;
        this.multivalued = null;
        this.display = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespace_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespace_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespace_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespace_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKnamespace_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
