

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.roi;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="shape_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="shape_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="shape_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="shape_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="shape_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "shape", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"roi","roi_index"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.SINGLE_TABLE)
@javax.persistence.DiscriminatorValue("")
@javax.persistence.DiscriminatorColumn(
    name="discriminator", discriminatorType=javax.persistence.DiscriminatorType.STRING
)
@org.hibernate.annotations.GenericGenerator(name = "seq_shape",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_shape"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public abstract class Shape
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "shape_owner_filter";
    public final static String GROUP_FILTER = "shape_group_filter";
    public final static String EVENT_FILTER = "shape_event_filter";
    public final static String PERMS_FILTER = "shape_perms_filter";

    public Shape () {
        this(null, true);
    }

    protected Shape (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Shape (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Shape(
ome.model.roi.Roi _roi    ) {
        this(null, true);
        setRoi(_roi);
    }

    public final static String ID = "ome.model.roi.Shape_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_shape") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.roi.Shape_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.Integer theZ = null;

   /**
    * Simple field ome.model.roi.Shape.theZ (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theZ", updatable=true)
    public java.lang.Integer getTheZ() {
        if (! _loaded ) errorIfUnloaded();
        return this.theZ;
    }

    public void setTheZ(java.lang.Integer theZ) {
        if (! _loaded ) errorIfUnloaded();
        this.theZ = (java.lang.Integer) theZ;
    }
    protected java.lang.Integer theT = null;

   /**
    * Simple field ome.model.roi.Shape.theT (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theT", updatable=true)
    public java.lang.Integer getTheT() {
        if (! _loaded ) errorIfUnloaded();
        return this.theT;
    }

    public void setTheT(java.lang.Integer theT) {
        if (! _loaded ) errorIfUnloaded();
        this.theT = (java.lang.Integer) theT;
    }
    protected java.lang.Integer theC = null;

   /**
    * Simple field ome.model.roi.Shape.theC (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theC", updatable=true)
    public java.lang.Integer getTheC() {
        if (! _loaded ) errorIfUnloaded();
        return this.theC;
    }

    public void setTheC(java.lang.Integer theC) {
        if (! _loaded ) errorIfUnloaded();
        this.theC = (java.lang.Integer) theC;
    }
    protected ome.model.roi.Roi roi = null;

   /**
    * Many-to-one field ome.model.roi.Shape.roi (ome.model.roi.Roi)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.EAGER, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.roi.Roi.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="roi", nullable=false,
        unique=false, insertable=false, updatable=false)
    @org.hibernate.annotations.ForeignKey(name="FKshape_roi_roi")
    public ome.model.roi.Roi getRoi() {
        if (! _loaded ) errorIfUnloaded();
        return this.roi;
    }

    public void setRoi(ome.model.roi.Roi roi) {
        if (! _loaded ) errorIfUnloaded();
        this.roi = roi;
    }
    protected java.lang.Boolean locked = null;

   /**
    * Simple field ome.model.roi.Shape.locked (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="locked", updatable=true)
    public java.lang.Boolean getLocked() {
        if (! _loaded ) errorIfUnloaded();
        return this.locked;
    }

    public void setLocked(java.lang.Boolean locked) {
        if (! _loaded ) errorIfUnloaded();
        this.locked = (java.lang.Boolean) locked;
    }
    protected java.lang.String g = null;

   /**
    * Simple field ome.model.roi.Shape.g (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="g", updatable=true)
    public java.lang.String getG() {
        if (! _loaded ) errorIfUnloaded();
        return this.g;
    }

    public void setG(java.lang.String g) {
        if (! _loaded ) errorIfUnloaded();
        this.g = (java.lang.String) g;
    }
    protected java.lang.String transform = null;

   /**
    * Simple field ome.model.roi.Shape.transform (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="transform", updatable=true)
    public java.lang.String getTransform() {
        if (! _loaded ) errorIfUnloaded();
        return this.transform;
    }

    public void setTransform(java.lang.String transform) {
        if (! _loaded ) errorIfUnloaded();
        this.transform = (java.lang.String) transform;
    }
    protected java.lang.String vectorEffect = null;

   /**
    * Simple field ome.model.roi.Shape.vectorEffect (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="vectorEffect", updatable=true)
    public java.lang.String getVectorEffect() {
        if (! _loaded ) errorIfUnloaded();
        return this.vectorEffect;
    }

    public void setVectorEffect(java.lang.String vectorEffect) {
        if (! _loaded ) errorIfUnloaded();
        this.vectorEffect = (java.lang.String) vectorEffect;
    }
    protected java.lang.Boolean visibility = null;

   /**
    * Simple field ome.model.roi.Shape.visibility (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="visibility", updatable=true)
    public java.lang.Boolean getVisibility() {
        if (! _loaded ) errorIfUnloaded();
        return this.visibility;
    }

    public void setVisibility(java.lang.Boolean visibility) {
        if (! _loaded ) errorIfUnloaded();
        this.visibility = (java.lang.Boolean) visibility;
    }
    protected java.lang.Integer fillColor = null;

   /**
    * Simple field ome.model.roi.Shape.fillColor (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fillColor", updatable=true)
    public java.lang.Integer getFillColor() {
        if (! _loaded ) errorIfUnloaded();
        return this.fillColor;
    }

    public void setFillColor(java.lang.Integer fillColor) {
        if (! _loaded ) errorIfUnloaded();
        this.fillColor = (java.lang.Integer) fillColor;
    }
    protected java.lang.String fillRule = null;

   /**
    * Simple field ome.model.roi.Shape.fillRule (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fillRule", updatable=true)
    public java.lang.String getFillRule() {
        if (! _loaded ) errorIfUnloaded();
        return this.fillRule;
    }

    public void setFillRule(java.lang.String fillRule) {
        if (! _loaded ) errorIfUnloaded();
        this.fillRule = (java.lang.String) fillRule;
    }
    protected java.lang.Integer strokeColor = null;

   /**
    * Simple field ome.model.roi.Shape.strokeColor (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeColor", updatable=true)
    public java.lang.Integer getStrokeColor() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeColor;
    }

    public void setStrokeColor(java.lang.Integer strokeColor) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeColor = (java.lang.Integer) strokeColor;
    }
    protected java.lang.String strokeDashArray = null;

   /**
    * Simple field ome.model.roi.Shape.strokeDashArray (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeDashArray", updatable=true)
    public java.lang.String getStrokeDashArray() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeDashArray;
    }

    public void setStrokeDashArray(java.lang.String strokeDashArray) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeDashArray = (java.lang.String) strokeDashArray;
    }
    protected java.lang.Integer strokeDashOffset = null;

   /**
    * Simple field ome.model.roi.Shape.strokeDashOffset (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeDashOffset", updatable=true)
    public java.lang.Integer getStrokeDashOffset() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeDashOffset;
    }

    public void setStrokeDashOffset(java.lang.Integer strokeDashOffset) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeDashOffset = (java.lang.Integer) strokeDashOffset;
    }
    protected java.lang.String strokeLineCap = null;

   /**
    * Simple field ome.model.roi.Shape.strokeLineCap (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeLineCap", updatable=true)
    public java.lang.String getStrokeLineCap() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeLineCap;
    }

    public void setStrokeLineCap(java.lang.String strokeLineCap) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeLineCap = (java.lang.String) strokeLineCap;
    }
    protected java.lang.String strokeLineJoin = null;

   /**
    * Simple field ome.model.roi.Shape.strokeLineJoin (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeLineJoin", updatable=true)
    public java.lang.String getStrokeLineJoin() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeLineJoin;
    }

    public void setStrokeLineJoin(java.lang.String strokeLineJoin) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeLineJoin = (java.lang.String) strokeLineJoin;
    }
    protected java.lang.Integer strokeMiterLimit = null;

   /**
    * Simple field ome.model.roi.Shape.strokeMiterLimit (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeMiterLimit", updatable=true)
    public java.lang.Integer getStrokeMiterLimit() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeMiterLimit;
    }

    public void setStrokeMiterLimit(java.lang.Integer strokeMiterLimit) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeMiterLimit = (java.lang.Integer) strokeMiterLimit;
    }
    protected java.lang.Integer strokeWidth = null;

   /**
    * Simple field ome.model.roi.Shape.strokeWidth (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeWidth", updatable=true)
    public java.lang.Integer getStrokeWidth() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeWidth;
    }

    public void setStrokeWidth(java.lang.Integer strokeWidth) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeWidth = (java.lang.Integer) strokeWidth;
    }
    protected java.lang.String fontFamily = null;

   /**
    * Simple field ome.model.roi.Shape.fontFamily (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontFamily", updatable=true)
    public java.lang.String getFontFamily() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontFamily;
    }

    public void setFontFamily(java.lang.String fontFamily) {
        if (! _loaded ) errorIfUnloaded();
        this.fontFamily = (java.lang.String) fontFamily;
    }
    protected java.lang.Integer fontSize = null;

   /**
    * Simple field ome.model.roi.Shape.fontSize (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontSize", updatable=true)
    public java.lang.Integer getFontSize() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontSize;
    }

    public void setFontSize(java.lang.Integer fontSize) {
        if (! _loaded ) errorIfUnloaded();
        this.fontSize = (java.lang.Integer) fontSize;
    }
    protected java.lang.String fontStretch = null;

   /**
    * Simple field ome.model.roi.Shape.fontStretch (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontStretch", updatable=true)
    public java.lang.String getFontStretch() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontStretch;
    }

    public void setFontStretch(java.lang.String fontStretch) {
        if (! _loaded ) errorIfUnloaded();
        this.fontStretch = (java.lang.String) fontStretch;
    }
    protected java.lang.String fontStyle = null;

   /**
    * Simple field ome.model.roi.Shape.fontStyle (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontStyle", updatable=true)
    public java.lang.String getFontStyle() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontStyle;
    }

    public void setFontStyle(java.lang.String fontStyle) {
        if (! _loaded ) errorIfUnloaded();
        this.fontStyle = (java.lang.String) fontStyle;
    }
    protected java.lang.String fontVariant = null;

   /**
    * Simple field ome.model.roi.Shape.fontVariant (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontVariant", updatable=true)
    public java.lang.String getFontVariant() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontVariant;
    }

    public void setFontVariant(java.lang.String fontVariant) {
        if (! _loaded ) errorIfUnloaded();
        this.fontVariant = (java.lang.String) fontVariant;
    }
    protected java.lang.String fontWeight = null;

   /**
    * Simple field ome.model.roi.Shape.fontWeight (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontWeight", updatable=true)
    public java.lang.String getFontWeight() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontWeight;
    }

    public void setFontWeight(java.lang.String fontWeight) {
        if (! _loaded ) errorIfUnloaded();
        this.fontWeight = (java.lang.String) fontWeight;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }


    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.theZ = (java.lang.Integer) __filter.filter(THEZ, this.theZ );
            this.theT = (java.lang.Integer) __filter.filter(THET, this.theT );
            this.theC = (java.lang.Integer) __filter.filter(THEC, this.theC );
            this.roi = (ome.model.roi.Roi) __filter.filter(ROI, this.roi );
            this.locked = (java.lang.Boolean) __filter.filter(LOCKED, this.locked );
            this.g = (java.lang.String) __filter.filter(G, this.g );
            this.transform = (java.lang.String) __filter.filter(TRANSFORM, this.transform );
            this.vectorEffect = (java.lang.String) __filter.filter(VECTOREFFECT, this.vectorEffect );
            this.visibility = (java.lang.Boolean) __filter.filter(VISIBILITY, this.visibility );
            this.fillColor = (java.lang.Integer) __filter.filter(FILLCOLOR, this.fillColor );
            this.fillRule = (java.lang.String) __filter.filter(FILLRULE, this.fillRule );
            this.strokeColor = (java.lang.Integer) __filter.filter(STROKECOLOR, this.strokeColor );
            this.strokeDashArray = (java.lang.String) __filter.filter(STROKEDASHARRAY, this.strokeDashArray );
            this.strokeDashOffset = (java.lang.Integer) __filter.filter(STROKEDASHOFFSET, this.strokeDashOffset );
            this.strokeLineCap = (java.lang.String) __filter.filter(STROKELINECAP, this.strokeLineCap );
            this.strokeLineJoin = (java.lang.String) __filter.filter(STROKELINEJOIN, this.strokeLineJoin );
            this.strokeMiterLimit = (java.lang.Integer) __filter.filter(STROKEMITERLIMIT, this.strokeMiterLimit );
            this.strokeWidth = (java.lang.Integer) __filter.filter(STROKEWIDTH, this.strokeWidth );
            this.fontFamily = (java.lang.String) __filter.filter(FONTFAMILY, this.fontFamily );
            this.fontSize = (java.lang.Integer) __filter.filter(FONTSIZE, this.fontSize );
            this.fontStretch = (java.lang.String) __filter.filter(FONTSTRETCH, this.fontStretch );
            this.fontStyle = (java.lang.String) __filter.filter(FONTSTYLE, this.fontStyle );
            this.fontVariant = (java.lang.String) __filter.filter(FONTVARIANT, this.fontVariant );
            this.fontWeight = (java.lang.String) __filter.filter(FONTWEIGHT, this.fontWeight );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.roi.Shape.FIELDS;
    }
  
    public final static String THEZ = "ome.model.roi.Shape_theZ";
    public final static String THET = "ome.model.roi.Shape_theT";
    public final static String THEC = "ome.model.roi.Shape_theC";
    public final static String ROI = "ome.model.roi.Shape_roi";
    public final static String LOCKED = "ome.model.roi.Shape_locked";
    public final static String G = "ome.model.roi.Shape_g";
    public final static String TRANSFORM = "ome.model.roi.Shape_transform";
    public final static String VECTOREFFECT = "ome.model.roi.Shape_vectorEffect";
    public final static String VISIBILITY = "ome.model.roi.Shape_visibility";
    public final static String FILLCOLOR = "ome.model.roi.Shape_fillColor";
    public final static String FILLRULE = "ome.model.roi.Shape_fillRule";
    public final static String STROKECOLOR = "ome.model.roi.Shape_strokeColor";
    public final static String STROKEDASHARRAY = "ome.model.roi.Shape_strokeDashArray";
    public final static String STROKEDASHOFFSET = "ome.model.roi.Shape_strokeDashOffset";
    public final static String STROKELINECAP = "ome.model.roi.Shape_strokeLineCap";
    public final static String STROKELINEJOIN = "ome.model.roi.Shape_strokeLineJoin";
    public final static String STROKEMITERLIMIT = "ome.model.roi.Shape_strokeMiterLimit";
    public final static String STROKEWIDTH = "ome.model.roi.Shape_strokeWidth";
    public final static String FONTFAMILY = "ome.model.roi.Shape_fontFamily";
    public final static String FONTSIZE = "ome.model.roi.Shape_fontSize";
    public final static String FONTSTRETCH = "ome.model.roi.Shape_fontStretch";
    public final static String FONTSTYLE = "ome.model.roi.Shape_fontStyle";
    public final static String FONTVARIANT = "ome.model.roi.Shape_fontVariant";
    public final static String FONTWEIGHT = "ome.model.roi.Shape_fontWeight";
    public final static String DETAILS = "ome.model.roi.Shape_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(THEZ);
       raw.add(THET);
       raw.add(THEC);
       raw.add(ROI);
       raw.add(LOCKED);
       raw.add(G);
       raw.add(TRANSFORM);
       raw.add(VECTOREFFECT);
       raw.add(VISIBILITY);
       raw.add(FILLCOLOR);
       raw.add(FILLRULE);
       raw.add(STROKECOLOR);
       raw.add(STROKEDASHARRAY);
       raw.add(STROKEDASHOFFSET);
       raw.add(STROKELINECAP);
       raw.add(STROKELINEJOIN);
       raw.add(STROKEMITERLIMIT);
       raw.add(STROKEWIDTH);
       raw.add(FONTFAMILY);
       raw.add(FONTSIZE);
       raw.add(FONTSTRETCH);
       raw.add(FONTSTYLE);
       raw.add(FONTVARIANT);
       raw.add(FONTWEIGHT);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(THEZ)) { // TODO use == here first??
            return getTheZ();
        } else if (field.equals(THET)) { // TODO use == here first??
            return getTheT();
        } else if (field.equals(THEC)) { // TODO use == here first??
            return getTheC();
        } else if (field.equals(ROI)) { // TODO use == here first??
            return getRoi();
        } else if (field.equals(LOCKED)) { // TODO use == here first??
            return getLocked();
        } else if (field.equals(G)) { // TODO use == here first??
            return getG();
        } else if (field.equals(TRANSFORM)) { // TODO use == here first??
            return getTransform();
        } else if (field.equals(VECTOREFFECT)) { // TODO use == here first??
            return getVectorEffect();
        } else if (field.equals(VISIBILITY)) { // TODO use == here first??
            return getVisibility();
        } else if (field.equals(FILLCOLOR)) { // TODO use == here first??
            return getFillColor();
        } else if (field.equals(FILLRULE)) { // TODO use == here first??
            return getFillRule();
        } else if (field.equals(STROKECOLOR)) { // TODO use == here first??
            return getStrokeColor();
        } else if (field.equals(STROKEDASHARRAY)) { // TODO use == here first??
            return getStrokeDashArray();
        } else if (field.equals(STROKEDASHOFFSET)) { // TODO use == here first??
            return getStrokeDashOffset();
        } else if (field.equals(STROKELINECAP)) { // TODO use == here first??
            return getStrokeLineCap();
        } else if (field.equals(STROKELINEJOIN)) { // TODO use == here first??
            return getStrokeLineJoin();
        } else if (field.equals(STROKEMITERLIMIT)) { // TODO use == here first??
            return getStrokeMiterLimit();
        } else if (field.equals(STROKEWIDTH)) { // TODO use == here first??
            return getStrokeWidth();
        } else if (field.equals(FONTFAMILY)) { // TODO use == here first??
            return getFontFamily();
        } else if (field.equals(FONTSIZE)) { // TODO use == here first??
            return getFontSize();
        } else if (field.equals(FONTSTRETCH)) { // TODO use == here first??
            return getFontStretch();
        } else if (field.equals(FONTSTYLE)) { // TODO use == here first??
            return getFontStyle();
        } else if (field.equals(FONTVARIANT)) { // TODO use == here first??
            return getFontVariant();
        } else if (field.equals(FONTWEIGHT)) { // TODO use == here first??
            return getFontWeight();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(THEZ)) {
            setTheZ((java.lang.Integer)value);
        } else if (field.equals(THET)) {
            setTheT((java.lang.Integer)value);
        } else if (field.equals(THEC)) {
            setTheC((java.lang.Integer)value);
        } else if (field.equals(ROI)) {
            setRoi((ome.model.roi.Roi)value);
        } else if (field.equals(LOCKED)) {
            setLocked((java.lang.Boolean)value);
        } else if (field.equals(G)) {
            setG((java.lang.String)value);
        } else if (field.equals(TRANSFORM)) {
            setTransform((java.lang.String)value);
        } else if (field.equals(VECTOREFFECT)) {
            setVectorEffect((java.lang.String)value);
        } else if (field.equals(VISIBILITY)) {
            setVisibility((java.lang.Boolean)value);
        } else if (field.equals(FILLCOLOR)) {
            setFillColor((java.lang.Integer)value);
        } else if (field.equals(FILLRULE)) {
            setFillRule((java.lang.String)value);
        } else if (field.equals(STROKECOLOR)) {
            setStrokeColor((java.lang.Integer)value);
        } else if (field.equals(STROKEDASHARRAY)) {
            setStrokeDashArray((java.lang.String)value);
        } else if (field.equals(STROKEDASHOFFSET)) {
            setStrokeDashOffset((java.lang.Integer)value);
        } else if (field.equals(STROKELINECAP)) {
            setStrokeLineCap((java.lang.String)value);
        } else if (field.equals(STROKELINEJOIN)) {
            setStrokeLineJoin((java.lang.String)value);
        } else if (field.equals(STROKEMITERLIMIT)) {
            setStrokeMiterLimit((java.lang.Integer)value);
        } else if (field.equals(STROKEWIDTH)) {
            setStrokeWidth((java.lang.Integer)value);
        } else if (field.equals(FONTFAMILY)) {
            setFontFamily((java.lang.String)value);
        } else if (field.equals(FONTSIZE)) {
            setFontSize((java.lang.Integer)value);
        } else if (field.equals(FONTSTRETCH)) {
            setFontStretch((java.lang.String)value);
        } else if (field.equals(FONTSTYLE)) {
            setFontStyle((java.lang.String)value);
        } else if (field.equals(FONTVARIANT)) {
            setFontVariant((java.lang.String)value);
        } else if (field.equals(FONTWEIGHT)) {
            setFontWeight((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.theZ = null;
        this.theT = null;
        this.theC = null;
        this.roi = null;
        this.locked = null;
        this.g = null;
        this.transform = null;
        this.vectorEffect = null;
        this.visibility = null;
        this.fillColor = null;
        this.fillRule = null;
        this.strokeColor = null;
        this.strokeDashArray = null;
        this.strokeDashOffset = null;
        this.strokeLineCap = null;
        this.strokeLineJoin = null;
        this.strokeMiterLimit = null;
        this.strokeWidth = null;
        this.fontFamily = null;
        this.fontSize = null;
        this.fontStretch = null;
        this.fontStyle = null;
        this.fontVariant = null;
        this.fontWeight = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
