

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.screen;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="plate_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="plate_owner_filter_SCREENLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_group_filter_SCREENLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_event_filter_SCREENLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_perms_filter_SCREENLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="plate_owner_filter_WELLS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_group_filter_WELLS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_event_filter_WELLS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_perms_filter_WELLS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="plate_owner_filter_PLATEACQUISITIONS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_group_filter_PLATEACQUISITIONS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_event_filter_PLATEACQUISITIONS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_perms_filter_PLATEACQUISITIONS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="plate_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="plate_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="plate_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="plate_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="plate_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="plate_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "plate", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_plate",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_plate"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Plate
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "plate_owner_filter";
    public final static String GROUP_FILTER = "plate_group_filter";
    public final static String EVENT_FILTER = "plate_event_filter";
    public final static String PERMS_FILTER = "plate_perms_filter";

    public Plate () {
        this(null, true);
    }

    protected Plate (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Plate (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Plate(
java.lang.String _name    ) {
        this(null, true);
        setName(_name);
    }

    public final static String ID = "ome.model.screen.Plate_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_plate") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.screen.Plate_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.Integer defaultSample = null;

   /**
    * Simple field ome.model.screen.Plate.defaultSample (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="defaultSample", updatable=true)
    public java.lang.Integer getDefaultSample() {
        if (! _loaded ) errorIfUnloaded();
        return this.defaultSample;
    }

    public void setDefaultSample(java.lang.Integer defaultSample) {
        if (! _loaded ) errorIfUnloaded();
        this.defaultSample = (java.lang.Integer) defaultSample;
    }
    protected java.lang.String columnNamingConvention = null;

   /**
    * Simple field ome.model.screen.Plate.columnNamingConvention (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="columnNamingConvention", updatable=true)
    public java.lang.String getColumnNamingConvention() {
        if (! _loaded ) errorIfUnloaded();
        return this.columnNamingConvention;
    }

    public void setColumnNamingConvention(java.lang.String columnNamingConvention) {
        if (! _loaded ) errorIfUnloaded();
        this.columnNamingConvention = (java.lang.String) columnNamingConvention;
    }
    protected java.lang.String rowNamingConvention = null;

   /**
    * Simple field ome.model.screen.Plate.rowNamingConvention (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="rowNamingConvention", updatable=true)
    public java.lang.String getRowNamingConvention() {
        if (! _loaded ) errorIfUnloaded();
        return this.rowNamingConvention;
    }

    public void setRowNamingConvention(java.lang.String rowNamingConvention) {
        if (! _loaded ) errorIfUnloaded();
        this.rowNamingConvention = (java.lang.String) rowNamingConvention;
    }
    protected java.lang.Double wellOriginX = null;

   /**
    * Simple field ome.model.screen.Plate.wellOriginX (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="wellOriginX", updatable=true)
    public java.lang.Double getWellOriginX() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellOriginX;
    }

    public void setWellOriginX(java.lang.Double wellOriginX) {
        if (! _loaded ) errorIfUnloaded();
        this.wellOriginX = (java.lang.Double) wellOriginX;
    }
    protected java.lang.Double wellOriginY = null;

   /**
    * Simple field ome.model.screen.Plate.wellOriginY (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="wellOriginY", updatable=true)
    public java.lang.Double getWellOriginY() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellOriginY;
    }

    public void setWellOriginY(java.lang.Double wellOriginY) {
        if (! _loaded ) errorIfUnloaded();
        this.wellOriginY = (java.lang.Double) wellOriginY;
    }
    protected java.lang.Integer rows = null;

   /**
    * Simple field ome.model.screen.Plate.rows (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="\"rows\"", updatable=true)
    public java.lang.Integer getRows() {
        if (! _loaded ) errorIfUnloaded();
        return this.rows;
    }

    public void setRows(java.lang.Integer rows) {
        if (! _loaded ) errorIfUnloaded();
        this.rows = (java.lang.Integer) rows;
    }
    protected java.lang.Integer columns = null;

   /**
    * Simple field ome.model.screen.Plate.columns (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="columns", updatable=true)
    public java.lang.Integer getColumns() {
        if (! _loaded ) errorIfUnloaded();
        return this.columns;
    }

    public void setColumns(java.lang.Integer columns) {
        if (! _loaded ) errorIfUnloaded();
        this.columns = (java.lang.Integer) columns;
    }
    protected java.lang.String status = null;

   /**
    * Simple field ome.model.screen.Plate.status (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="status", updatable=true)
    public java.lang.String getStatus() {
        if (! _loaded ) errorIfUnloaded();
        return this.status;
    }

    public void setStatus(java.lang.String status) {
        if (! _loaded ) errorIfUnloaded();
        this.status = (java.lang.String) status;
    }
    protected java.lang.String externalIdentifier = null;

   /**
    * Simple field ome.model.screen.Plate.externalIdentifier (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="externalIdentifier", updatable=true)
    public java.lang.String getExternalIdentifier() {
        if (! _loaded ) errorIfUnloaded();
        return this.externalIdentifier;
    }

    public void setExternalIdentifier(java.lang.String externalIdentifier) {
        if (! _loaded ) errorIfUnloaded();
        this.externalIdentifier = (java.lang.String) externalIdentifier;
    }
    protected java.util.Set<ome.model.screen.ScreenPlateLink> screenLinks = new java.util.HashSet<ome.model.screen.ScreenPlateLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_SCREENLINKS = "plate_owner_filter_SCREENLINKS";
    public final static String GROUP_FILTER_SCREENLINKS = "plate_group_filter_SCREENLINKS";
    public final static String EVENT_FILTER_SCREENLINKS = "plate_event_filter_SCREENLINKS";
    public final static String PERMS_FILTER_SCREENLINKS = "plate_perms_filter_SCREENLINKS";

   /**
    * returns screenLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Plate.screenLinks (ome.model.screen.ScreenPlateLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_SCREENLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_SCREENLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_SCREENLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_SCREENLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.ScreenPlateLink> getScreenLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.screenLinks;
    }

    /**
     * setter for screenLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setScreenLinks(java.util.Set<ome.model.screen.ScreenPlateLink> screenLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.screenLinks = screenLinks;
    }
    /**
     * returns the size of screenLinks. If less than zero, the Set was null.
     */
    public int sizeOfScreenLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.screenLinks == null ? -1 : this.screenLinks.size();
    }

    /**
     * should be used rather than accessing the screenLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfScreenLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.ScreenPlateLink> iterateScreenLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getScreenLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.ScreenPlateLink>();
        }
        return getScreenLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.ScreenPlateLink> unmodifiableScreenLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getScreenLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getScreenLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.ScreenPlateLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateScreenLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectScreenLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = iterateScreenLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setScreenLinks . Makes the necessary
     * call on ome.model.screen.ScreenPlateLink as well.
     */
    public void addScreenPlateLink(ome.model.screen.ScreenPlateLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getScreenLinks() == null) {
            throwNullCollectionException("ScreenLinks");
        }
        getScreenLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addScreenPlateLink.
     */
    public void addScreenPlateLinkSet(java.util.Collection<ome.model.screen.ScreenPlateLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getScreenLinks() == null) {
           throwNullCollectionException("ScreenLinks");
        }
        getScreenLinks().addAll( targets );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.ScreenPlateLink
     */
    public void removeScreenPlateLink(ome.model.screen.ScreenPlateLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getScreenLinks() == null) {
            throwNullCollectionException("ScreenLinks");
        }
        getScreenLinks().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeScreenPlateLink
     */
    public void removeScreenPlateLinkSet(java.util.Collection<ome.model.screen.ScreenPlateLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getScreenLinks() == null) {
            throwNullCollectionException("ScreenLinks");
        }
        getScreenLinks().removeAll( targets );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.screen.ScreenPlateLink to screenLinks . This entails changing our screenLinks Set,
     * creating a new ome.model.screen.ScreenPlateLink and calling linkScreen on the ome.model.screen.Screen.
     */
    public ome.model.screen.ScreenPlateLink linkScreen (ome.model.screen.Screen addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.screen.ScreenPlateLink link = new ome.model.screen.ScreenPlateLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addScreenPlateLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.screen.ScreenPlateLink to screenLinks, allowing for recursion -- whether
     * or not addScreenPlateLink will be called on the addition <b>if it is loaded</b>
     */
    public void addScreenPlateLink (ome.model.screen.ScreenPlateLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getScreenLinks() == null ) {
            throwNullCollectionException("ScreenLinks");
        }
        getScreenLinks().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addScreenPlateLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the screenLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedScreenList()} instead.
     */
     public java.util.Iterator<ome.model.screen.Screen> linkedScreenIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getScreenLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Screen>();
        }

        final java.util.Iterator<ome.model.screen.ScreenPlateLink> it = getScreenLinks().iterator();
        return new java.util.Iterator<ome.model.screen.Screen>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.screen.Screen next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "screenLinks is null; no elements." );
                }
                ome.model.screen.ScreenPlateLink link = (ome.model.screen.ScreenPlateLink) it.next();
                return link.parent();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.screen.ScreenPlateLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.screen.ScreenPlateLink> findScreenPlateLink( ome.model.screen.Screen target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.screen.ScreenPlateLink> it = iterateScreenLinks();
        final java.util.Set<ome.model.screen.ScreenPlateLink> result = new java.util.HashSet<ome.model.screen.ScreenPlateLink>();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedScreenIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.screen.Screen> linkedScreenList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.screen.Screen> it = linkedScreenIterator();
        java.util.List<ome.model.screen.Screen> list = new java.util.ArrayList<ome.model.screen.Screen>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Screen while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedScreen(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Screen> it = linkedScreenIterator();
        while ( it.hasNext() ) {
            ome.model.screen.Screen obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.screen.Screen instances from this instance.
     */
    public void unlinkScreen (ome.model.screen.Screen removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.screen.ScreenPlateLink> toRemove = findScreenPlateLink( removal );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeScreenPlateLink( it.next(), true );
        }
    }

    /**
     * removes the given ScreenPlateLink from screenLinks, allowing for recursion -- whether
     * or not the removal will call unlinkPlate again <b>if loaded</b>.
     */
    public void removeScreenPlateLink (ome.model.screen.ScreenPlateLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getScreenLinks() == null ) {
            throwNullCollectionException("ScreenLinks");
        }

        getScreenLinks().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeScreenPlateLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearScreenLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.screen.ScreenPlateLink> list = new java.util.ArrayList<ome.model.screen.ScreenPlateLink>( getScreenLinks() );
        for (ome.model.screen.ScreenPlateLink link : list) {
            removeScreenPlateLink( link, true );
        }
    }

    private java.util.Map<Long, Long> screenLinksCountPerOwner = null;

    protected void setScreenLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.screenLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Plate_screenLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.screen.ScreenPlateLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Plate_screenLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Plate_screenLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Plate_id"))
    public java.util.Map<Long, Long> getScreenLinksCountPerOwner() {
        return this.screenLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.screen.Well> wells = new java.util.HashSet<ome.model.screen.Well>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_WELLS = "plate_owner_filter_WELLS";
    public final static String GROUP_FILTER_WELLS = "plate_group_filter_WELLS";
    public final static String EVENT_FILTER_WELLS = "plate_event_filter_WELLS";
    public final static String PERMS_FILTER_WELLS = "plate_perms_filter_WELLS";

   /**
    * returns wells . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Plate.wells (ome.model.screen.Well)
    */
    @javax.persistence.OneToMany(mappedBy="plate", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_WELLS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_WELLS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_WELLS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_WELLS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.Well> getWells() {
        if (! _loaded ) errorIfUnloaded();
        return this.wells;
    }

    /**
     * setter for wells should be avoided. Does not fulfill normal semantics.
     */
    protected void setWells(java.util.Set<ome.model.screen.Well> wells) {
        if (! _loaded ) errorIfUnloaded();
        this.wells = wells;
    }
    /**
     * returns the size of wells. If less than zero, the Set was null.
     */
    public int sizeOfWells() {
        if (! _loaded ) errorIfUnloaded();
        return this.wells == null ? -1 : this.wells.size();
    }

    /**
     * should be used rather than accessing the wells set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfWells()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.Well> iterateWells() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWells() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Well>();
        }
        return getWells().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.Well> unmodifiableWells() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWells() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getWells() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Well while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateWells} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectWells(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Well> it = iterateWells();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setWells . Makes the necessary
     * call on ome.model.screen.Well as well.
     */
    public void addWell(ome.model.screen.Well target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWells() == null) {
            throwNullCollectionException("Wells");
        }
        getWells().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setPlate ( this );
         }
    }

    /**
     * use like addWell.
     */
    public void addWellSet(java.util.Collection<ome.model.screen.Well> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getWells() == null) {
           throwNullCollectionException("Wells");
        }
        getWells().addAll( targets );
        java.util.Iterator<ome.model.screen.Well> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.Well target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setPlate ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.Well
     */
    public void removeWell(ome.model.screen.Well target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWells() == null) {
            throwNullCollectionException("Wells");
        }
        getWells().remove( target );
            target.setPlate ( null );
    }

    /**
     * use like removeWell
     */
    public void removeWellSet(java.util.Collection<ome.model.screen.Well> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getWells() == null) {
            throwNullCollectionException("Wells");
        }
        getWells().removeAll( targets );
        java.util.Iterator<ome.model.screen.Well> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.Well target = it.next();
                target.setPlate ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearWells() {
        if (! _loaded ) errorIfUnloaded();
        if (getWells() == null) {
            throwNullCollectionException("Wells");
        }
        getWells().clear();
        java.util.Iterator<ome.model.screen.Well> it = iterateWells();
        while (it.hasNext()) {
            ome.model.screen.Well target = it.next();
            target.setPlate ( null );
        }
    }


    protected java.util.Set<ome.model.screen.PlateAcquisition> plateAcquisitions = new java.util.HashSet<ome.model.screen.PlateAcquisition>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_PLATEACQUISITIONS = "plate_owner_filter_PLATEACQUISITIONS";
    public final static String GROUP_FILTER_PLATEACQUISITIONS = "plate_group_filter_PLATEACQUISITIONS";
    public final static String EVENT_FILTER_PLATEACQUISITIONS = "plate_event_filter_PLATEACQUISITIONS";
    public final static String PERMS_FILTER_PLATEACQUISITIONS = "plate_perms_filter_PLATEACQUISITIONS";

   /**
    * returns plateAcquisitions . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Plate.plateAcquisitions (ome.model.screen.PlateAcquisition)
    */
    @javax.persistence.OneToMany(mappedBy="plate", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_PLATEACQUISITIONS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_PLATEACQUISITIONS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_PLATEACQUISITIONS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_PLATEACQUISITIONS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.PlateAcquisition> getPlateAcquisitions() {
        if (! _loaded ) errorIfUnloaded();
        return this.plateAcquisitions;
    }

    /**
     * setter for plateAcquisitions should be avoided. Does not fulfill normal semantics.
     */
    protected void setPlateAcquisitions(java.util.Set<ome.model.screen.PlateAcquisition> plateAcquisitions) {
        if (! _loaded ) errorIfUnloaded();
        this.plateAcquisitions = plateAcquisitions;
    }
    /**
     * returns the size of plateAcquisitions. If less than zero, the Set was null.
     */
    public int sizeOfPlateAcquisitions() {
        if (! _loaded ) errorIfUnloaded();
        return this.plateAcquisitions == null ? -1 : this.plateAcquisitions.size();
    }

    /**
     * should be used rather than accessing the plateAcquisitions set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfPlateAcquisitions()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.PlateAcquisition> iteratePlateAcquisitions() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateAcquisitions() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.PlateAcquisition>();
        }
        return getPlateAcquisitions().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.PlateAcquisition> unmodifiablePlateAcquisitions() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateAcquisitions() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getPlateAcquisitions() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.PlateAcquisition while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iteratePlateAcquisitions} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectPlateAcquisitions(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.PlateAcquisition> it = iteratePlateAcquisitions();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setPlateAcquisitions . Makes the necessary
     * call on ome.model.screen.PlateAcquisition as well.
     */
    public void addPlateAcquisition(ome.model.screen.PlateAcquisition target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateAcquisitions() == null) {
            throwNullCollectionException("PlateAcquisitions");
        }
        getPlateAcquisitions().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setPlate ( this );
         }
    }

    /**
     * use like addPlateAcquisition.
     */
    public void addPlateAcquisitionSet(java.util.Collection<ome.model.screen.PlateAcquisition> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateAcquisitions() == null) {
           throwNullCollectionException("PlateAcquisitions");
        }
        getPlateAcquisitions().addAll( targets );
        java.util.Iterator<ome.model.screen.PlateAcquisition> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.PlateAcquisition target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setPlate ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.PlateAcquisition
     */
    public void removePlateAcquisition(ome.model.screen.PlateAcquisition target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateAcquisitions() == null) {
            throwNullCollectionException("PlateAcquisitions");
        }
        getPlateAcquisitions().remove( target );
            target.setPlate ( null );
    }

    /**
     * use like removePlateAcquisition
     */
    public void removePlateAcquisitionSet(java.util.Collection<ome.model.screen.PlateAcquisition> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateAcquisitions() == null) {
            throwNullCollectionException("PlateAcquisitions");
        }
        getPlateAcquisitions().removeAll( targets );
        java.util.Iterator<ome.model.screen.PlateAcquisition> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.PlateAcquisition target = it.next();
                target.setPlate ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearPlateAcquisitions() {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateAcquisitions() == null) {
            throwNullCollectionException("PlateAcquisitions");
        }
        getPlateAcquisitions().clear();
        java.util.Iterator<ome.model.screen.PlateAcquisition> it = iteratePlateAcquisitions();
        while (it.hasNext()) {
            ome.model.screen.PlateAcquisition target = it.next();
            target.setPlate ( null );
        }
    }


    protected java.util.Set<ome.model.annotations.PlateAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.PlateAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "plate_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "plate_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "plate_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "plate_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Plate.annotationLinks (ome.model.annotations.PlateAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.PlateAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.PlateAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.PlateAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.PlateAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.PlateAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.PlateAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.PlateAnnotationLink as well.
     */
    public void addPlateAnnotationLink(ome.model.annotations.PlateAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addPlateAnnotationLink.
     */
    public void addPlateAnnotationLinkSet(java.util.Collection<ome.model.annotations.PlateAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.PlateAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.PlateAnnotationLink
     */
    public void removePlateAnnotationLink(ome.model.annotations.PlateAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removePlateAnnotationLink
     */
    public void removePlateAnnotationLinkSet(java.util.Collection<ome.model.annotations.PlateAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.PlateAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.PlateAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.PlateAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.PlateAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.PlateAnnotationLink link = new ome.model.annotations.PlateAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addPlateAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.PlateAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addPlateAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addPlateAnnotationLink (ome.model.annotations.PlateAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.PlateAnnotationLink link = (ome.model.annotations.PlateAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.PlateAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.PlateAnnotationLink> findPlateAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.PlateAnnotationLink> result = new java.util.HashSet<ome.model.annotations.PlateAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.PlateAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.PlateAnnotationLink> toRemove = findPlateAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.PlateAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removePlateAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given PlateAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkPlate again <b>if loaded</b>.
     */
    public void removePlateAnnotationLink (ome.model.annotations.PlateAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.PlateAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.PlateAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.PlateAnnotationLink link : list) {
            removePlateAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Plate_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.PlateAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Plate_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Plate_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Plate_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.screen.Plate.name (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.screen.Plate.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.screen.Plate newInstance() 
    {
        return new ome.model.screen.Plate();
    }

    public ome.model.screen.Plate proxy() {
        return new ome.model.screen.Plate(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.defaultSample = (java.lang.Integer) __filter.filter(DEFAULTSAMPLE, this.defaultSample );
            this.columnNamingConvention = (java.lang.String) __filter.filter(COLUMNNAMINGCONVENTION, this.columnNamingConvention );
            this.rowNamingConvention = (java.lang.String) __filter.filter(ROWNAMINGCONVENTION, this.rowNamingConvention );
            this.wellOriginX = (java.lang.Double) __filter.filter(WELLORIGINX, this.wellOriginX );
            this.wellOriginY = (java.lang.Double) __filter.filter(WELLORIGINY, this.wellOriginY );
            this.rows = (java.lang.Integer) __filter.filter(ROWS, this.rows );
            this.columns = (java.lang.Integer) __filter.filter(COLUMNS, this.columns );
            this.status = (java.lang.String) __filter.filter(STATUS, this.status );
            this.externalIdentifier = (java.lang.String) __filter.filter(EXTERNALIDENTIFIER, this.externalIdentifier );
            this.screenLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(SCREENLINKSCOUNTPEROWNER, this.screenLinksCountPerOwner );
            this.screenLinks = (java.util.Set<ome.model.screen.ScreenPlateLink>) __filter.filter(SCREENLINKS, this.screenLinks );
            this.wells = (java.util.Set<ome.model.screen.Well>) __filter.filter(WELLS, this.wells );
            this.plateAcquisitions = (java.util.Set<ome.model.screen.PlateAcquisition>) __filter.filter(PLATEACQUISITIONS, this.plateAcquisitions );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.PlateAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.screen.Plate.FIELDS;
    }
  
    public final static String DEFAULTSAMPLE = "ome.model.screen.Plate_defaultSample";
    public final static String COLUMNNAMINGCONVENTION = "ome.model.screen.Plate_columnNamingConvention";
    public final static String ROWNAMINGCONVENTION = "ome.model.screen.Plate_rowNamingConvention";
    public final static String WELLORIGINX = "ome.model.screen.Plate_wellOriginX";
    public final static String WELLORIGINY = "ome.model.screen.Plate_wellOriginY";
    public final static String ROWS = "ome.model.screen.Plate_rows";
    public final static String COLUMNS = "ome.model.screen.Plate_columns";
    public final static String STATUS = "ome.model.screen.Plate_status";
    public final static String EXTERNALIDENTIFIER = "ome.model.screen.Plate_externalIdentifier";
    public final static String SCREENLINKSCOUNTPEROWNER = "ome.model.screen.Plate_screenLinksCountPerOwner";
    public final static String SCREENLINKS = "ome.model.screen.Plate_screenLinks";
    public final static String WELLS = "ome.model.screen.Plate_wells";
    public final static String PLATEACQUISITIONS = "ome.model.screen.Plate_plateAcquisitions";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.screen.Plate_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.screen.Plate_annotationLinks";
    public final static String NAME = "ome.model.screen.Plate_name";
    public final static String DESCRIPTION = "ome.model.screen.Plate_description";
    public final static String DETAILS = "ome.model.screen.Plate_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(DEFAULTSAMPLE);
       raw.add(COLUMNNAMINGCONVENTION);
       raw.add(ROWNAMINGCONVENTION);
       raw.add(WELLORIGINX);
       raw.add(WELLORIGINY);
       raw.add(ROWS);
       raw.add(COLUMNS);
       raw.add(STATUS);
       raw.add(EXTERNALIDENTIFIER);
       raw.add(SCREENLINKSCOUNTPEROWNER);
       raw.add(SCREENLINKS);
       raw.add(WELLS);
       raw.add(PLATEACQUISITIONS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(DEFAULTSAMPLE)) { // TODO use == here first??
            return getDefaultSample();
        } else if (field.equals(COLUMNNAMINGCONVENTION)) { // TODO use == here first??
            return getColumnNamingConvention();
        } else if (field.equals(ROWNAMINGCONVENTION)) { // TODO use == here first??
            return getRowNamingConvention();
        } else if (field.equals(WELLORIGINX)) { // TODO use == here first??
            return getWellOriginX();
        } else if (field.equals(WELLORIGINY)) { // TODO use == here first??
            return getWellOriginY();
        } else if (field.equals(ROWS)) { // TODO use == here first??
            return getRows();
        } else if (field.equals(COLUMNS)) { // TODO use == here first??
            return getColumns();
        } else if (field.equals(STATUS)) { // TODO use == here first??
            return getStatus();
        } else if (field.equals(EXTERNALIDENTIFIER)) { // TODO use == here first??
            return getExternalIdentifier();
        } else if (field.equals(SCREENLINKSCOUNTPEROWNER)) {
            return getScreenLinksCountPerOwner();
        } else if (field.equals(SCREENLINKS)) { // TODO use == here first??
            return getScreenLinks();
        } else if (field.equals(WELLS)) { // TODO use == here first??
            return getWells();
        } else if (field.equals(PLATEACQUISITIONS)) { // TODO use == here first??
            return getPlateAcquisitions();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(NAME)) { // TODO use == here first??
            return getName();
        } else if (field.equals(DESCRIPTION)) { // TODO use == here first??
            return getDescription();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(DEFAULTSAMPLE)) {
            setDefaultSample((java.lang.Integer)value);
        } else if (field.equals(COLUMNNAMINGCONVENTION)) {
            setColumnNamingConvention((java.lang.String)value);
        } else if (field.equals(ROWNAMINGCONVENTION)) {
            setRowNamingConvention((java.lang.String)value);
        } else if (field.equals(WELLORIGINX)) {
            setWellOriginX((java.lang.Double)value);
        } else if (field.equals(WELLORIGINY)) {
            setWellOriginY((java.lang.Double)value);
        } else if (field.equals(ROWS)) {
            setRows((java.lang.Integer)value);
        } else if (field.equals(COLUMNS)) {
            setColumns((java.lang.Integer)value);
        } else if (field.equals(STATUS)) {
            setStatus((java.lang.String)value);
        } else if (field.equals(EXTERNALIDENTIFIER)) {
            setExternalIdentifier((java.lang.String)value);
        } else if (field.equals(SCREENLINKSCOUNTPEROWNER)) {
            setScreenLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(SCREENLINKS)) {
            setScreenLinks((java.util.Set<ome.model.screen.ScreenPlateLink>)value);
        } else if (field.equals(WELLS)) {
            setWells((java.util.Set<ome.model.screen.Well>)value);
        } else if (field.equals(PLATEACQUISITIONS)) {
            setPlateAcquisitions((java.util.Set<ome.model.screen.PlateAcquisition>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.PlateAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.defaultSample = null;
        this.columnNamingConvention = null;
        this.rowNamingConvention = null;
        this.wellOriginX = null;
        this.wellOriginY = null;
        this.rows = null;
        this.columns = null;
        this.status = null;
        this.externalIdentifier = null;
        this.screenLinksCountPerOwner = null;
        this.screenLinks = null;
        this.wells = null;
        this.plateAcquisitions = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKplate_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplate_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKplate_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplate_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplate_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
