

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.screen;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="well_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="well_owner_filter_REAGENTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_group_filter_REAGENTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_event_filter_REAGENTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_perms_filter_REAGENTLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="well_owner_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_group_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_event_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_perms_filter_WELLSAMPLES",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="well_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="well_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="well_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="well_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="well_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="well_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "well", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_well",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_well"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Well
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "well_owner_filter";
    public final static String GROUP_FILTER = "well_group_filter";
    public final static String EVENT_FILTER = "well_event_filter";
    public final static String PERMS_FILTER = "well_perms_filter";

    public Well () {
        this(null, true);
    }

    protected Well (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Well (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Well(
ome.model.screen.Plate _plate    ) {
        this(null, true);
        setPlate(_plate);
    }

    public final static String ID = "ome.model.screen.Well_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_well") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.screen.Well_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String status = null;

   /**
    * Simple field ome.model.screen.Well.status (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="status", updatable=true)
    public java.lang.String getStatus() {
        if (! _loaded ) errorIfUnloaded();
        return this.status;
    }

    public void setStatus(java.lang.String status) {
        if (! _loaded ) errorIfUnloaded();
        this.status = (java.lang.String) status;
    }
    protected java.lang.Integer column = null;

   /**
    * Simple field ome.model.screen.Well.column (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="\"column\"", updatable=true)
    public java.lang.Integer getColumn() {
        if (! _loaded ) errorIfUnloaded();
        return this.column;
    }

    public void setColumn(java.lang.Integer column) {
        if (! _loaded ) errorIfUnloaded();
        this.column = (java.lang.Integer) column;
    }
    protected java.lang.Integer row = null;

   /**
    * Simple field ome.model.screen.Well.row (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="\"row\"", updatable=true)
    public java.lang.Integer getRow() {
        if (! _loaded ) errorIfUnloaded();
        return this.row;
    }

    public void setRow(java.lang.Integer row) {
        if (! _loaded ) errorIfUnloaded();
        this.row = (java.lang.Integer) row;
    }
    protected java.lang.Integer red = null;

   /**
    * Simple field ome.model.screen.Well.red (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="red", updatable=true)
    public java.lang.Integer getRed() {
        if (! _loaded ) errorIfUnloaded();
        return this.red;
    }

    public void setRed(java.lang.Integer red) {
        if (! _loaded ) errorIfUnloaded();
        this.red = (java.lang.Integer) red;
    }
    protected java.lang.Integer green = null;

   /**
    * Simple field ome.model.screen.Well.green (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="green", updatable=true)
    public java.lang.Integer getGreen() {
        if (! _loaded ) errorIfUnloaded();
        return this.green;
    }

    public void setGreen(java.lang.Integer green) {
        if (! _loaded ) errorIfUnloaded();
        this.green = (java.lang.Integer) green;
    }
    protected java.lang.Integer blue = null;

   /**
    * Simple field ome.model.screen.Well.blue (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="blue", updatable=true)
    public java.lang.Integer getBlue() {
        if (! _loaded ) errorIfUnloaded();
        return this.blue;
    }

    public void setBlue(java.lang.Integer blue) {
        if (! _loaded ) errorIfUnloaded();
        this.blue = (java.lang.Integer) blue;
    }
    protected java.lang.Integer alpha = null;

   /**
    * Simple field ome.model.screen.Well.alpha (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="alpha", updatable=true)
    public java.lang.Integer getAlpha() {
        if (! _loaded ) errorIfUnloaded();
        return this.alpha;
    }

    public void setAlpha(java.lang.Integer alpha) {
        if (! _loaded ) errorIfUnloaded();
        this.alpha = (java.lang.Integer) alpha;
    }
    protected java.util.Set<ome.model.screen.WellReagentLink> reagentLinks = new java.util.HashSet<ome.model.screen.WellReagentLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_REAGENTLINKS = "well_owner_filter_REAGENTLINKS";
    public final static String GROUP_FILTER_REAGENTLINKS = "well_group_filter_REAGENTLINKS";
    public final static String EVENT_FILTER_REAGENTLINKS = "well_event_filter_REAGENTLINKS";
    public final static String PERMS_FILTER_REAGENTLINKS = "well_perms_filter_REAGENTLINKS";

   /**
    * returns reagentLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Well.reagentLinks (ome.model.screen.WellReagentLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_REAGENTLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_REAGENTLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_REAGENTLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_REAGENTLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.WellReagentLink> getReagentLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagentLinks;
    }

    /**
     * setter for reagentLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setReagentLinks(java.util.Set<ome.model.screen.WellReagentLink> reagentLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.reagentLinks = reagentLinks;
    }
    /**
     * returns the size of reagentLinks. If less than zero, the Set was null.
     */
    public int sizeOfReagentLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagentLinks == null ? -1 : this.reagentLinks.size();
    }

    /**
     * should be used rather than accessing the reagentLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfReagentLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.WellReagentLink> iterateReagentLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagentLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.WellReagentLink>();
        }
        return getReagentLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.WellReagentLink> unmodifiableReagentLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagentLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getReagentLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.WellReagentLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateReagentLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectReagentLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.WellReagentLink> it = iterateReagentLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setReagentLinks . Makes the necessary
     * call on ome.model.screen.WellReagentLink as well.
     */
    public void addWellReagentLink(ome.model.screen.WellReagentLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagentLinks() == null) {
            throwNullCollectionException("ReagentLinks");
        }
        getReagentLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addWellReagentLink.
     */
    public void addWellReagentLinkSet(java.util.Collection<ome.model.screen.WellReagentLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagentLinks() == null) {
           throwNullCollectionException("ReagentLinks");
        }
        getReagentLinks().addAll( targets );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.WellReagentLink
     */
    public void removeWellReagentLink(ome.model.screen.WellReagentLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagentLinks() == null) {
            throwNullCollectionException("ReagentLinks");
        }
        getReagentLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeWellReagentLink
     */
    public void removeWellReagentLinkSet(java.util.Collection<ome.model.screen.WellReagentLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagentLinks() == null) {
            throwNullCollectionException("ReagentLinks");
        }
        getReagentLinks().removeAll( targets );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.screen.WellReagentLink to reagentLinks . This entails changing our reagentLinks Set,
     * creating a new ome.model.screen.WellReagentLink and calling linkReagent on the ome.model.screen.Reagent.
     */
    public ome.model.screen.WellReagentLink linkReagent (ome.model.screen.Reagent addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.screen.WellReagentLink link = new ome.model.screen.WellReagentLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addWellReagentLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.screen.WellReagentLink to reagentLinks, allowing for recursion -- whether
     * or not addWellReagentLink will be called on the addition <b>if it is loaded</b>
     */
    public void addWellReagentLink (ome.model.screen.WellReagentLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagentLinks() == null ) {
            throwNullCollectionException("ReagentLinks");
        }
        getReagentLinks().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addWellReagentLink( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the reagentLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedReagentList()} instead.
     */
     public java.util.Iterator<ome.model.screen.Reagent> linkedReagentIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagentLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Reagent>();
        }

        final java.util.Iterator<ome.model.screen.WellReagentLink> it = getReagentLinks().iterator();
        return new java.util.Iterator<ome.model.screen.Reagent>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.screen.Reagent next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "reagentLinks is null; no elements." );
                }
                ome.model.screen.WellReagentLink link = (ome.model.screen.WellReagentLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.screen.WellReagentLink which have the argument as their child.
     */
    public java.util.Set<ome.model.screen.WellReagentLink> findWellReagentLink( ome.model.screen.Reagent target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.screen.WellReagentLink> it = iterateReagentLinks();
        final java.util.Set<ome.model.screen.WellReagentLink> result = new java.util.HashSet<ome.model.screen.WellReagentLink>();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedReagentIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.screen.Reagent> linkedReagentList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.screen.Reagent> it = linkedReagentIterator();
        java.util.List<ome.model.screen.Reagent> list = new java.util.ArrayList<ome.model.screen.Reagent>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Reagent while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedReagent(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Reagent> it = linkedReagentIterator();
        while ( it.hasNext() ) {
            ome.model.screen.Reagent obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.screen.Reagent instances from this instance.
     */
    public void unlinkReagent (ome.model.screen.Reagent removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.screen.WellReagentLink> toRemove = findWellReagentLink( removal );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeWellReagentLink( it.next(), true );
        }
    }

    /**
     * removes the given WellReagentLink from reagentLinks, allowing for recursion -- whether
     * or not the removal will call unlinkWell again <b>if loaded</b>.
     */
    public void removeWellReagentLink (ome.model.screen.WellReagentLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getReagentLinks() == null ) {
            throwNullCollectionException("ReagentLinks");
        }

        getReagentLinks().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removeWellReagentLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearReagentLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.screen.WellReagentLink> list = new java.util.ArrayList<ome.model.screen.WellReagentLink>( getReagentLinks() );
        for (ome.model.screen.WellReagentLink link : list) {
            removeWellReagentLink( link, true );
        }
    }

    private java.util.Map<Long, Long> reagentLinksCountPerOwner = null;

    protected void setReagentLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.reagentLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Well_reagentLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.screen.WellReagentLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Well_reagentLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Well_reagentLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Well_id"))
    public java.util.Map<Long, Long> getReagentLinksCountPerOwner() {
        return this.reagentLinksCountPerOwner;
    }

    protected java.lang.String externalDescription = null;

   /**
    * Simple field ome.model.screen.Well.externalDescription (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="externalDescription", updatable=true)
    public java.lang.String getExternalDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.externalDescription;
    }

    public void setExternalDescription(java.lang.String externalDescription) {
        if (! _loaded ) errorIfUnloaded();
        this.externalDescription = (java.lang.String) externalDescription;
    }
    protected java.lang.String externalIdentifier = null;

   /**
    * Simple field ome.model.screen.Well.externalIdentifier (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="externalIdentifier", updatable=true)
    public java.lang.String getExternalIdentifier() {
        if (! _loaded ) errorIfUnloaded();
        return this.externalIdentifier;
    }

    public void setExternalIdentifier(java.lang.String externalIdentifier) {
        if (! _loaded ) errorIfUnloaded();
        this.externalIdentifier = (java.lang.String) externalIdentifier;
    }
    protected java.lang.String type = null;

   /**
    * Simple field ome.model.screen.Well.type (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="type", updatable=true)
    public java.lang.String getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(java.lang.String type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = (java.lang.String) type;
    }
    protected java.util.List<ome.model.screen.WellSample> wellSamples = new java.util.ArrayList<ome.model.screen.WellSample>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_WELLSAMPLES = "well_owner_filter_WELLSAMPLES";
    public final static String GROUP_FILTER_WELLSAMPLES = "well_group_filter_WELLSAMPLES";
    public final static String EVENT_FILTER_WELLSAMPLES = "well_event_filter_WELLSAMPLES";
    public final static String PERMS_FILTER_WELLSAMPLES = "well_perms_filter_WELLSAMPLES";

   /**
    * returns wellSamples . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.screen.Well.wellSamples (ome.model.screen.WellSample)
    * Values are indexed by the column "index" on ome.model.screen.WellSample
    */
    @javax.persistence.JoinColumn(name="well", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="well_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_WELLSAMPLES, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_WELLSAMPLES, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_WELLSAMPLES, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_WELLSAMPLES, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.screen.WellSample> getWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellSamples;
    }

    /**
     * setter for wellSamples should be avoided. Does not fulfill normal semantics.
     */
    protected void setWellSamples(java.util.List<ome.model.screen.WellSample> wellSamples) {
        if (! _loaded ) errorIfUnloaded();
        this.wellSamples = wellSamples;
    }
    /**
     * returns the size of wellSamples. If less than zero, the Set was null.
     */
    public int sizeOfWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellSamples == null ? -1 : this.wellSamples.size();
    }

    /**
     * should be used rather than accessing the wellSamples set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfWellSamples()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.WellSample> iterateWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellSamples() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.WellSample>();
        }
        return getWellSamples().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.screen.WellSample> unmodifiableWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellSamples() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getWellSamples() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.screen.WellSample while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateWellSamples} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectWellSamples(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.WellSample> it = iterateWellSamples();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setWellSamples . Makes the necessary
     * call on ome.model.screen.WellSample as well.
     */
    public void addWellSample(ome.model.screen.WellSample target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setWell ( this );
             }
         }
    }

    /**
     * use like addWellSample.
     */
    public void addWellSampleSet(java.util.Collection<ome.model.screen.WellSample> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
           throwNullCollectionException("WellSamples");
        }
        getWellSamples().addAll( targets );
        java.util.Iterator<ome.model.screen.WellSample> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellSample target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setWell ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.WellSample
     */
    public void removeWellSample(ome.model.screen.WellSample target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().remove( target );
        if (target.isLoaded()) {
            target.setWell ( null );
        }
    }

    /**
     * use like removeWellSample
     */
    public void removeWellSampleSet(java.util.Collection<ome.model.screen.WellSample> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().removeAll( targets );
        java.util.Iterator<ome.model.screen.WellSample> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellSample target = it.next();
            if (target.isLoaded()) {
                target.setWell ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearWellSamples() {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        getWellSamples().clear();
        java.util.Iterator<ome.model.screen.WellSample> it = iterateWellSamples();
        while (it.hasNext()) {
            ome.model.screen.WellSample target = it.next();
            target.setWell ( null );
        }
    }


    /**
     * Gets the ome.model.screen.WellSample at the given index.
     */
    public ome.model.screen.WellSample getWellSample(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        return getWellSamples().get(index);
    }

    /**
     * Sets the ome.model.screen.WellSample at the given index. Adheres to the {@link List#set(int ,E))}
     * contract. To extend the list, use {@link #addWellSample()}.
     * @see java.util.List#set(int, E)
     */
    public ome.model.screen.WellSample setWellSample(int index, ome.model.screen.WellSample element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }

        ome.model.screen.WellSample old = getWellSamples().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setWell ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of wellSamples which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfWellSamples()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.screen.WellSample getPrimaryWellSample()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        return getWellSamples().get(0);
    }

    /**
     * Swaps the first element of wellSamples with the first instance of the 
     * given element. If the given element is not in the list, an 
     * {@link IndexOutBoundException} will be thrown. Returns the swapped 
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfWellSamples()} for more information.
     */
    public ome.model.screen.WellSample setPrimaryWellSample(ome.model.screen.WellSample element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getWellSamples() == null) {
            throwNullCollectionException("WellSamples");
        }
        java.util.List<ome.model.screen.WellSample> list = getWellSamples();
        int index = list.indexOf(element);
        ome.model.screen.WellSample old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected ome.model.screen.Plate plate = null;

   /**
    * Many-to-one field ome.model.screen.Well.plate (ome.model.screen.Plate)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.screen.Plate.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="plate", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKwell_plate_plate")
    public ome.model.screen.Plate getPlate() {
        if (! _loaded ) errorIfUnloaded();
        return this.plate;
    }

    public void setPlate(ome.model.screen.Plate plate) {
        if (! _loaded ) errorIfUnloaded();
        this.plate = plate;
    }
    protected java.util.Set<ome.model.annotations.WellAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.WellAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "well_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "well_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "well_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "well_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Well.annotationLinks (ome.model.annotations.WellAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.WellAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.WellAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.WellAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.WellAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.WellAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.WellAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.WellAnnotationLink as well.
     */
    public void addWellAnnotationLink(ome.model.annotations.WellAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addWellAnnotationLink.
     */
    public void addWellAnnotationLinkSet(java.util.Collection<ome.model.annotations.WellAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.WellAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.WellAnnotationLink
     */
    public void removeWellAnnotationLink(ome.model.annotations.WellAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeWellAnnotationLink
     */
    public void removeWellAnnotationLinkSet(java.util.Collection<ome.model.annotations.WellAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.WellAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.WellAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.WellAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.WellAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.WellAnnotationLink link = new ome.model.annotations.WellAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addWellAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.WellAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addWellAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addWellAnnotationLink (ome.model.annotations.WellAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.WellAnnotationLink link = (ome.model.annotations.WellAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.WellAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.WellAnnotationLink> findWellAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.WellAnnotationLink> result = new java.util.HashSet<ome.model.annotations.WellAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.WellAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.WellAnnotationLink> toRemove = findWellAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.WellAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeWellAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given WellAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkWell again <b>if loaded</b>.
     */
    public void removeWellAnnotationLink (ome.model.annotations.WellAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.WellAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.WellAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.WellAnnotationLink link : list) {
            removeWellAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Well_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.WellAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Well_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Well_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Well_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.screen.Well newInstance() 
    {
        return new ome.model.screen.Well();
    }

    public ome.model.screen.Well proxy() {
        return new ome.model.screen.Well(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.status = (java.lang.String) __filter.filter(STATUS, this.status );
            this.column = (java.lang.Integer) __filter.filter(COLUMN, this.column );
            this.row = (java.lang.Integer) __filter.filter(ROW, this.row );
            this.red = (java.lang.Integer) __filter.filter(RED, this.red );
            this.green = (java.lang.Integer) __filter.filter(GREEN, this.green );
            this.blue = (java.lang.Integer) __filter.filter(BLUE, this.blue );
            this.alpha = (java.lang.Integer) __filter.filter(ALPHA, this.alpha );
            this.reagentLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(REAGENTLINKSCOUNTPEROWNER, this.reagentLinksCountPerOwner );
            this.reagentLinks = (java.util.Set<ome.model.screen.WellReagentLink>) __filter.filter(REAGENTLINKS, this.reagentLinks );
            this.externalDescription = (java.lang.String) __filter.filter(EXTERNALDESCRIPTION, this.externalDescription );
            this.externalIdentifier = (java.lang.String) __filter.filter(EXTERNALIDENTIFIER, this.externalIdentifier );
            this.type = (java.lang.String) __filter.filter(TYPE, this.type );
            this.wellSamples = (java.util.List<ome.model.screen.WellSample>) __filter.filter(WELLSAMPLES, this.wellSamples );
            this.plate = (ome.model.screen.Plate) __filter.filter(PLATE, this.plate );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.WellAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.screen.Well.FIELDS;
    }
  
    public final static String STATUS = "ome.model.screen.Well_status";
    public final static String COLUMN = "ome.model.screen.Well_column";
    public final static String ROW = "ome.model.screen.Well_row";
    public final static String RED = "ome.model.screen.Well_red";
    public final static String GREEN = "ome.model.screen.Well_green";
    public final static String BLUE = "ome.model.screen.Well_blue";
    public final static String ALPHA = "ome.model.screen.Well_alpha";
    public final static String REAGENTLINKSCOUNTPEROWNER = "ome.model.screen.Well_reagentLinksCountPerOwner";
    public final static String REAGENTLINKS = "ome.model.screen.Well_reagentLinks";
    public final static String EXTERNALDESCRIPTION = "ome.model.screen.Well_externalDescription";
    public final static String EXTERNALIDENTIFIER = "ome.model.screen.Well_externalIdentifier";
    public final static String TYPE = "ome.model.screen.Well_type";
    public final static String WELLSAMPLES = "ome.model.screen.Well_wellSamples";
    public final static String PLATE = "ome.model.screen.Well_plate";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.screen.Well_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.screen.Well_annotationLinks";
    public final static String DETAILS = "ome.model.screen.Well_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(STATUS);
       raw.add(COLUMN);
       raw.add(ROW);
       raw.add(RED);
       raw.add(GREEN);
       raw.add(BLUE);
       raw.add(ALPHA);
       raw.add(REAGENTLINKSCOUNTPEROWNER);
       raw.add(REAGENTLINKS);
       raw.add(EXTERNALDESCRIPTION);
       raw.add(EXTERNALIDENTIFIER);
       raw.add(TYPE);
       raw.add(WELLSAMPLES);
       raw.add(PLATE);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(STATUS)) { // TODO use == here first??
            return getStatus();
        } else if (field.equals(COLUMN)) { // TODO use == here first??
            return getColumn();
        } else if (field.equals(ROW)) { // TODO use == here first??
            return getRow();
        } else if (field.equals(RED)) { // TODO use == here first??
            return getRed();
        } else if (field.equals(GREEN)) { // TODO use == here first??
            return getGreen();
        } else if (field.equals(BLUE)) { // TODO use == here first??
            return getBlue();
        } else if (field.equals(ALPHA)) { // TODO use == here first??
            return getAlpha();
        } else if (field.equals(REAGENTLINKSCOUNTPEROWNER)) {
            return getReagentLinksCountPerOwner();
        } else if (field.equals(REAGENTLINKS)) { // TODO use == here first??
            return getReagentLinks();
        } else if (field.equals(EXTERNALDESCRIPTION)) { // TODO use == here first??
            return getExternalDescription();
        } else if (field.equals(EXTERNALIDENTIFIER)) { // TODO use == here first??
            return getExternalIdentifier();
        } else if (field.equals(TYPE)) { // TODO use == here first??
            return getType();
        } else if (field.equals(WELLSAMPLES)) { // TODO use == here first??
            return getWellSamples();
        } else if (field.equals(PLATE)) { // TODO use == here first??
            return getPlate();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(STATUS)) {
            setStatus((java.lang.String)value);
        } else if (field.equals(COLUMN)) {
            setColumn((java.lang.Integer)value);
        } else if (field.equals(ROW)) {
            setRow((java.lang.Integer)value);
        } else if (field.equals(RED)) {
            setRed((java.lang.Integer)value);
        } else if (field.equals(GREEN)) {
            setGreen((java.lang.Integer)value);
        } else if (field.equals(BLUE)) {
            setBlue((java.lang.Integer)value);
        } else if (field.equals(ALPHA)) {
            setAlpha((java.lang.Integer)value);
        } else if (field.equals(REAGENTLINKSCOUNTPEROWNER)) {
            setReagentLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(REAGENTLINKS)) {
            setReagentLinks((java.util.Set<ome.model.screen.WellReagentLink>)value);
        } else if (field.equals(EXTERNALDESCRIPTION)) {
            setExternalDescription((java.lang.String)value);
        } else if (field.equals(EXTERNALIDENTIFIER)) {
            setExternalIdentifier((java.lang.String)value);
        } else if (field.equals(TYPE)) {
            setType((java.lang.String)value);
        } else if (field.equals(WELLSAMPLES)) {
            setWellSamples((java.util.List<ome.model.screen.WellSample>)value);
        } else if (field.equals(PLATE)) {
            setPlate((ome.model.screen.Plate)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.WellAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.status = null;
        this.column = null;
        this.row = null;
        this.red = null;
        this.green = null;
        this.blue = null;
        this.alpha = null;
        this.reagentLinksCountPerOwner = null;
        this.reagentLinks = null;
        this.externalDescription = null;
        this.externalIdentifier = null;
        this.type = null;
        this.wellSamples = null;
        this.plate = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKwell_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwell_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKwell_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwell_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwell_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
