

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.screen;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="wellsample_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="wellsample_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="wellsample_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="wellsample_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="wellsample_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="wellsample_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "wellsample", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"well","well_index"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_wellsample",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_wellsample"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class WellSample
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "wellsample_owner_filter";
    public final static String GROUP_FILTER = "wellsample_group_filter";
    public final static String EVENT_FILTER = "wellsample_event_filter";
    public final static String PERMS_FILTER = "wellsample_perms_filter";

    public WellSample () {
        this(null, true);
    }

    protected WellSample (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public WellSample (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public WellSample(
ome.model.screen.Well _well,ome.model.core.Image _image    ) {
        this(null, true);
        setWell(_well);
        setImage(_image);
    }

    public final static String ID = "ome.model.screen.WellSample_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_wellsample") 
    @org.hibernate.search.annotations.DocumentId
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.screen.WellSample_version";

    protected Integer version = 0; // TODO?

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straight-forward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.Double posX = null;

   /**
    * Simple field ome.model.screen.WellSample.posX (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="posX", updatable=true)
    public java.lang.Double getPosX() {
        if (! _loaded ) errorIfUnloaded();
        return this.posX;
    }

    public void setPosX(java.lang.Double posX) {
        if (! _loaded ) errorIfUnloaded();
        this.posX = (java.lang.Double) posX;
    }
    protected java.lang.Double posY = null;

   /**
    * Simple field ome.model.screen.WellSample.posY (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="posY", updatable=true)
    public java.lang.Double getPosY() {
        if (! _loaded ) errorIfUnloaded();
        return this.posY;
    }

    public void setPosY(java.lang.Double posY) {
        if (! _loaded ) errorIfUnloaded();
        this.posY = (java.lang.Double) posY;
    }
    protected java.sql.Timestamp timepoint = null;

   /**
    * Simple field ome.model.screen.WellSample.timepoint (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="timepoint", updatable=true)
    public java.sql.Timestamp getTimepoint() {
        if (! _loaded ) errorIfUnloaded();
        return this.timepoint;
    }

    public void setTimepoint(java.sql.Timestamp timepoint) {
        if (! _loaded ) errorIfUnloaded();
        this.timepoint = (java.sql.Timestamp) timepoint;
    }
    protected ome.model.screen.PlateAcquisition plateAcquisition = null;

   /**
    * Many-to-one field ome.model.screen.WellSample.plateAcquisition (ome.model.screen.PlateAcquisition)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.screen.PlateAcquisition.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="plateAcquisition", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKwellsample_plateAcquisition_plateacquisition")
    public ome.model.screen.PlateAcquisition getPlateAcquisition() {
        if (! _loaded ) errorIfUnloaded();
        return this.plateAcquisition;
    }

    public void setPlateAcquisition(ome.model.screen.PlateAcquisition plateAcquisition) {
        if (! _loaded ) errorIfUnloaded();
        this.plateAcquisition = plateAcquisition;
    }
    protected ome.model.screen.Well well = null;

   /**
    * Many-to-one field ome.model.screen.WellSample.well (ome.model.screen.Well)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.screen.Well.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="well", nullable=false,
        unique=false, insertable=false, updatable=false)
    @org.hibernate.annotations.ForeignKey(name="FKwellsample_well_well")
    public ome.model.screen.Well getWell() {
        if (! _loaded ) errorIfUnloaded();
        return this.well;
    }

    public void setWell(ome.model.screen.Well well) {
        if (! _loaded ) errorIfUnloaded();
        this.well = well;
    }
    protected ome.model.core.Image image = null;

   /**
    * Many-to-one field ome.model.screen.WellSample.image (ome.model.core.Image)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.core.Image.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="image", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKwellsample_image_image")
    public ome.model.core.Image getImage() {
        if (! _loaded ) errorIfUnloaded();
        return this.image;
    }

    public void setImage(ome.model.core.Image image) {
        if (! _loaded ) errorIfUnloaded();
        this.image = image;
    }
    protected java.util.Set<ome.model.annotations.WellSampleAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.WellSampleAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "wellsample_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "wellsample_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "wellsample_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "wellsample_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.WellSample.annotationLinks (ome.model.annotations.WellSampleAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.WellSampleAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.WellSampleAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.WellSampleAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view 
     */
    public java.util.Collection<ome.model.annotations.WellSampleAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }
    
    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.WellSampleAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.WellSampleAnnotationLink as well.
     */
    public void addWellSampleAnnotationLink(ome.model.annotations.WellSampleAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addWellSampleAnnotationLink.
     */
    public void addWellSampleAnnotationLinkSet(java.util.Collection<ome.model.annotations.WellSampleAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.WellSampleAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.WellSampleAnnotationLink
     */
    public void removeWellSampleAnnotationLink(ome.model.annotations.WellSampleAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeWellSampleAnnotationLink
     */
    public void removeWellSampleAnnotationLinkSet(java.util.Collection<ome.model.annotations.WellSampleAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.WellSampleAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.WellSampleAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.WellSampleAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.WellSampleAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.WellSampleAnnotationLink link = new ome.model.annotations.WellSampleAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addWellSampleAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.WellSampleAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addWellSampleAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addWellSampleAnnotationLink (ome.model.annotations.WellSampleAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modificiations to the underlying collection
     * while iterating will result in an {@link ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.WellSampleAnnotationLink link = (ome.model.annotations.WellSampleAnnotationLink) it.next();
                return link.child();
            }

            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.WellSampleAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.WellSampleAnnotationLink> findWellSampleAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.WellSampleAnnotationLink> result = new java.util.HashSet<ome.model.annotations.WellSampleAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.WellSampleAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /** 
     * produces a {@link List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link List},
     * modifications can be made to the underlying collection without throwing
     * {@link ConcurrentModificationExceptions}
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.WellSampleAnnotationLink> toRemove = findWellSampleAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.WellSampleAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeWellSampleAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given WellSampleAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkWellSample again <b>if loaded</b>.
     */
    public void removeWellSampleAnnotationLink (ome.model.annotations.WellSampleAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.WellSampleAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.WellSampleAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.WellSampleAnnotationLink link : list) {
            removeWellSampleAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_WellSample_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.WellSampleAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_WellSample_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_WellSample_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="WellSample_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed 
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclasse of 
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link Details\#copy(Details)} or {@link Details\#shallowCopy(Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }
  
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.screen.WellSample newInstance() 
    {
        return new ome.model.screen.WellSample();
    }

    public ome.model.screen.WellSample proxy() {
        return new ome.model.screen.WellSample(this.id, false);
    }

    @SuppressWarnings("unchecked")
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.posX = (java.lang.Double) __filter.filter(POSX, this.posX );
            this.posY = (java.lang.Double) __filter.filter(POSY, this.posY );
            this.timepoint = (java.sql.Timestamp) __filter.filter(TIMEPOINT, this.timepoint );
            this.plateAcquisition = (ome.model.screen.PlateAcquisition) __filter.filter(PLATEACQUISITION, this.plateAcquisition );
            this.well = (ome.model.screen.Well) __filter.filter(WELL, this.well );
            this.image = (ome.model.core.Image) __filter.filter(IMAGE, this.image );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.WellSampleAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString(){
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }
  
    // FIELD-FIELDS
  
    public java.util.Set<String> fields() {
        return ome.model.screen.WellSample.FIELDS;
    }
  
    public final static String POSX = "ome.model.screen.WellSample_posX";
    public final static String POSY = "ome.model.screen.WellSample_posY";
    public final static String TIMEPOINT = "ome.model.screen.WellSample_timepoint";
    public final static String PLATEACQUISITION = "ome.model.screen.WellSample_plateAcquisition";
    public final static String WELL = "ome.model.screen.WellSample_well";
    public final static String IMAGE = "ome.model.screen.WellSample_image";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.screen.WellSample_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.screen.WellSample_annotationLinks";
    public final static String DETAILS = "ome.model.screen.WellSample_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(POSX);
       raw.add(POSY);
       raw.add(TIMEPOINT);
       raw.add(PLATEACQUISITION);
       raw.add(WELL);
       raw.add(IMAGE);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }
    
    
    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields; 

    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(POSX)) { // TODO use == here first??
            return getPosX();
        } else if (field.equals(POSY)) { // TODO use == here first??
            return getPosY();
        } else if (field.equals(TIMEPOINT)) { // TODO use == here first??
            return getTimepoint();
        } else if (field.equals(PLATEACQUISITION)) { // TODO use == here first??
            return getPlateAcquisition();
        } else if (field.equals(WELL)) { // TODO use == here first??
            return getWell();
        } else if (field.equals(IMAGE)) { // TODO use == here first??
            return getImage();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) { // TODO use == here first??
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) { // TODO use == here first??
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }
    
    @SuppressWarnings("unchecked")
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(POSX)) {
            setPosX((java.lang.Double)value);
        } else if (field.equals(POSY)) {
            setPosY((java.lang.Double)value);
        } else if (field.equals(TIMEPOINT)) {
            setTimepoint((java.sql.Timestamp)value);
        } else if (field.equals(PLATEACQUISITION)) {
            setPlateAcquisition((ome.model.screen.PlateAcquisition)value);
        } else if (field.equals(WELL)) {
            setWell((ome.model.screen.Well)value);
        } else if (field.equals(IMAGE)) {
            setImage((ome.model.core.Image)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.WellSampleAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    public void unload() {
        _loaded = false;
        this.version = null;
        this.posX = null;
        this.posY = null;
        this.timepoint = null;
        this.plateAcquisition = null;
        this.well = null;
        this.image = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }


    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKwellsample_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwellsample_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKwellsample_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwellsample_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKwellsample_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
